# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from . import _utilities
from . import outputs
from ._inputs import *

__all__ = ['ApigCustomAuthorizerArgs', 'ApigCustomAuthorizer']

@pulumi.input_type
class ApigCustomAuthorizerArgs:
    def __init__(__self__, *,
                 function_urn: pulumi.Input[builtins.str],
                 instance_id: pulumi.Input[builtins.str],
                 cache_age: Optional[pulumi.Input[builtins.int]] = None,
                 function_alias_uri: Optional[pulumi.Input[builtins.str]] = None,
                 function_version: Optional[pulumi.Input[builtins.str]] = None,
                 identities: Optional[pulumi.Input[Sequence[pulumi.Input['ApigCustomAuthorizerIdentityArgs']]]] = None,
                 is_body_send: Optional[pulumi.Input[builtins.bool]] = None,
                 name: Optional[pulumi.Input[builtins.str]] = None,
                 network_type: Optional[pulumi.Input[builtins.str]] = None,
                 region: Optional[pulumi.Input[builtins.str]] = None,
                 type: Optional[pulumi.Input[builtins.str]] = None,
                 user_data: Optional[pulumi.Input[builtins.str]] = None):
        """
        The set of arguments for constructing a ApigCustomAuthorizer resource.
        :param pulumi.Input[builtins.str] function_urn: The URN of the FGS function.
        :param pulumi.Input[builtins.str] instance_id: The ID of the dedicated instance to which the custom authorizer belongs.
        :param pulumi.Input[builtins.int] cache_age: The maximum cache age.
        :param pulumi.Input[builtins.str] function_alias_uri: The version alias URI of the FGS function.
        :param pulumi.Input[builtins.str] function_version: The version of the FGS function.
        :param pulumi.Input[Sequence[pulumi.Input['ApigCustomAuthorizerIdentityArgs']]] identities: The array of one or more parameter identities of the custom authorizer.
        :param pulumi.Input[builtins.bool] is_body_send: Whether to send the body.
        :param pulumi.Input[builtins.str] name: The name of the custom authorizer.
        :param pulumi.Input[builtins.str] network_type: The framework type of the function.
        :param pulumi.Input[builtins.str] region: The region where the custom authorizer is located.
        :param pulumi.Input[builtins.str] type: The custom authorization type
        :param pulumi.Input[builtins.str] user_data: The user data for custom authorizer function.
        """
        pulumi.set(__self__, "function_urn", function_urn)
        pulumi.set(__self__, "instance_id", instance_id)
        if cache_age is not None:
            pulumi.set(__self__, "cache_age", cache_age)
        if function_alias_uri is not None:
            pulumi.set(__self__, "function_alias_uri", function_alias_uri)
        if function_version is not None:
            pulumi.set(__self__, "function_version", function_version)
        if identities is not None:
            pulumi.set(__self__, "identities", identities)
        if is_body_send is not None:
            pulumi.set(__self__, "is_body_send", is_body_send)
        if name is not None:
            pulumi.set(__self__, "name", name)
        if network_type is not None:
            pulumi.set(__self__, "network_type", network_type)
        if region is not None:
            pulumi.set(__self__, "region", region)
        if type is not None:
            pulumi.set(__self__, "type", type)
        if user_data is not None:
            pulumi.set(__self__, "user_data", user_data)

    @property
    @pulumi.getter(name="functionUrn")
    def function_urn(self) -> pulumi.Input[builtins.str]:
        """
        The URN of the FGS function.
        """
        return pulumi.get(self, "function_urn")

    @function_urn.setter
    def function_urn(self, value: pulumi.Input[builtins.str]):
        pulumi.set(self, "function_urn", value)

    @property
    @pulumi.getter(name="instanceId")
    def instance_id(self) -> pulumi.Input[builtins.str]:
        """
        The ID of the dedicated instance to which the custom authorizer belongs.
        """
        return pulumi.get(self, "instance_id")

    @instance_id.setter
    def instance_id(self, value: pulumi.Input[builtins.str]):
        pulumi.set(self, "instance_id", value)

    @property
    @pulumi.getter(name="cacheAge")
    def cache_age(self) -> Optional[pulumi.Input[builtins.int]]:
        """
        The maximum cache age.
        """
        return pulumi.get(self, "cache_age")

    @cache_age.setter
    def cache_age(self, value: Optional[pulumi.Input[builtins.int]]):
        pulumi.set(self, "cache_age", value)

    @property
    @pulumi.getter(name="functionAliasUri")
    def function_alias_uri(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The version alias URI of the FGS function.
        """
        return pulumi.get(self, "function_alias_uri")

    @function_alias_uri.setter
    def function_alias_uri(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "function_alias_uri", value)

    @property
    @pulumi.getter(name="functionVersion")
    def function_version(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The version of the FGS function.
        """
        return pulumi.get(self, "function_version")

    @function_version.setter
    def function_version(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "function_version", value)

    @property
    @pulumi.getter
    def identities(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['ApigCustomAuthorizerIdentityArgs']]]]:
        """
        The array of one or more parameter identities of the custom authorizer.
        """
        return pulumi.get(self, "identities")

    @identities.setter
    def identities(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['ApigCustomAuthorizerIdentityArgs']]]]):
        pulumi.set(self, "identities", value)

    @property
    @pulumi.getter(name="isBodySend")
    def is_body_send(self) -> Optional[pulumi.Input[builtins.bool]]:
        """
        Whether to send the body.
        """
        return pulumi.get(self, "is_body_send")

    @is_body_send.setter
    def is_body_send(self, value: Optional[pulumi.Input[builtins.bool]]):
        pulumi.set(self, "is_body_send", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The name of the custom authorizer.
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter(name="networkType")
    def network_type(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The framework type of the function.
        """
        return pulumi.get(self, "network_type")

    @network_type.setter
    def network_type(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "network_type", value)

    @property
    @pulumi.getter
    def region(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The region where the custom authorizer is located.
        """
        return pulumi.get(self, "region")

    @region.setter
    def region(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "region", value)

    @property
    @pulumi.getter
    def type(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The custom authorization type
        """
        return pulumi.get(self, "type")

    @type.setter
    def type(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "type", value)

    @property
    @pulumi.getter(name="userData")
    def user_data(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The user data for custom authorizer function.
        """
        return pulumi.get(self, "user_data")

    @user_data.setter
    def user_data(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "user_data", value)


@pulumi.input_type
class _ApigCustomAuthorizerState:
    def __init__(__self__, *,
                 cache_age: Optional[pulumi.Input[builtins.int]] = None,
                 created_at: Optional[pulumi.Input[builtins.str]] = None,
                 function_alias_uri: Optional[pulumi.Input[builtins.str]] = None,
                 function_urn: Optional[pulumi.Input[builtins.str]] = None,
                 function_version: Optional[pulumi.Input[builtins.str]] = None,
                 identities: Optional[pulumi.Input[Sequence[pulumi.Input['ApigCustomAuthorizerIdentityArgs']]]] = None,
                 instance_id: Optional[pulumi.Input[builtins.str]] = None,
                 is_body_send: Optional[pulumi.Input[builtins.bool]] = None,
                 name: Optional[pulumi.Input[builtins.str]] = None,
                 network_type: Optional[pulumi.Input[builtins.str]] = None,
                 region: Optional[pulumi.Input[builtins.str]] = None,
                 type: Optional[pulumi.Input[builtins.str]] = None,
                 user_data: Optional[pulumi.Input[builtins.str]] = None):
        """
        Input properties used for looking up and filtering ApigCustomAuthorizer resources.
        :param pulumi.Input[builtins.int] cache_age: The maximum cache age.
        :param pulumi.Input[builtins.str] created_at: The creation time of the custom authorizer.
        :param pulumi.Input[builtins.str] function_alias_uri: The version alias URI of the FGS function.
        :param pulumi.Input[builtins.str] function_urn: The URN of the FGS function.
        :param pulumi.Input[builtins.str] function_version: The version of the FGS function.
        :param pulumi.Input[Sequence[pulumi.Input['ApigCustomAuthorizerIdentityArgs']]] identities: The array of one or more parameter identities of the custom authorizer.
        :param pulumi.Input[builtins.str] instance_id: The ID of the dedicated instance to which the custom authorizer belongs.
        :param pulumi.Input[builtins.bool] is_body_send: Whether to send the body.
        :param pulumi.Input[builtins.str] name: The name of the custom authorizer.
        :param pulumi.Input[builtins.str] network_type: The framework type of the function.
        :param pulumi.Input[builtins.str] region: The region where the custom authorizer is located.
        :param pulumi.Input[builtins.str] type: The custom authorization type
        :param pulumi.Input[builtins.str] user_data: The user data for custom authorizer function.
        """
        if cache_age is not None:
            pulumi.set(__self__, "cache_age", cache_age)
        if created_at is not None:
            pulumi.set(__self__, "created_at", created_at)
        if function_alias_uri is not None:
            pulumi.set(__self__, "function_alias_uri", function_alias_uri)
        if function_urn is not None:
            pulumi.set(__self__, "function_urn", function_urn)
        if function_version is not None:
            pulumi.set(__self__, "function_version", function_version)
        if identities is not None:
            pulumi.set(__self__, "identities", identities)
        if instance_id is not None:
            pulumi.set(__self__, "instance_id", instance_id)
        if is_body_send is not None:
            pulumi.set(__self__, "is_body_send", is_body_send)
        if name is not None:
            pulumi.set(__self__, "name", name)
        if network_type is not None:
            pulumi.set(__self__, "network_type", network_type)
        if region is not None:
            pulumi.set(__self__, "region", region)
        if type is not None:
            pulumi.set(__self__, "type", type)
        if user_data is not None:
            pulumi.set(__self__, "user_data", user_data)

    @property
    @pulumi.getter(name="cacheAge")
    def cache_age(self) -> Optional[pulumi.Input[builtins.int]]:
        """
        The maximum cache age.
        """
        return pulumi.get(self, "cache_age")

    @cache_age.setter
    def cache_age(self, value: Optional[pulumi.Input[builtins.int]]):
        pulumi.set(self, "cache_age", value)

    @property
    @pulumi.getter(name="createdAt")
    def created_at(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The creation time of the custom authorizer.
        """
        return pulumi.get(self, "created_at")

    @created_at.setter
    def created_at(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "created_at", value)

    @property
    @pulumi.getter(name="functionAliasUri")
    def function_alias_uri(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The version alias URI of the FGS function.
        """
        return pulumi.get(self, "function_alias_uri")

    @function_alias_uri.setter
    def function_alias_uri(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "function_alias_uri", value)

    @property
    @pulumi.getter(name="functionUrn")
    def function_urn(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The URN of the FGS function.
        """
        return pulumi.get(self, "function_urn")

    @function_urn.setter
    def function_urn(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "function_urn", value)

    @property
    @pulumi.getter(name="functionVersion")
    def function_version(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The version of the FGS function.
        """
        return pulumi.get(self, "function_version")

    @function_version.setter
    def function_version(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "function_version", value)

    @property
    @pulumi.getter
    def identities(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['ApigCustomAuthorizerIdentityArgs']]]]:
        """
        The array of one or more parameter identities of the custom authorizer.
        """
        return pulumi.get(self, "identities")

    @identities.setter
    def identities(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['ApigCustomAuthorizerIdentityArgs']]]]):
        pulumi.set(self, "identities", value)

    @property
    @pulumi.getter(name="instanceId")
    def instance_id(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The ID of the dedicated instance to which the custom authorizer belongs.
        """
        return pulumi.get(self, "instance_id")

    @instance_id.setter
    def instance_id(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "instance_id", value)

    @property
    @pulumi.getter(name="isBodySend")
    def is_body_send(self) -> Optional[pulumi.Input[builtins.bool]]:
        """
        Whether to send the body.
        """
        return pulumi.get(self, "is_body_send")

    @is_body_send.setter
    def is_body_send(self, value: Optional[pulumi.Input[builtins.bool]]):
        pulumi.set(self, "is_body_send", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The name of the custom authorizer.
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter(name="networkType")
    def network_type(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The framework type of the function.
        """
        return pulumi.get(self, "network_type")

    @network_type.setter
    def network_type(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "network_type", value)

    @property
    @pulumi.getter
    def region(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The region where the custom authorizer is located.
        """
        return pulumi.get(self, "region")

    @region.setter
    def region(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "region", value)

    @property
    @pulumi.getter
    def type(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The custom authorization type
        """
        return pulumi.get(self, "type")

    @type.setter
    def type(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "type", value)

    @property
    @pulumi.getter(name="userData")
    def user_data(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The user data for custom authorizer function.
        """
        return pulumi.get(self, "user_data")

    @user_data.setter
    def user_data(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "user_data", value)


class ApigCustomAuthorizer(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 cache_age: Optional[pulumi.Input[builtins.int]] = None,
                 function_alias_uri: Optional[pulumi.Input[builtins.str]] = None,
                 function_urn: Optional[pulumi.Input[builtins.str]] = None,
                 function_version: Optional[pulumi.Input[builtins.str]] = None,
                 identities: Optional[pulumi.Input[Sequence[pulumi.Input[Union['ApigCustomAuthorizerIdentityArgs', 'ApigCustomAuthorizerIdentityArgsDict']]]]] = None,
                 instance_id: Optional[pulumi.Input[builtins.str]] = None,
                 is_body_send: Optional[pulumi.Input[builtins.bool]] = None,
                 name: Optional[pulumi.Input[builtins.str]] = None,
                 network_type: Optional[pulumi.Input[builtins.str]] = None,
                 region: Optional[pulumi.Input[builtins.str]] = None,
                 type: Optional[pulumi.Input[builtins.str]] = None,
                 user_data: Optional[pulumi.Input[builtins.str]] = None,
                 __props__=None):
        """
        Create a ApigCustomAuthorizer resource with the given unique name, props, and options.
        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[builtins.int] cache_age: The maximum cache age.
        :param pulumi.Input[builtins.str] function_alias_uri: The version alias URI of the FGS function.
        :param pulumi.Input[builtins.str] function_urn: The URN of the FGS function.
        :param pulumi.Input[builtins.str] function_version: The version of the FGS function.
        :param pulumi.Input[Sequence[pulumi.Input[Union['ApigCustomAuthorizerIdentityArgs', 'ApigCustomAuthorizerIdentityArgsDict']]]] identities: The array of one or more parameter identities of the custom authorizer.
        :param pulumi.Input[builtins.str] instance_id: The ID of the dedicated instance to which the custom authorizer belongs.
        :param pulumi.Input[builtins.bool] is_body_send: Whether to send the body.
        :param pulumi.Input[builtins.str] name: The name of the custom authorizer.
        :param pulumi.Input[builtins.str] network_type: The framework type of the function.
        :param pulumi.Input[builtins.str] region: The region where the custom authorizer is located.
        :param pulumi.Input[builtins.str] type: The custom authorization type
        :param pulumi.Input[builtins.str] user_data: The user data for custom authorizer function.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: ApigCustomAuthorizerArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Create a ApigCustomAuthorizer resource with the given unique name, props, and options.
        :param str resource_name: The name of the resource.
        :param ApigCustomAuthorizerArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(ApigCustomAuthorizerArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 cache_age: Optional[pulumi.Input[builtins.int]] = None,
                 function_alias_uri: Optional[pulumi.Input[builtins.str]] = None,
                 function_urn: Optional[pulumi.Input[builtins.str]] = None,
                 function_version: Optional[pulumi.Input[builtins.str]] = None,
                 identities: Optional[pulumi.Input[Sequence[pulumi.Input[Union['ApigCustomAuthorizerIdentityArgs', 'ApigCustomAuthorizerIdentityArgsDict']]]]] = None,
                 instance_id: Optional[pulumi.Input[builtins.str]] = None,
                 is_body_send: Optional[pulumi.Input[builtins.bool]] = None,
                 name: Optional[pulumi.Input[builtins.str]] = None,
                 network_type: Optional[pulumi.Input[builtins.str]] = None,
                 region: Optional[pulumi.Input[builtins.str]] = None,
                 type: Optional[pulumi.Input[builtins.str]] = None,
                 user_data: Optional[pulumi.Input[builtins.str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = ApigCustomAuthorizerArgs.__new__(ApigCustomAuthorizerArgs)

            __props__.__dict__["cache_age"] = cache_age
            __props__.__dict__["function_alias_uri"] = function_alias_uri
            if function_urn is None and not opts.urn:
                raise TypeError("Missing required property 'function_urn'")
            __props__.__dict__["function_urn"] = function_urn
            __props__.__dict__["function_version"] = function_version
            __props__.__dict__["identities"] = identities
            if instance_id is None and not opts.urn:
                raise TypeError("Missing required property 'instance_id'")
            __props__.__dict__["instance_id"] = instance_id
            __props__.__dict__["is_body_send"] = is_body_send
            __props__.__dict__["name"] = name
            __props__.__dict__["network_type"] = network_type
            __props__.__dict__["region"] = region
            __props__.__dict__["type"] = type
            __props__.__dict__["user_data"] = user_data
            __props__.__dict__["created_at"] = None
        super(ApigCustomAuthorizer, __self__).__init__(
            'sbercloud:index/apigCustomAuthorizer:ApigCustomAuthorizer',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            cache_age: Optional[pulumi.Input[builtins.int]] = None,
            created_at: Optional[pulumi.Input[builtins.str]] = None,
            function_alias_uri: Optional[pulumi.Input[builtins.str]] = None,
            function_urn: Optional[pulumi.Input[builtins.str]] = None,
            function_version: Optional[pulumi.Input[builtins.str]] = None,
            identities: Optional[pulumi.Input[Sequence[pulumi.Input[Union['ApigCustomAuthorizerIdentityArgs', 'ApigCustomAuthorizerIdentityArgsDict']]]]] = None,
            instance_id: Optional[pulumi.Input[builtins.str]] = None,
            is_body_send: Optional[pulumi.Input[builtins.bool]] = None,
            name: Optional[pulumi.Input[builtins.str]] = None,
            network_type: Optional[pulumi.Input[builtins.str]] = None,
            region: Optional[pulumi.Input[builtins.str]] = None,
            type: Optional[pulumi.Input[builtins.str]] = None,
            user_data: Optional[pulumi.Input[builtins.str]] = None) -> 'ApigCustomAuthorizer':
        """
        Get an existing ApigCustomAuthorizer resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[builtins.int] cache_age: The maximum cache age.
        :param pulumi.Input[builtins.str] created_at: The creation time of the custom authorizer.
        :param pulumi.Input[builtins.str] function_alias_uri: The version alias URI of the FGS function.
        :param pulumi.Input[builtins.str] function_urn: The URN of the FGS function.
        :param pulumi.Input[builtins.str] function_version: The version of the FGS function.
        :param pulumi.Input[Sequence[pulumi.Input[Union['ApigCustomAuthorizerIdentityArgs', 'ApigCustomAuthorizerIdentityArgsDict']]]] identities: The array of one or more parameter identities of the custom authorizer.
        :param pulumi.Input[builtins.str] instance_id: The ID of the dedicated instance to which the custom authorizer belongs.
        :param pulumi.Input[builtins.bool] is_body_send: Whether to send the body.
        :param pulumi.Input[builtins.str] name: The name of the custom authorizer.
        :param pulumi.Input[builtins.str] network_type: The framework type of the function.
        :param pulumi.Input[builtins.str] region: The region where the custom authorizer is located.
        :param pulumi.Input[builtins.str] type: The custom authorization type
        :param pulumi.Input[builtins.str] user_data: The user data for custom authorizer function.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _ApigCustomAuthorizerState.__new__(_ApigCustomAuthorizerState)

        __props__.__dict__["cache_age"] = cache_age
        __props__.__dict__["created_at"] = created_at
        __props__.__dict__["function_alias_uri"] = function_alias_uri
        __props__.__dict__["function_urn"] = function_urn
        __props__.__dict__["function_version"] = function_version
        __props__.__dict__["identities"] = identities
        __props__.__dict__["instance_id"] = instance_id
        __props__.__dict__["is_body_send"] = is_body_send
        __props__.__dict__["name"] = name
        __props__.__dict__["network_type"] = network_type
        __props__.__dict__["region"] = region
        __props__.__dict__["type"] = type
        __props__.__dict__["user_data"] = user_data
        return ApigCustomAuthorizer(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="cacheAge")
    def cache_age(self) -> pulumi.Output[Optional[builtins.int]]:
        """
        The maximum cache age.
        """
        return pulumi.get(self, "cache_age")

    @property
    @pulumi.getter(name="createdAt")
    def created_at(self) -> pulumi.Output[builtins.str]:
        """
        The creation time of the custom authorizer.
        """
        return pulumi.get(self, "created_at")

    @property
    @pulumi.getter(name="functionAliasUri")
    def function_alias_uri(self) -> pulumi.Output[builtins.str]:
        """
        The version alias URI of the FGS function.
        """
        return pulumi.get(self, "function_alias_uri")

    @property
    @pulumi.getter(name="functionUrn")
    def function_urn(self) -> pulumi.Output[builtins.str]:
        """
        The URN of the FGS function.
        """
        return pulumi.get(self, "function_urn")

    @property
    @pulumi.getter(name="functionVersion")
    def function_version(self) -> pulumi.Output[builtins.str]:
        """
        The version of the FGS function.
        """
        return pulumi.get(self, "function_version")

    @property
    @pulumi.getter
    def identities(self) -> pulumi.Output[Optional[Sequence['outputs.ApigCustomAuthorizerIdentity']]]:
        """
        The array of one or more parameter identities of the custom authorizer.
        """
        return pulumi.get(self, "identities")

    @property
    @pulumi.getter(name="instanceId")
    def instance_id(self) -> pulumi.Output[builtins.str]:
        """
        The ID of the dedicated instance to which the custom authorizer belongs.
        """
        return pulumi.get(self, "instance_id")

    @property
    @pulumi.getter(name="isBodySend")
    def is_body_send(self) -> pulumi.Output[Optional[builtins.bool]]:
        """
        Whether to send the body.
        """
        return pulumi.get(self, "is_body_send")

    @property
    @pulumi.getter
    def name(self) -> pulumi.Output[builtins.str]:
        """
        The name of the custom authorizer.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="networkType")
    def network_type(self) -> pulumi.Output[builtins.str]:
        """
        The framework type of the function.
        """
        return pulumi.get(self, "network_type")

    @property
    @pulumi.getter
    def region(self) -> pulumi.Output[builtins.str]:
        """
        The region where the custom authorizer is located.
        """
        return pulumi.get(self, "region")

    @property
    @pulumi.getter
    def type(self) -> pulumi.Output[Optional[builtins.str]]:
        """
        The custom authorization type
        """
        return pulumi.get(self, "type")

    @property
    @pulumi.getter(name="userData")
    def user_data(self) -> pulumi.Output[Optional[builtins.str]]:
        """
        The user data for custom authorizer function.
        """
        return pulumi.get(self, "user_data")

