# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from . import _utilities

__all__ = ['ApigInstanceRoutesArgs', 'ApigInstanceRoutes']

@pulumi.input_type
class ApigInstanceRoutesArgs:
    def __init__(__self__, *,
                 instance_id: pulumi.Input[builtins.str],
                 nexthops: pulumi.Input[Sequence[pulumi.Input[builtins.str]]],
                 region: Optional[pulumi.Input[builtins.str]] = None):
        """
        The set of arguments for constructing a ApigInstanceRoutes resource.
        :param pulumi.Input[builtins.str] instance_id: The ID of the dedicated instance to which the routes belong.
        :param pulumi.Input[Sequence[pulumi.Input[builtins.str]]] nexthops: The configuration of the next hop routes.
        :param pulumi.Input[builtins.str] region: The region where the dedicated instance and routes are located.
        """
        pulumi.set(__self__, "instance_id", instance_id)
        pulumi.set(__self__, "nexthops", nexthops)
        if region is not None:
            pulumi.set(__self__, "region", region)

    @property
    @pulumi.getter(name="instanceId")
    def instance_id(self) -> pulumi.Input[builtins.str]:
        """
        The ID of the dedicated instance to which the routes belong.
        """
        return pulumi.get(self, "instance_id")

    @instance_id.setter
    def instance_id(self, value: pulumi.Input[builtins.str]):
        pulumi.set(self, "instance_id", value)

    @property
    @pulumi.getter
    def nexthops(self) -> pulumi.Input[Sequence[pulumi.Input[builtins.str]]]:
        """
        The configuration of the next hop routes.
        """
        return pulumi.get(self, "nexthops")

    @nexthops.setter
    def nexthops(self, value: pulumi.Input[Sequence[pulumi.Input[builtins.str]]]):
        pulumi.set(self, "nexthops", value)

    @property
    @pulumi.getter
    def region(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The region where the dedicated instance and routes are located.
        """
        return pulumi.get(self, "region")

    @region.setter
    def region(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "region", value)


@pulumi.input_type
class _ApigInstanceRoutesState:
    def __init__(__self__, *,
                 instance_id: Optional[pulumi.Input[builtins.str]] = None,
                 nexthops: Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]] = None,
                 region: Optional[pulumi.Input[builtins.str]] = None):
        """
        Input properties used for looking up and filtering ApigInstanceRoutes resources.
        :param pulumi.Input[builtins.str] instance_id: The ID of the dedicated instance to which the routes belong.
        :param pulumi.Input[Sequence[pulumi.Input[builtins.str]]] nexthops: The configuration of the next hop routes.
        :param pulumi.Input[builtins.str] region: The region where the dedicated instance and routes are located.
        """
        if instance_id is not None:
            pulumi.set(__self__, "instance_id", instance_id)
        if nexthops is not None:
            pulumi.set(__self__, "nexthops", nexthops)
        if region is not None:
            pulumi.set(__self__, "region", region)

    @property
    @pulumi.getter(name="instanceId")
    def instance_id(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The ID of the dedicated instance to which the routes belong.
        """
        return pulumi.get(self, "instance_id")

    @instance_id.setter
    def instance_id(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "instance_id", value)

    @property
    @pulumi.getter
    def nexthops(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]]:
        """
        The configuration of the next hop routes.
        """
        return pulumi.get(self, "nexthops")

    @nexthops.setter
    def nexthops(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]]):
        pulumi.set(self, "nexthops", value)

    @property
    @pulumi.getter
    def region(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The region where the dedicated instance and routes are located.
        """
        return pulumi.get(self, "region")

    @region.setter
    def region(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "region", value)


class ApigInstanceRoutes(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 instance_id: Optional[pulumi.Input[builtins.str]] = None,
                 nexthops: Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]] = None,
                 region: Optional[pulumi.Input[builtins.str]] = None,
                 __props__=None):
        """
        Create a ApigInstanceRoutes resource with the given unique name, props, and options.
        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[builtins.str] instance_id: The ID of the dedicated instance to which the routes belong.
        :param pulumi.Input[Sequence[pulumi.Input[builtins.str]]] nexthops: The configuration of the next hop routes.
        :param pulumi.Input[builtins.str] region: The region where the dedicated instance and routes are located.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: ApigInstanceRoutesArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Create a ApigInstanceRoutes resource with the given unique name, props, and options.
        :param str resource_name: The name of the resource.
        :param ApigInstanceRoutesArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(ApigInstanceRoutesArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 instance_id: Optional[pulumi.Input[builtins.str]] = None,
                 nexthops: Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]] = None,
                 region: Optional[pulumi.Input[builtins.str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = ApigInstanceRoutesArgs.__new__(ApigInstanceRoutesArgs)

            if instance_id is None and not opts.urn:
                raise TypeError("Missing required property 'instance_id'")
            __props__.__dict__["instance_id"] = instance_id
            if nexthops is None and not opts.urn:
                raise TypeError("Missing required property 'nexthops'")
            __props__.__dict__["nexthops"] = nexthops
            __props__.__dict__["region"] = region
        super(ApigInstanceRoutes, __self__).__init__(
            'sbercloud:index/apigInstanceRoutes:ApigInstanceRoutes',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            instance_id: Optional[pulumi.Input[builtins.str]] = None,
            nexthops: Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]] = None,
            region: Optional[pulumi.Input[builtins.str]] = None) -> 'ApigInstanceRoutes':
        """
        Get an existing ApigInstanceRoutes resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[builtins.str] instance_id: The ID of the dedicated instance to which the routes belong.
        :param pulumi.Input[Sequence[pulumi.Input[builtins.str]]] nexthops: The configuration of the next hop routes.
        :param pulumi.Input[builtins.str] region: The region where the dedicated instance and routes are located.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _ApigInstanceRoutesState.__new__(_ApigInstanceRoutesState)

        __props__.__dict__["instance_id"] = instance_id
        __props__.__dict__["nexthops"] = nexthops
        __props__.__dict__["region"] = region
        return ApigInstanceRoutes(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="instanceId")
    def instance_id(self) -> pulumi.Output[builtins.str]:
        """
        The ID of the dedicated instance to which the routes belong.
        """
        return pulumi.get(self, "instance_id")

    @property
    @pulumi.getter
    def nexthops(self) -> pulumi.Output[Sequence[builtins.str]]:
        """
        The configuration of the next hop routes.
        """
        return pulumi.get(self, "nexthops")

    @property
    @pulumi.getter
    def region(self) -> pulumi.Output[builtins.str]:
        """
        The region where the dedicated instance and routes are located.
        """
        return pulumi.get(self, "region")

