# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from . import _utilities
from . import outputs
from ._inputs import *

__all__ = ['CbrVaultArgs', 'CbrVault']

@pulumi.input_type
class CbrVaultArgs:
    def __init__(__self__, *,
                 protection_type: pulumi.Input[builtins.str],
                 size: pulumi.Input[builtins.int],
                 type: pulumi.Input[builtins.str],
                 auto_bind: Optional[pulumi.Input[builtins.bool]] = None,
                 auto_expand: Optional[pulumi.Input[builtins.bool]] = None,
                 auto_pay: Optional[pulumi.Input[builtins.str]] = None,
                 auto_renew: Optional[pulumi.Input[builtins.str]] = None,
                 backup_name_prefix: Optional[pulumi.Input[builtins.str]] = None,
                 bind_rules: Optional[pulumi.Input[Mapping[str, pulumi.Input[builtins.str]]]] = None,
                 charging_mode: Optional[pulumi.Input[builtins.str]] = None,
                 cloud_type: Optional[pulumi.Input[builtins.str]] = None,
                 consistent_level: Optional[pulumi.Input[builtins.str]] = None,
                 enterprise_project_id: Optional[pulumi.Input[builtins.str]] = None,
                 is_multi_az: Optional[pulumi.Input[builtins.bool]] = None,
                 name: Optional[pulumi.Input[builtins.str]] = None,
                 period: Optional[pulumi.Input[builtins.int]] = None,
                 period_unit: Optional[pulumi.Input[builtins.str]] = None,
                 policies: Optional[pulumi.Input[Sequence[pulumi.Input['CbrVaultPolicyArgs']]]] = None,
                 policy_id: Optional[pulumi.Input[builtins.str]] = None,
                 region: Optional[pulumi.Input[builtins.str]] = None,
                 resources: Optional[pulumi.Input[Sequence[pulumi.Input['CbrVaultResourceArgs']]]] = None,
                 tags: Optional[pulumi.Input[Mapping[str, pulumi.Input[builtins.str]]]] = None):
        """
        The set of arguments for constructing a CbrVault resource.
        :param pulumi.Input[builtins.str] protection_type: The protection type of the vault.
        :param pulumi.Input[builtins.int] size: The capacity of the vault, in GB.
        :param pulumi.Input[builtins.str] type: The type of the vault.
        :param pulumi.Input[builtins.bool] auto_bind: Whether automatic association is supported.
        :param pulumi.Input[builtins.bool] auto_expand: Whether to enable auto capacity expansion for the vault.
        :param pulumi.Input[builtins.str] backup_name_prefix: The backup name prefix.
        :param pulumi.Input[Mapping[str, pulumi.Input[builtins.str]]] bind_rules: The rules for automatic association.
        :param pulumi.Input[builtins.str] cloud_type: The cloud type of the vault.
        :param pulumi.Input[builtins.str] consistent_level: The consistent level (specification) of the vault.
        :param pulumi.Input[builtins.str] enterprise_project_id: The enterprise project ID to which the vault belongs.
        :param pulumi.Input[builtins.bool] is_multi_az: Whether multiple availability zones are used for backing up.
        :param pulumi.Input[builtins.str] name: The name of the vault.
        :param pulumi.Input[Sequence[pulumi.Input['CbrVaultPolicyArgs']]] policies: The policy details to associate with the CBR vault.
        :param pulumi.Input[builtins.str] policy_id: schema:Deprecated; Using parameter 'policy' instead.
        :param pulumi.Input[builtins.str] region: The region where the vault is located.
        :param pulumi.Input[Sequence[pulumi.Input['CbrVaultResourceArgs']]] resources: The array of one or more resources to attach to the CBR vault.
        """
        pulumi.set(__self__, "protection_type", protection_type)
        pulumi.set(__self__, "size", size)
        pulumi.set(__self__, "type", type)
        if auto_bind is not None:
            pulumi.set(__self__, "auto_bind", auto_bind)
        if auto_expand is not None:
            pulumi.set(__self__, "auto_expand", auto_expand)
        if auto_pay is not None:
            warnings.warn("""Deprecated""", DeprecationWarning)
            pulumi.log.warn("""auto_pay is deprecated: Deprecated""")
        if auto_pay is not None:
            pulumi.set(__self__, "auto_pay", auto_pay)
        if auto_renew is not None:
            pulumi.set(__self__, "auto_renew", auto_renew)
        if backup_name_prefix is not None:
            pulumi.set(__self__, "backup_name_prefix", backup_name_prefix)
        if bind_rules is not None:
            pulumi.set(__self__, "bind_rules", bind_rules)
        if charging_mode is not None:
            pulumi.set(__self__, "charging_mode", charging_mode)
        if cloud_type is not None:
            pulumi.set(__self__, "cloud_type", cloud_type)
        if consistent_level is not None:
            pulumi.set(__self__, "consistent_level", consistent_level)
        if enterprise_project_id is not None:
            pulumi.set(__self__, "enterprise_project_id", enterprise_project_id)
        if is_multi_az is not None:
            pulumi.set(__self__, "is_multi_az", is_multi_az)
        if name is not None:
            pulumi.set(__self__, "name", name)
        if period is not None:
            pulumi.set(__self__, "period", period)
        if period_unit is not None:
            pulumi.set(__self__, "period_unit", period_unit)
        if policies is not None:
            pulumi.set(__self__, "policies", policies)
        if policy_id is not None:
            pulumi.set(__self__, "policy_id", policy_id)
        if region is not None:
            pulumi.set(__self__, "region", region)
        if resources is not None:
            pulumi.set(__self__, "resources", resources)
        if tags is not None:
            pulumi.set(__self__, "tags", tags)

    @property
    @pulumi.getter(name="protectionType")
    def protection_type(self) -> pulumi.Input[builtins.str]:
        """
        The protection type of the vault.
        """
        return pulumi.get(self, "protection_type")

    @protection_type.setter
    def protection_type(self, value: pulumi.Input[builtins.str]):
        pulumi.set(self, "protection_type", value)

    @property
    @pulumi.getter
    def size(self) -> pulumi.Input[builtins.int]:
        """
        The capacity of the vault, in GB.
        """
        return pulumi.get(self, "size")

    @size.setter
    def size(self, value: pulumi.Input[builtins.int]):
        pulumi.set(self, "size", value)

    @property
    @pulumi.getter
    def type(self) -> pulumi.Input[builtins.str]:
        """
        The type of the vault.
        """
        return pulumi.get(self, "type")

    @type.setter
    def type(self, value: pulumi.Input[builtins.str]):
        pulumi.set(self, "type", value)

    @property
    @pulumi.getter(name="autoBind")
    def auto_bind(self) -> Optional[pulumi.Input[builtins.bool]]:
        """
        Whether automatic association is supported.
        """
        return pulumi.get(self, "auto_bind")

    @auto_bind.setter
    def auto_bind(self, value: Optional[pulumi.Input[builtins.bool]]):
        pulumi.set(self, "auto_bind", value)

    @property
    @pulumi.getter(name="autoExpand")
    def auto_expand(self) -> Optional[pulumi.Input[builtins.bool]]:
        """
        Whether to enable auto capacity expansion for the vault.
        """
        return pulumi.get(self, "auto_expand")

    @auto_expand.setter
    def auto_expand(self, value: Optional[pulumi.Input[builtins.bool]]):
        pulumi.set(self, "auto_expand", value)

    @property
    @pulumi.getter(name="autoPay")
    @_utilities.deprecated("""Deprecated""")
    def auto_pay(self) -> Optional[pulumi.Input[builtins.str]]:
        return pulumi.get(self, "auto_pay")

    @auto_pay.setter
    def auto_pay(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "auto_pay", value)

    @property
    @pulumi.getter(name="autoRenew")
    def auto_renew(self) -> Optional[pulumi.Input[builtins.str]]:
        return pulumi.get(self, "auto_renew")

    @auto_renew.setter
    def auto_renew(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "auto_renew", value)

    @property
    @pulumi.getter(name="backupNamePrefix")
    def backup_name_prefix(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The backup name prefix.
        """
        return pulumi.get(self, "backup_name_prefix")

    @backup_name_prefix.setter
    def backup_name_prefix(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "backup_name_prefix", value)

    @property
    @pulumi.getter(name="bindRules")
    def bind_rules(self) -> Optional[pulumi.Input[Mapping[str, pulumi.Input[builtins.str]]]]:
        """
        The rules for automatic association.
        """
        return pulumi.get(self, "bind_rules")

    @bind_rules.setter
    def bind_rules(self, value: Optional[pulumi.Input[Mapping[str, pulumi.Input[builtins.str]]]]):
        pulumi.set(self, "bind_rules", value)

    @property
    @pulumi.getter(name="chargingMode")
    def charging_mode(self) -> Optional[pulumi.Input[builtins.str]]:
        return pulumi.get(self, "charging_mode")

    @charging_mode.setter
    def charging_mode(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "charging_mode", value)

    @property
    @pulumi.getter(name="cloudType")
    def cloud_type(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The cloud type of the vault.
        """
        return pulumi.get(self, "cloud_type")

    @cloud_type.setter
    def cloud_type(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "cloud_type", value)

    @property
    @pulumi.getter(name="consistentLevel")
    def consistent_level(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The consistent level (specification) of the vault.
        """
        return pulumi.get(self, "consistent_level")

    @consistent_level.setter
    def consistent_level(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "consistent_level", value)

    @property
    @pulumi.getter(name="enterpriseProjectId")
    def enterprise_project_id(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The enterprise project ID to which the vault belongs.
        """
        return pulumi.get(self, "enterprise_project_id")

    @enterprise_project_id.setter
    def enterprise_project_id(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "enterprise_project_id", value)

    @property
    @pulumi.getter(name="isMultiAz")
    def is_multi_az(self) -> Optional[pulumi.Input[builtins.bool]]:
        """
        Whether multiple availability zones are used for backing up.
        """
        return pulumi.get(self, "is_multi_az")

    @is_multi_az.setter
    def is_multi_az(self, value: Optional[pulumi.Input[builtins.bool]]):
        pulumi.set(self, "is_multi_az", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The name of the vault.
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter
    def period(self) -> Optional[pulumi.Input[builtins.int]]:
        return pulumi.get(self, "period")

    @period.setter
    def period(self, value: Optional[pulumi.Input[builtins.int]]):
        pulumi.set(self, "period", value)

    @property
    @pulumi.getter(name="periodUnit")
    def period_unit(self) -> Optional[pulumi.Input[builtins.str]]:
        return pulumi.get(self, "period_unit")

    @period_unit.setter
    def period_unit(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "period_unit", value)

    @property
    @pulumi.getter
    def policies(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['CbrVaultPolicyArgs']]]]:
        """
        The policy details to associate with the CBR vault.
        """
        return pulumi.get(self, "policies")

    @policies.setter
    def policies(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['CbrVaultPolicyArgs']]]]):
        pulumi.set(self, "policies", value)

    @property
    @pulumi.getter(name="policyId")
    def policy_id(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        schema:Deprecated; Using parameter 'policy' instead.
        """
        return pulumi.get(self, "policy_id")

    @policy_id.setter
    def policy_id(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "policy_id", value)

    @property
    @pulumi.getter
    def region(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The region where the vault is located.
        """
        return pulumi.get(self, "region")

    @region.setter
    def region(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "region", value)

    @property
    @pulumi.getter
    def resources(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['CbrVaultResourceArgs']]]]:
        """
        The array of one or more resources to attach to the CBR vault.
        """
        return pulumi.get(self, "resources")

    @resources.setter
    def resources(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['CbrVaultResourceArgs']]]]):
        pulumi.set(self, "resources", value)

    @property
    @pulumi.getter
    def tags(self) -> Optional[pulumi.Input[Mapping[str, pulumi.Input[builtins.str]]]]:
        return pulumi.get(self, "tags")

    @tags.setter
    def tags(self, value: Optional[pulumi.Input[Mapping[str, pulumi.Input[builtins.str]]]]):
        pulumi.set(self, "tags", value)


@pulumi.input_type
class _CbrVaultState:
    def __init__(__self__, *,
                 allocated: Optional[pulumi.Input[builtins.float]] = None,
                 auto_bind: Optional[pulumi.Input[builtins.bool]] = None,
                 auto_expand: Optional[pulumi.Input[builtins.bool]] = None,
                 auto_pay: Optional[pulumi.Input[builtins.str]] = None,
                 auto_renew: Optional[pulumi.Input[builtins.str]] = None,
                 backup_name_prefix: Optional[pulumi.Input[builtins.str]] = None,
                 bind_rules: Optional[pulumi.Input[Mapping[str, pulumi.Input[builtins.str]]]] = None,
                 charging_mode: Optional[pulumi.Input[builtins.str]] = None,
                 cloud_type: Optional[pulumi.Input[builtins.str]] = None,
                 consistent_level: Optional[pulumi.Input[builtins.str]] = None,
                 enterprise_project_id: Optional[pulumi.Input[builtins.str]] = None,
                 is_multi_az: Optional[pulumi.Input[builtins.bool]] = None,
                 name: Optional[pulumi.Input[builtins.str]] = None,
                 period: Optional[pulumi.Input[builtins.int]] = None,
                 period_unit: Optional[pulumi.Input[builtins.str]] = None,
                 policies: Optional[pulumi.Input[Sequence[pulumi.Input['CbrVaultPolicyArgs']]]] = None,
                 policy_id: Optional[pulumi.Input[builtins.str]] = None,
                 protection_type: Optional[pulumi.Input[builtins.str]] = None,
                 region: Optional[pulumi.Input[builtins.str]] = None,
                 resources: Optional[pulumi.Input[Sequence[pulumi.Input['CbrVaultResourceArgs']]]] = None,
                 size: Optional[pulumi.Input[builtins.int]] = None,
                 spec_code: Optional[pulumi.Input[builtins.str]] = None,
                 status: Optional[pulumi.Input[builtins.str]] = None,
                 storage: Optional[pulumi.Input[builtins.str]] = None,
                 tags: Optional[pulumi.Input[Mapping[str, pulumi.Input[builtins.str]]]] = None,
                 type: Optional[pulumi.Input[builtins.str]] = None,
                 used: Optional[pulumi.Input[builtins.float]] = None):
        """
        Input properties used for looking up and filtering CbrVault resources.
        :param pulumi.Input[builtins.float] allocated: The allocated capacity, in GB.
        :param pulumi.Input[builtins.bool] auto_bind: Whether automatic association is supported.
        :param pulumi.Input[builtins.bool] auto_expand: Whether to enable auto capacity expansion for the vault.
        :param pulumi.Input[builtins.str] backup_name_prefix: The backup name prefix.
        :param pulumi.Input[Mapping[str, pulumi.Input[builtins.str]]] bind_rules: The rules for automatic association.
        :param pulumi.Input[builtins.str] cloud_type: The cloud type of the vault.
        :param pulumi.Input[builtins.str] consistent_level: The consistent level (specification) of the vault.
        :param pulumi.Input[builtins.str] enterprise_project_id: The enterprise project ID to which the vault belongs.
        :param pulumi.Input[builtins.bool] is_multi_az: Whether multiple availability zones are used for backing up.
        :param pulumi.Input[builtins.str] name: The name of the vault.
        :param pulumi.Input[Sequence[pulumi.Input['CbrVaultPolicyArgs']]] policies: The policy details to associate with the CBR vault.
        :param pulumi.Input[builtins.str] policy_id: schema:Deprecated; Using parameter 'policy' instead.
        :param pulumi.Input[builtins.str] protection_type: The protection type of the vault.
        :param pulumi.Input[builtins.str] region: The region where the vault is located.
        :param pulumi.Input[Sequence[pulumi.Input['CbrVaultResourceArgs']]] resources: The array of one or more resources to attach to the CBR vault.
        :param pulumi.Input[builtins.int] size: The capacity of the vault, in GB.
        :param pulumi.Input[builtins.str] spec_code: The specification code.
        :param pulumi.Input[builtins.str] status: The vault status.
        :param pulumi.Input[builtins.str] storage: The name of the bucket for the vault.
        :param pulumi.Input[builtins.str] type: The type of the vault.
        :param pulumi.Input[builtins.float] used: The used capacity, in GB.
        """
        if allocated is not None:
            pulumi.set(__self__, "allocated", allocated)
        if auto_bind is not None:
            pulumi.set(__self__, "auto_bind", auto_bind)
        if auto_expand is not None:
            pulumi.set(__self__, "auto_expand", auto_expand)
        if auto_pay is not None:
            warnings.warn("""Deprecated""", DeprecationWarning)
            pulumi.log.warn("""auto_pay is deprecated: Deprecated""")
        if auto_pay is not None:
            pulumi.set(__self__, "auto_pay", auto_pay)
        if auto_renew is not None:
            pulumi.set(__self__, "auto_renew", auto_renew)
        if backup_name_prefix is not None:
            pulumi.set(__self__, "backup_name_prefix", backup_name_prefix)
        if bind_rules is not None:
            pulumi.set(__self__, "bind_rules", bind_rules)
        if charging_mode is not None:
            pulumi.set(__self__, "charging_mode", charging_mode)
        if cloud_type is not None:
            pulumi.set(__self__, "cloud_type", cloud_type)
        if consistent_level is not None:
            pulumi.set(__self__, "consistent_level", consistent_level)
        if enterprise_project_id is not None:
            pulumi.set(__self__, "enterprise_project_id", enterprise_project_id)
        if is_multi_az is not None:
            pulumi.set(__self__, "is_multi_az", is_multi_az)
        if name is not None:
            pulumi.set(__self__, "name", name)
        if period is not None:
            pulumi.set(__self__, "period", period)
        if period_unit is not None:
            pulumi.set(__self__, "period_unit", period_unit)
        if policies is not None:
            pulumi.set(__self__, "policies", policies)
        if policy_id is not None:
            pulumi.set(__self__, "policy_id", policy_id)
        if protection_type is not None:
            pulumi.set(__self__, "protection_type", protection_type)
        if region is not None:
            pulumi.set(__self__, "region", region)
        if resources is not None:
            pulumi.set(__self__, "resources", resources)
        if size is not None:
            pulumi.set(__self__, "size", size)
        if spec_code is not None:
            pulumi.set(__self__, "spec_code", spec_code)
        if status is not None:
            pulumi.set(__self__, "status", status)
        if storage is not None:
            pulumi.set(__self__, "storage", storage)
        if tags is not None:
            pulumi.set(__self__, "tags", tags)
        if type is not None:
            pulumi.set(__self__, "type", type)
        if used is not None:
            pulumi.set(__self__, "used", used)

    @property
    @pulumi.getter
    def allocated(self) -> Optional[pulumi.Input[builtins.float]]:
        """
        The allocated capacity, in GB.
        """
        return pulumi.get(self, "allocated")

    @allocated.setter
    def allocated(self, value: Optional[pulumi.Input[builtins.float]]):
        pulumi.set(self, "allocated", value)

    @property
    @pulumi.getter(name="autoBind")
    def auto_bind(self) -> Optional[pulumi.Input[builtins.bool]]:
        """
        Whether automatic association is supported.
        """
        return pulumi.get(self, "auto_bind")

    @auto_bind.setter
    def auto_bind(self, value: Optional[pulumi.Input[builtins.bool]]):
        pulumi.set(self, "auto_bind", value)

    @property
    @pulumi.getter(name="autoExpand")
    def auto_expand(self) -> Optional[pulumi.Input[builtins.bool]]:
        """
        Whether to enable auto capacity expansion for the vault.
        """
        return pulumi.get(self, "auto_expand")

    @auto_expand.setter
    def auto_expand(self, value: Optional[pulumi.Input[builtins.bool]]):
        pulumi.set(self, "auto_expand", value)

    @property
    @pulumi.getter(name="autoPay")
    @_utilities.deprecated("""Deprecated""")
    def auto_pay(self) -> Optional[pulumi.Input[builtins.str]]:
        return pulumi.get(self, "auto_pay")

    @auto_pay.setter
    def auto_pay(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "auto_pay", value)

    @property
    @pulumi.getter(name="autoRenew")
    def auto_renew(self) -> Optional[pulumi.Input[builtins.str]]:
        return pulumi.get(self, "auto_renew")

    @auto_renew.setter
    def auto_renew(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "auto_renew", value)

    @property
    @pulumi.getter(name="backupNamePrefix")
    def backup_name_prefix(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The backup name prefix.
        """
        return pulumi.get(self, "backup_name_prefix")

    @backup_name_prefix.setter
    def backup_name_prefix(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "backup_name_prefix", value)

    @property
    @pulumi.getter(name="bindRules")
    def bind_rules(self) -> Optional[pulumi.Input[Mapping[str, pulumi.Input[builtins.str]]]]:
        """
        The rules for automatic association.
        """
        return pulumi.get(self, "bind_rules")

    @bind_rules.setter
    def bind_rules(self, value: Optional[pulumi.Input[Mapping[str, pulumi.Input[builtins.str]]]]):
        pulumi.set(self, "bind_rules", value)

    @property
    @pulumi.getter(name="chargingMode")
    def charging_mode(self) -> Optional[pulumi.Input[builtins.str]]:
        return pulumi.get(self, "charging_mode")

    @charging_mode.setter
    def charging_mode(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "charging_mode", value)

    @property
    @pulumi.getter(name="cloudType")
    def cloud_type(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The cloud type of the vault.
        """
        return pulumi.get(self, "cloud_type")

    @cloud_type.setter
    def cloud_type(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "cloud_type", value)

    @property
    @pulumi.getter(name="consistentLevel")
    def consistent_level(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The consistent level (specification) of the vault.
        """
        return pulumi.get(self, "consistent_level")

    @consistent_level.setter
    def consistent_level(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "consistent_level", value)

    @property
    @pulumi.getter(name="enterpriseProjectId")
    def enterprise_project_id(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The enterprise project ID to which the vault belongs.
        """
        return pulumi.get(self, "enterprise_project_id")

    @enterprise_project_id.setter
    def enterprise_project_id(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "enterprise_project_id", value)

    @property
    @pulumi.getter(name="isMultiAz")
    def is_multi_az(self) -> Optional[pulumi.Input[builtins.bool]]:
        """
        Whether multiple availability zones are used for backing up.
        """
        return pulumi.get(self, "is_multi_az")

    @is_multi_az.setter
    def is_multi_az(self, value: Optional[pulumi.Input[builtins.bool]]):
        pulumi.set(self, "is_multi_az", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The name of the vault.
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter
    def period(self) -> Optional[pulumi.Input[builtins.int]]:
        return pulumi.get(self, "period")

    @period.setter
    def period(self, value: Optional[pulumi.Input[builtins.int]]):
        pulumi.set(self, "period", value)

    @property
    @pulumi.getter(name="periodUnit")
    def period_unit(self) -> Optional[pulumi.Input[builtins.str]]:
        return pulumi.get(self, "period_unit")

    @period_unit.setter
    def period_unit(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "period_unit", value)

    @property
    @pulumi.getter
    def policies(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['CbrVaultPolicyArgs']]]]:
        """
        The policy details to associate with the CBR vault.
        """
        return pulumi.get(self, "policies")

    @policies.setter
    def policies(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['CbrVaultPolicyArgs']]]]):
        pulumi.set(self, "policies", value)

    @property
    @pulumi.getter(name="policyId")
    def policy_id(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        schema:Deprecated; Using parameter 'policy' instead.
        """
        return pulumi.get(self, "policy_id")

    @policy_id.setter
    def policy_id(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "policy_id", value)

    @property
    @pulumi.getter(name="protectionType")
    def protection_type(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The protection type of the vault.
        """
        return pulumi.get(self, "protection_type")

    @protection_type.setter
    def protection_type(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "protection_type", value)

    @property
    @pulumi.getter
    def region(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The region where the vault is located.
        """
        return pulumi.get(self, "region")

    @region.setter
    def region(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "region", value)

    @property
    @pulumi.getter
    def resources(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['CbrVaultResourceArgs']]]]:
        """
        The array of one or more resources to attach to the CBR vault.
        """
        return pulumi.get(self, "resources")

    @resources.setter
    def resources(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['CbrVaultResourceArgs']]]]):
        pulumi.set(self, "resources", value)

    @property
    @pulumi.getter
    def size(self) -> Optional[pulumi.Input[builtins.int]]:
        """
        The capacity of the vault, in GB.
        """
        return pulumi.get(self, "size")

    @size.setter
    def size(self, value: Optional[pulumi.Input[builtins.int]]):
        pulumi.set(self, "size", value)

    @property
    @pulumi.getter(name="specCode")
    def spec_code(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The specification code.
        """
        return pulumi.get(self, "spec_code")

    @spec_code.setter
    def spec_code(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "spec_code", value)

    @property
    @pulumi.getter
    def status(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The vault status.
        """
        return pulumi.get(self, "status")

    @status.setter
    def status(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "status", value)

    @property
    @pulumi.getter
    def storage(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The name of the bucket for the vault.
        """
        return pulumi.get(self, "storage")

    @storage.setter
    def storage(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "storage", value)

    @property
    @pulumi.getter
    def tags(self) -> Optional[pulumi.Input[Mapping[str, pulumi.Input[builtins.str]]]]:
        return pulumi.get(self, "tags")

    @tags.setter
    def tags(self, value: Optional[pulumi.Input[Mapping[str, pulumi.Input[builtins.str]]]]):
        pulumi.set(self, "tags", value)

    @property
    @pulumi.getter
    def type(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The type of the vault.
        """
        return pulumi.get(self, "type")

    @type.setter
    def type(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "type", value)

    @property
    @pulumi.getter
    def used(self) -> Optional[pulumi.Input[builtins.float]]:
        """
        The used capacity, in GB.
        """
        return pulumi.get(self, "used")

    @used.setter
    def used(self, value: Optional[pulumi.Input[builtins.float]]):
        pulumi.set(self, "used", value)


class CbrVault(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 auto_bind: Optional[pulumi.Input[builtins.bool]] = None,
                 auto_expand: Optional[pulumi.Input[builtins.bool]] = None,
                 auto_pay: Optional[pulumi.Input[builtins.str]] = None,
                 auto_renew: Optional[pulumi.Input[builtins.str]] = None,
                 backup_name_prefix: Optional[pulumi.Input[builtins.str]] = None,
                 bind_rules: Optional[pulumi.Input[Mapping[str, pulumi.Input[builtins.str]]]] = None,
                 charging_mode: Optional[pulumi.Input[builtins.str]] = None,
                 cloud_type: Optional[pulumi.Input[builtins.str]] = None,
                 consistent_level: Optional[pulumi.Input[builtins.str]] = None,
                 enterprise_project_id: Optional[pulumi.Input[builtins.str]] = None,
                 is_multi_az: Optional[pulumi.Input[builtins.bool]] = None,
                 name: Optional[pulumi.Input[builtins.str]] = None,
                 period: Optional[pulumi.Input[builtins.int]] = None,
                 period_unit: Optional[pulumi.Input[builtins.str]] = None,
                 policies: Optional[pulumi.Input[Sequence[pulumi.Input[Union['CbrVaultPolicyArgs', 'CbrVaultPolicyArgsDict']]]]] = None,
                 policy_id: Optional[pulumi.Input[builtins.str]] = None,
                 protection_type: Optional[pulumi.Input[builtins.str]] = None,
                 region: Optional[pulumi.Input[builtins.str]] = None,
                 resources: Optional[pulumi.Input[Sequence[pulumi.Input[Union['CbrVaultResourceArgs', 'CbrVaultResourceArgsDict']]]]] = None,
                 size: Optional[pulumi.Input[builtins.int]] = None,
                 tags: Optional[pulumi.Input[Mapping[str, pulumi.Input[builtins.str]]]] = None,
                 type: Optional[pulumi.Input[builtins.str]] = None,
                 __props__=None):
        """
        Create a CbrVault resource with the given unique name, props, and options.
        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[builtins.bool] auto_bind: Whether automatic association is supported.
        :param pulumi.Input[builtins.bool] auto_expand: Whether to enable auto capacity expansion for the vault.
        :param pulumi.Input[builtins.str] backup_name_prefix: The backup name prefix.
        :param pulumi.Input[Mapping[str, pulumi.Input[builtins.str]]] bind_rules: The rules for automatic association.
        :param pulumi.Input[builtins.str] cloud_type: The cloud type of the vault.
        :param pulumi.Input[builtins.str] consistent_level: The consistent level (specification) of the vault.
        :param pulumi.Input[builtins.str] enterprise_project_id: The enterprise project ID to which the vault belongs.
        :param pulumi.Input[builtins.bool] is_multi_az: Whether multiple availability zones are used for backing up.
        :param pulumi.Input[builtins.str] name: The name of the vault.
        :param pulumi.Input[Sequence[pulumi.Input[Union['CbrVaultPolicyArgs', 'CbrVaultPolicyArgsDict']]]] policies: The policy details to associate with the CBR vault.
        :param pulumi.Input[builtins.str] policy_id: schema:Deprecated; Using parameter 'policy' instead.
        :param pulumi.Input[builtins.str] protection_type: The protection type of the vault.
        :param pulumi.Input[builtins.str] region: The region where the vault is located.
        :param pulumi.Input[Sequence[pulumi.Input[Union['CbrVaultResourceArgs', 'CbrVaultResourceArgsDict']]]] resources: The array of one or more resources to attach to the CBR vault.
        :param pulumi.Input[builtins.int] size: The capacity of the vault, in GB.
        :param pulumi.Input[builtins.str] type: The type of the vault.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: CbrVaultArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Create a CbrVault resource with the given unique name, props, and options.
        :param str resource_name: The name of the resource.
        :param CbrVaultArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(CbrVaultArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 auto_bind: Optional[pulumi.Input[builtins.bool]] = None,
                 auto_expand: Optional[pulumi.Input[builtins.bool]] = None,
                 auto_pay: Optional[pulumi.Input[builtins.str]] = None,
                 auto_renew: Optional[pulumi.Input[builtins.str]] = None,
                 backup_name_prefix: Optional[pulumi.Input[builtins.str]] = None,
                 bind_rules: Optional[pulumi.Input[Mapping[str, pulumi.Input[builtins.str]]]] = None,
                 charging_mode: Optional[pulumi.Input[builtins.str]] = None,
                 cloud_type: Optional[pulumi.Input[builtins.str]] = None,
                 consistent_level: Optional[pulumi.Input[builtins.str]] = None,
                 enterprise_project_id: Optional[pulumi.Input[builtins.str]] = None,
                 is_multi_az: Optional[pulumi.Input[builtins.bool]] = None,
                 name: Optional[pulumi.Input[builtins.str]] = None,
                 period: Optional[pulumi.Input[builtins.int]] = None,
                 period_unit: Optional[pulumi.Input[builtins.str]] = None,
                 policies: Optional[pulumi.Input[Sequence[pulumi.Input[Union['CbrVaultPolicyArgs', 'CbrVaultPolicyArgsDict']]]]] = None,
                 policy_id: Optional[pulumi.Input[builtins.str]] = None,
                 protection_type: Optional[pulumi.Input[builtins.str]] = None,
                 region: Optional[pulumi.Input[builtins.str]] = None,
                 resources: Optional[pulumi.Input[Sequence[pulumi.Input[Union['CbrVaultResourceArgs', 'CbrVaultResourceArgsDict']]]]] = None,
                 size: Optional[pulumi.Input[builtins.int]] = None,
                 tags: Optional[pulumi.Input[Mapping[str, pulumi.Input[builtins.str]]]] = None,
                 type: Optional[pulumi.Input[builtins.str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = CbrVaultArgs.__new__(CbrVaultArgs)

            __props__.__dict__["auto_bind"] = auto_bind
            __props__.__dict__["auto_expand"] = auto_expand
            __props__.__dict__["auto_pay"] = auto_pay
            __props__.__dict__["auto_renew"] = auto_renew
            __props__.__dict__["backup_name_prefix"] = backup_name_prefix
            __props__.__dict__["bind_rules"] = bind_rules
            __props__.__dict__["charging_mode"] = charging_mode
            __props__.__dict__["cloud_type"] = cloud_type
            __props__.__dict__["consistent_level"] = consistent_level
            __props__.__dict__["enterprise_project_id"] = enterprise_project_id
            __props__.__dict__["is_multi_az"] = is_multi_az
            __props__.__dict__["name"] = name
            __props__.__dict__["period"] = period
            __props__.__dict__["period_unit"] = period_unit
            __props__.__dict__["policies"] = policies
            __props__.__dict__["policy_id"] = policy_id
            if protection_type is None and not opts.urn:
                raise TypeError("Missing required property 'protection_type'")
            __props__.__dict__["protection_type"] = protection_type
            __props__.__dict__["region"] = region
            __props__.__dict__["resources"] = resources
            if size is None and not opts.urn:
                raise TypeError("Missing required property 'size'")
            __props__.__dict__["size"] = size
            __props__.__dict__["tags"] = tags
            if type is None and not opts.urn:
                raise TypeError("Missing required property 'type'")
            __props__.__dict__["type"] = type
            __props__.__dict__["allocated"] = None
            __props__.__dict__["spec_code"] = None
            __props__.__dict__["status"] = None
            __props__.__dict__["storage"] = None
            __props__.__dict__["used"] = None
        super(CbrVault, __self__).__init__(
            'sbercloud:index/cbrVault:CbrVault',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            allocated: Optional[pulumi.Input[builtins.float]] = None,
            auto_bind: Optional[pulumi.Input[builtins.bool]] = None,
            auto_expand: Optional[pulumi.Input[builtins.bool]] = None,
            auto_pay: Optional[pulumi.Input[builtins.str]] = None,
            auto_renew: Optional[pulumi.Input[builtins.str]] = None,
            backup_name_prefix: Optional[pulumi.Input[builtins.str]] = None,
            bind_rules: Optional[pulumi.Input[Mapping[str, pulumi.Input[builtins.str]]]] = None,
            charging_mode: Optional[pulumi.Input[builtins.str]] = None,
            cloud_type: Optional[pulumi.Input[builtins.str]] = None,
            consistent_level: Optional[pulumi.Input[builtins.str]] = None,
            enterprise_project_id: Optional[pulumi.Input[builtins.str]] = None,
            is_multi_az: Optional[pulumi.Input[builtins.bool]] = None,
            name: Optional[pulumi.Input[builtins.str]] = None,
            period: Optional[pulumi.Input[builtins.int]] = None,
            period_unit: Optional[pulumi.Input[builtins.str]] = None,
            policies: Optional[pulumi.Input[Sequence[pulumi.Input[Union['CbrVaultPolicyArgs', 'CbrVaultPolicyArgsDict']]]]] = None,
            policy_id: Optional[pulumi.Input[builtins.str]] = None,
            protection_type: Optional[pulumi.Input[builtins.str]] = None,
            region: Optional[pulumi.Input[builtins.str]] = None,
            resources: Optional[pulumi.Input[Sequence[pulumi.Input[Union['CbrVaultResourceArgs', 'CbrVaultResourceArgsDict']]]]] = None,
            size: Optional[pulumi.Input[builtins.int]] = None,
            spec_code: Optional[pulumi.Input[builtins.str]] = None,
            status: Optional[pulumi.Input[builtins.str]] = None,
            storage: Optional[pulumi.Input[builtins.str]] = None,
            tags: Optional[pulumi.Input[Mapping[str, pulumi.Input[builtins.str]]]] = None,
            type: Optional[pulumi.Input[builtins.str]] = None,
            used: Optional[pulumi.Input[builtins.float]] = None) -> 'CbrVault':
        """
        Get an existing CbrVault resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[builtins.float] allocated: The allocated capacity, in GB.
        :param pulumi.Input[builtins.bool] auto_bind: Whether automatic association is supported.
        :param pulumi.Input[builtins.bool] auto_expand: Whether to enable auto capacity expansion for the vault.
        :param pulumi.Input[builtins.str] backup_name_prefix: The backup name prefix.
        :param pulumi.Input[Mapping[str, pulumi.Input[builtins.str]]] bind_rules: The rules for automatic association.
        :param pulumi.Input[builtins.str] cloud_type: The cloud type of the vault.
        :param pulumi.Input[builtins.str] consistent_level: The consistent level (specification) of the vault.
        :param pulumi.Input[builtins.str] enterprise_project_id: The enterprise project ID to which the vault belongs.
        :param pulumi.Input[builtins.bool] is_multi_az: Whether multiple availability zones are used for backing up.
        :param pulumi.Input[builtins.str] name: The name of the vault.
        :param pulumi.Input[Sequence[pulumi.Input[Union['CbrVaultPolicyArgs', 'CbrVaultPolicyArgsDict']]]] policies: The policy details to associate with the CBR vault.
        :param pulumi.Input[builtins.str] policy_id: schema:Deprecated; Using parameter 'policy' instead.
        :param pulumi.Input[builtins.str] protection_type: The protection type of the vault.
        :param pulumi.Input[builtins.str] region: The region where the vault is located.
        :param pulumi.Input[Sequence[pulumi.Input[Union['CbrVaultResourceArgs', 'CbrVaultResourceArgsDict']]]] resources: The array of one or more resources to attach to the CBR vault.
        :param pulumi.Input[builtins.int] size: The capacity of the vault, in GB.
        :param pulumi.Input[builtins.str] spec_code: The specification code.
        :param pulumi.Input[builtins.str] status: The vault status.
        :param pulumi.Input[builtins.str] storage: The name of the bucket for the vault.
        :param pulumi.Input[builtins.str] type: The type of the vault.
        :param pulumi.Input[builtins.float] used: The used capacity, in GB.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _CbrVaultState.__new__(_CbrVaultState)

        __props__.__dict__["allocated"] = allocated
        __props__.__dict__["auto_bind"] = auto_bind
        __props__.__dict__["auto_expand"] = auto_expand
        __props__.__dict__["auto_pay"] = auto_pay
        __props__.__dict__["auto_renew"] = auto_renew
        __props__.__dict__["backup_name_prefix"] = backup_name_prefix
        __props__.__dict__["bind_rules"] = bind_rules
        __props__.__dict__["charging_mode"] = charging_mode
        __props__.__dict__["cloud_type"] = cloud_type
        __props__.__dict__["consistent_level"] = consistent_level
        __props__.__dict__["enterprise_project_id"] = enterprise_project_id
        __props__.__dict__["is_multi_az"] = is_multi_az
        __props__.__dict__["name"] = name
        __props__.__dict__["period"] = period
        __props__.__dict__["period_unit"] = period_unit
        __props__.__dict__["policies"] = policies
        __props__.__dict__["policy_id"] = policy_id
        __props__.__dict__["protection_type"] = protection_type
        __props__.__dict__["region"] = region
        __props__.__dict__["resources"] = resources
        __props__.__dict__["size"] = size
        __props__.__dict__["spec_code"] = spec_code
        __props__.__dict__["status"] = status
        __props__.__dict__["storage"] = storage
        __props__.__dict__["tags"] = tags
        __props__.__dict__["type"] = type
        __props__.__dict__["used"] = used
        return CbrVault(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter
    def allocated(self) -> pulumi.Output[builtins.float]:
        """
        The allocated capacity, in GB.
        """
        return pulumi.get(self, "allocated")

    @property
    @pulumi.getter(name="autoBind")
    def auto_bind(self) -> pulumi.Output[builtins.bool]:
        """
        Whether automatic association is supported.
        """
        return pulumi.get(self, "auto_bind")

    @property
    @pulumi.getter(name="autoExpand")
    def auto_expand(self) -> pulumi.Output[builtins.bool]:
        """
        Whether to enable auto capacity expansion for the vault.
        """
        return pulumi.get(self, "auto_expand")

    @property
    @pulumi.getter(name="autoPay")
    @_utilities.deprecated("""Deprecated""")
    def auto_pay(self) -> pulumi.Output[Optional[builtins.str]]:
        return pulumi.get(self, "auto_pay")

    @property
    @pulumi.getter(name="autoRenew")
    def auto_renew(self) -> pulumi.Output[Optional[builtins.str]]:
        return pulumi.get(self, "auto_renew")

    @property
    @pulumi.getter(name="backupNamePrefix")
    def backup_name_prefix(self) -> pulumi.Output[builtins.str]:
        """
        The backup name prefix.
        """
        return pulumi.get(self, "backup_name_prefix")

    @property
    @pulumi.getter(name="bindRules")
    def bind_rules(self) -> pulumi.Output[Optional[Mapping[str, builtins.str]]]:
        """
        The rules for automatic association.
        """
        return pulumi.get(self, "bind_rules")

    @property
    @pulumi.getter(name="chargingMode")
    def charging_mode(self) -> pulumi.Output[builtins.str]:
        return pulumi.get(self, "charging_mode")

    @property
    @pulumi.getter(name="cloudType")
    def cloud_type(self) -> pulumi.Output[builtins.str]:
        """
        The cloud type of the vault.
        """
        return pulumi.get(self, "cloud_type")

    @property
    @pulumi.getter(name="consistentLevel")
    def consistent_level(self) -> pulumi.Output[Optional[builtins.str]]:
        """
        The consistent level (specification) of the vault.
        """
        return pulumi.get(self, "consistent_level")

    @property
    @pulumi.getter(name="enterpriseProjectId")
    def enterprise_project_id(self) -> pulumi.Output[builtins.str]:
        """
        The enterprise project ID to which the vault belongs.
        """
        return pulumi.get(self, "enterprise_project_id")

    @property
    @pulumi.getter(name="isMultiAz")
    def is_multi_az(self) -> pulumi.Output[builtins.bool]:
        """
        Whether multiple availability zones are used for backing up.
        """
        return pulumi.get(self, "is_multi_az")

    @property
    @pulumi.getter
    def name(self) -> pulumi.Output[builtins.str]:
        """
        The name of the vault.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def period(self) -> pulumi.Output[Optional[builtins.int]]:
        return pulumi.get(self, "period")

    @property
    @pulumi.getter(name="periodUnit")
    def period_unit(self) -> pulumi.Output[Optional[builtins.str]]:
        return pulumi.get(self, "period_unit")

    @property
    @pulumi.getter
    def policies(self) -> pulumi.Output[Sequence['outputs.CbrVaultPolicy']]:
        """
        The policy details to associate with the CBR vault.
        """
        return pulumi.get(self, "policies")

    @property
    @pulumi.getter(name="policyId")
    def policy_id(self) -> pulumi.Output[Optional[builtins.str]]:
        """
        schema:Deprecated; Using parameter 'policy' instead.
        """
        return pulumi.get(self, "policy_id")

    @property
    @pulumi.getter(name="protectionType")
    def protection_type(self) -> pulumi.Output[builtins.str]:
        """
        The protection type of the vault.
        """
        return pulumi.get(self, "protection_type")

    @property
    @pulumi.getter
    def region(self) -> pulumi.Output[builtins.str]:
        """
        The region where the vault is located.
        """
        return pulumi.get(self, "region")

    @property
    @pulumi.getter
    def resources(self) -> pulumi.Output[Sequence['outputs.CbrVaultResource']]:
        """
        The array of one or more resources to attach to the CBR vault.
        """
        return pulumi.get(self, "resources")

    @property
    @pulumi.getter
    def size(self) -> pulumi.Output[builtins.int]:
        """
        The capacity of the vault, in GB.
        """
        return pulumi.get(self, "size")

    @property
    @pulumi.getter(name="specCode")
    def spec_code(self) -> pulumi.Output[builtins.str]:
        """
        The specification code.
        """
        return pulumi.get(self, "spec_code")

    @property
    @pulumi.getter
    def status(self) -> pulumi.Output[builtins.str]:
        """
        The vault status.
        """
        return pulumi.get(self, "status")

    @property
    @pulumi.getter
    def storage(self) -> pulumi.Output[builtins.str]:
        """
        The name of the bucket for the vault.
        """
        return pulumi.get(self, "storage")

    @property
    @pulumi.getter
    def tags(self) -> pulumi.Output[Optional[Mapping[str, builtins.str]]]:
        return pulumi.get(self, "tags")

    @property
    @pulumi.getter
    def type(self) -> pulumi.Output[builtins.str]:
        """
        The type of the vault.
        """
        return pulumi.get(self, "type")

    @property
    @pulumi.getter
    def used(self) -> pulumi.Output[builtins.float]:
        """
        The used capacity, in GB.
        """
        return pulumi.get(self, "used")

