# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from . import _utilities
from . import outputs
from ._inputs import *

__all__ = ['DwsClusterArgs', 'DwsCluster']

@pulumi.input_type
class DwsClusterArgs:
    def __init__(__self__, *,
                 availability_zone: pulumi.Input[builtins.str],
                 network_id: pulumi.Input[builtins.str],
                 node_type: pulumi.Input[builtins.str],
                 number_of_node: pulumi.Input[builtins.int],
                 security_group_id: pulumi.Input[builtins.str],
                 user_name: pulumi.Input[builtins.str],
                 user_pwd: pulumi.Input[builtins.str],
                 vpc_id: pulumi.Input[builtins.str],
                 description: Optional[pulumi.Input[builtins.str]] = None,
                 dss_pool_id: Optional[pulumi.Input[builtins.str]] = None,
                 elb_id: Optional[pulumi.Input[builtins.str]] = None,
                 enterprise_project_id: Optional[pulumi.Input[builtins.str]] = None,
                 force_backup: Optional[pulumi.Input[builtins.bool]] = None,
                 keep_last_manual_snapshot: Optional[pulumi.Input[builtins.int]] = None,
                 kms_key_id: Optional[pulumi.Input[builtins.str]] = None,
                 logical_cluster_enable: Optional[pulumi.Input[builtins.bool]] = None,
                 lts_enable: Optional[pulumi.Input[builtins.bool]] = None,
                 name: Optional[pulumi.Input[builtins.str]] = None,
                 number_of_cn: Optional[pulumi.Input[builtins.int]] = None,
                 port: Optional[pulumi.Input[builtins.int]] = None,
                 public_ip: Optional[pulumi.Input['DwsClusterPublicIpArgs']] = None,
                 region: Optional[pulumi.Input[builtins.str]] = None,
                 tags: Optional[pulumi.Input[Mapping[str, pulumi.Input[builtins.str]]]] = None,
                 version: Optional[pulumi.Input[builtins.str]] = None,
                 volume: Optional[pulumi.Input['DwsClusterVolumeArgs']] = None):
        """
        The set of arguments for constructing a DwsCluster resource.
        :param pulumi.Input[builtins.str] availability_zone: The availability zone in which to create the cluster instance.
        :param pulumi.Input[builtins.str] network_id: The subnet ID.
        :param pulumi.Input[builtins.str] node_type: The flavor of the cluster.
        :param pulumi.Input[builtins.int] number_of_node: Number of nodes in a cluster.
        :param pulumi.Input[builtins.str] security_group_id: The security group ID.
        :param pulumi.Input[builtins.str] user_name: Administrator username for logging in to a data warehouse cluster.
        :param pulumi.Input[builtins.str] user_pwd: Administrator password for logging in to a data warehouse cluster.
        :param pulumi.Input[builtins.str] vpc_id: The VPC ID.
        :param pulumi.Input[builtins.str] description: The description of the cluster.
        :param pulumi.Input[builtins.str] dss_pool_id: Dedicated storage pool ID.
        :param pulumi.Input[builtins.str] elb_id: The ID of the ELB load balancer.
        :param pulumi.Input[builtins.str] enterprise_project_id: The enterprise project ID.
        :param pulumi.Input[builtins.bool] force_backup: Whether to automatically execute snapshot when shrinking the number of nodes.
        :param pulumi.Input[builtins.int] keep_last_manual_snapshot: The number of latest manual snapshots that need to be retained when deleting the cluster.
        :param pulumi.Input[builtins.str] kms_key_id: The KMS key ID.
        :param pulumi.Input[builtins.bool] logical_cluster_enable: Whether to enable logical cluster.
        :param pulumi.Input[builtins.bool] lts_enable: Whether to enable LTS.
        :param pulumi.Input[builtins.str] name: The cluster name.
        :param pulumi.Input[builtins.int] number_of_cn: schema: Required
        :param pulumi.Input[builtins.int] port: Service port of a cluster (8000 to 10000). The default value is 8000.
        :param pulumi.Input[Mapping[str, pulumi.Input[builtins.str]]] tags: The key/value pairs to associate with the cluster.
        :param pulumi.Input[builtins.str] version: schema: Required
        """
        pulumi.set(__self__, "availability_zone", availability_zone)
        pulumi.set(__self__, "network_id", network_id)
        pulumi.set(__self__, "node_type", node_type)
        pulumi.set(__self__, "number_of_node", number_of_node)
        pulumi.set(__self__, "security_group_id", security_group_id)
        pulumi.set(__self__, "user_name", user_name)
        pulumi.set(__self__, "user_pwd", user_pwd)
        pulumi.set(__self__, "vpc_id", vpc_id)
        if description is not None:
            pulumi.set(__self__, "description", description)
        if dss_pool_id is not None:
            pulumi.set(__self__, "dss_pool_id", dss_pool_id)
        if elb_id is not None:
            pulumi.set(__self__, "elb_id", elb_id)
        if enterprise_project_id is not None:
            pulumi.set(__self__, "enterprise_project_id", enterprise_project_id)
        if force_backup is not None:
            pulumi.set(__self__, "force_backup", force_backup)
        if keep_last_manual_snapshot is not None:
            pulumi.set(__self__, "keep_last_manual_snapshot", keep_last_manual_snapshot)
        if kms_key_id is not None:
            pulumi.set(__self__, "kms_key_id", kms_key_id)
        if logical_cluster_enable is not None:
            pulumi.set(__self__, "logical_cluster_enable", logical_cluster_enable)
        if lts_enable is not None:
            pulumi.set(__self__, "lts_enable", lts_enable)
        if name is not None:
            pulumi.set(__self__, "name", name)
        if number_of_cn is not None:
            pulumi.set(__self__, "number_of_cn", number_of_cn)
        if port is not None:
            pulumi.set(__self__, "port", port)
        if public_ip is not None:
            pulumi.set(__self__, "public_ip", public_ip)
        if region is not None:
            pulumi.set(__self__, "region", region)
        if tags is not None:
            pulumi.set(__self__, "tags", tags)
        if version is not None:
            pulumi.set(__self__, "version", version)
        if volume is not None:
            pulumi.set(__self__, "volume", volume)

    @property
    @pulumi.getter(name="availabilityZone")
    def availability_zone(self) -> pulumi.Input[builtins.str]:
        """
        The availability zone in which to create the cluster instance.
        """
        return pulumi.get(self, "availability_zone")

    @availability_zone.setter
    def availability_zone(self, value: pulumi.Input[builtins.str]):
        pulumi.set(self, "availability_zone", value)

    @property
    @pulumi.getter(name="networkId")
    def network_id(self) -> pulumi.Input[builtins.str]:
        """
        The subnet ID.
        """
        return pulumi.get(self, "network_id")

    @network_id.setter
    def network_id(self, value: pulumi.Input[builtins.str]):
        pulumi.set(self, "network_id", value)

    @property
    @pulumi.getter(name="nodeType")
    def node_type(self) -> pulumi.Input[builtins.str]:
        """
        The flavor of the cluster.
        """
        return pulumi.get(self, "node_type")

    @node_type.setter
    def node_type(self, value: pulumi.Input[builtins.str]):
        pulumi.set(self, "node_type", value)

    @property
    @pulumi.getter(name="numberOfNode")
    def number_of_node(self) -> pulumi.Input[builtins.int]:
        """
        Number of nodes in a cluster.
        """
        return pulumi.get(self, "number_of_node")

    @number_of_node.setter
    def number_of_node(self, value: pulumi.Input[builtins.int]):
        pulumi.set(self, "number_of_node", value)

    @property
    @pulumi.getter(name="securityGroupId")
    def security_group_id(self) -> pulumi.Input[builtins.str]:
        """
        The security group ID.
        """
        return pulumi.get(self, "security_group_id")

    @security_group_id.setter
    def security_group_id(self, value: pulumi.Input[builtins.str]):
        pulumi.set(self, "security_group_id", value)

    @property
    @pulumi.getter(name="userName")
    def user_name(self) -> pulumi.Input[builtins.str]:
        """
        Administrator username for logging in to a data warehouse cluster.
        """
        return pulumi.get(self, "user_name")

    @user_name.setter
    def user_name(self, value: pulumi.Input[builtins.str]):
        pulumi.set(self, "user_name", value)

    @property
    @pulumi.getter(name="userPwd")
    def user_pwd(self) -> pulumi.Input[builtins.str]:
        """
        Administrator password for logging in to a data warehouse cluster.
        """
        return pulumi.get(self, "user_pwd")

    @user_pwd.setter
    def user_pwd(self, value: pulumi.Input[builtins.str]):
        pulumi.set(self, "user_pwd", value)

    @property
    @pulumi.getter(name="vpcId")
    def vpc_id(self) -> pulumi.Input[builtins.str]:
        """
        The VPC ID.
        """
        return pulumi.get(self, "vpc_id")

    @vpc_id.setter
    def vpc_id(self, value: pulumi.Input[builtins.str]):
        pulumi.set(self, "vpc_id", value)

    @property
    @pulumi.getter
    def description(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The description of the cluster.
        """
        return pulumi.get(self, "description")

    @description.setter
    def description(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "description", value)

    @property
    @pulumi.getter(name="dssPoolId")
    def dss_pool_id(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        Dedicated storage pool ID.
        """
        return pulumi.get(self, "dss_pool_id")

    @dss_pool_id.setter
    def dss_pool_id(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "dss_pool_id", value)

    @property
    @pulumi.getter(name="elbId")
    def elb_id(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The ID of the ELB load balancer.
        """
        return pulumi.get(self, "elb_id")

    @elb_id.setter
    def elb_id(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "elb_id", value)

    @property
    @pulumi.getter(name="enterpriseProjectId")
    def enterprise_project_id(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The enterprise project ID.
        """
        return pulumi.get(self, "enterprise_project_id")

    @enterprise_project_id.setter
    def enterprise_project_id(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "enterprise_project_id", value)

    @property
    @pulumi.getter(name="forceBackup")
    def force_backup(self) -> Optional[pulumi.Input[builtins.bool]]:
        """
        Whether to automatically execute snapshot when shrinking the number of nodes.
        """
        return pulumi.get(self, "force_backup")

    @force_backup.setter
    def force_backup(self, value: Optional[pulumi.Input[builtins.bool]]):
        pulumi.set(self, "force_backup", value)

    @property
    @pulumi.getter(name="keepLastManualSnapshot")
    def keep_last_manual_snapshot(self) -> Optional[pulumi.Input[builtins.int]]:
        """
        The number of latest manual snapshots that need to be retained when deleting the cluster.
        """
        return pulumi.get(self, "keep_last_manual_snapshot")

    @keep_last_manual_snapshot.setter
    def keep_last_manual_snapshot(self, value: Optional[pulumi.Input[builtins.int]]):
        pulumi.set(self, "keep_last_manual_snapshot", value)

    @property
    @pulumi.getter(name="kmsKeyId")
    def kms_key_id(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The KMS key ID.
        """
        return pulumi.get(self, "kms_key_id")

    @kms_key_id.setter
    def kms_key_id(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "kms_key_id", value)

    @property
    @pulumi.getter(name="logicalClusterEnable")
    def logical_cluster_enable(self) -> Optional[pulumi.Input[builtins.bool]]:
        """
        Whether to enable logical cluster.
        """
        return pulumi.get(self, "logical_cluster_enable")

    @logical_cluster_enable.setter
    def logical_cluster_enable(self, value: Optional[pulumi.Input[builtins.bool]]):
        pulumi.set(self, "logical_cluster_enable", value)

    @property
    @pulumi.getter(name="ltsEnable")
    def lts_enable(self) -> Optional[pulumi.Input[builtins.bool]]:
        """
        Whether to enable LTS.
        """
        return pulumi.get(self, "lts_enable")

    @lts_enable.setter
    def lts_enable(self, value: Optional[pulumi.Input[builtins.bool]]):
        pulumi.set(self, "lts_enable", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The cluster name.
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter(name="numberOfCn")
    def number_of_cn(self) -> Optional[pulumi.Input[builtins.int]]:
        """
        schema: Required
        """
        return pulumi.get(self, "number_of_cn")

    @number_of_cn.setter
    def number_of_cn(self, value: Optional[pulumi.Input[builtins.int]]):
        pulumi.set(self, "number_of_cn", value)

    @property
    @pulumi.getter
    def port(self) -> Optional[pulumi.Input[builtins.int]]:
        """
        Service port of a cluster (8000 to 10000). The default value is 8000.
        """
        return pulumi.get(self, "port")

    @port.setter
    def port(self, value: Optional[pulumi.Input[builtins.int]]):
        pulumi.set(self, "port", value)

    @property
    @pulumi.getter(name="publicIp")
    def public_ip(self) -> Optional[pulumi.Input['DwsClusterPublicIpArgs']]:
        return pulumi.get(self, "public_ip")

    @public_ip.setter
    def public_ip(self, value: Optional[pulumi.Input['DwsClusterPublicIpArgs']]):
        pulumi.set(self, "public_ip", value)

    @property
    @pulumi.getter
    def region(self) -> Optional[pulumi.Input[builtins.str]]:
        return pulumi.get(self, "region")

    @region.setter
    def region(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "region", value)

    @property
    @pulumi.getter
    def tags(self) -> Optional[pulumi.Input[Mapping[str, pulumi.Input[builtins.str]]]]:
        """
        The key/value pairs to associate with the cluster.
        """
        return pulumi.get(self, "tags")

    @tags.setter
    def tags(self, value: Optional[pulumi.Input[Mapping[str, pulumi.Input[builtins.str]]]]):
        pulumi.set(self, "tags", value)

    @property
    @pulumi.getter
    def version(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        schema: Required
        """
        return pulumi.get(self, "version")

    @version.setter
    def version(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "version", value)

    @property
    @pulumi.getter
    def volume(self) -> Optional[pulumi.Input['DwsClusterVolumeArgs']]:
        return pulumi.get(self, "volume")

    @volume.setter
    def volume(self, value: Optional[pulumi.Input['DwsClusterVolumeArgs']]):
        pulumi.set(self, "volume", value)


@pulumi.input_type
class _DwsClusterState:
    def __init__(__self__, *,
                 availability_zone: Optional[pulumi.Input[builtins.str]] = None,
                 created: Optional[pulumi.Input[builtins.str]] = None,
                 description: Optional[pulumi.Input[builtins.str]] = None,
                 dss_pool_id: Optional[pulumi.Input[builtins.str]] = None,
                 elb_id: Optional[pulumi.Input[builtins.str]] = None,
                 elbs: Optional[pulumi.Input[Sequence[pulumi.Input['DwsClusterElbArgs']]]] = None,
                 endpoints: Optional[pulumi.Input[Sequence[pulumi.Input['DwsClusterEndpointArgs']]]] = None,
                 enterprise_project_id: Optional[pulumi.Input[builtins.str]] = None,
                 force_backup: Optional[pulumi.Input[builtins.bool]] = None,
                 keep_last_manual_snapshot: Optional[pulumi.Input[builtins.int]] = None,
                 kms_key_id: Optional[pulumi.Input[builtins.str]] = None,
                 logical_cluster_enable: Optional[pulumi.Input[builtins.bool]] = None,
                 lts_enable: Optional[pulumi.Input[builtins.bool]] = None,
                 maintain_windows: Optional[pulumi.Input[Sequence[pulumi.Input['DwsClusterMaintainWindowArgs']]]] = None,
                 name: Optional[pulumi.Input[builtins.str]] = None,
                 network_id: Optional[pulumi.Input[builtins.str]] = None,
                 node_type: Optional[pulumi.Input[builtins.str]] = None,
                 number_of_cn: Optional[pulumi.Input[builtins.int]] = None,
                 number_of_node: Optional[pulumi.Input[builtins.int]] = None,
                 port: Optional[pulumi.Input[builtins.int]] = None,
                 private_ips: Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]] = None,
                 public_endpoints: Optional[pulumi.Input[Sequence[pulumi.Input['DwsClusterPublicEndpointArgs']]]] = None,
                 public_ip: Optional[pulumi.Input['DwsClusterPublicIpArgs']] = None,
                 recent_event: Optional[pulumi.Input[builtins.int]] = None,
                 region: Optional[pulumi.Input[builtins.str]] = None,
                 security_group_id: Optional[pulumi.Input[builtins.str]] = None,
                 status: Optional[pulumi.Input[builtins.str]] = None,
                 sub_status: Optional[pulumi.Input[builtins.str]] = None,
                 tags: Optional[pulumi.Input[Mapping[str, pulumi.Input[builtins.str]]]] = None,
                 task_status: Optional[pulumi.Input[builtins.str]] = None,
                 updated: Optional[pulumi.Input[builtins.str]] = None,
                 user_name: Optional[pulumi.Input[builtins.str]] = None,
                 user_pwd: Optional[pulumi.Input[builtins.str]] = None,
                 version: Optional[pulumi.Input[builtins.str]] = None,
                 volume: Optional[pulumi.Input['DwsClusterVolumeArgs']] = None,
                 vpc_id: Optional[pulumi.Input[builtins.str]] = None):
        """
        Input properties used for looking up and filtering DwsCluster resources.
        :param pulumi.Input[builtins.str] availability_zone: The availability zone in which to create the cluster instance.
        :param pulumi.Input[builtins.str] created: The creation time of the cluster.
        :param pulumi.Input[builtins.str] description: The description of the cluster.
        :param pulumi.Input[builtins.str] dss_pool_id: Dedicated storage pool ID.
        :param pulumi.Input[builtins.str] elb_id: The ID of the ELB load balancer.
        :param pulumi.Input[Sequence[pulumi.Input['DwsClusterElbArgs']]] elbs: The ELB information bound to the cluster.
        :param pulumi.Input[Sequence[pulumi.Input['DwsClusterEndpointArgs']]] endpoints: Private network connection information about the cluster.
        :param pulumi.Input[builtins.str] enterprise_project_id: The enterprise project ID.
        :param pulumi.Input[builtins.bool] force_backup: Whether to automatically execute snapshot when shrinking the number of nodes.
        :param pulumi.Input[builtins.int] keep_last_manual_snapshot: The number of latest manual snapshots that need to be retained when deleting the cluster.
        :param pulumi.Input[builtins.str] kms_key_id: The KMS key ID.
        :param pulumi.Input[builtins.bool] logical_cluster_enable: Whether to enable logical cluster.
        :param pulumi.Input[builtins.bool] lts_enable: Whether to enable LTS.
        :param pulumi.Input[Sequence[pulumi.Input['DwsClusterMaintainWindowArgs']]] maintain_windows: Cluster maintenance window.
        :param pulumi.Input[builtins.str] name: The cluster name.
        :param pulumi.Input[builtins.str] network_id: The subnet ID.
        :param pulumi.Input[builtins.str] node_type: The flavor of the cluster.
        :param pulumi.Input[builtins.int] number_of_cn: schema: Required
        :param pulumi.Input[builtins.int] number_of_node: Number of nodes in a cluster.
        :param pulumi.Input[builtins.int] port: Service port of a cluster (8000 to 10000). The default value is 8000.
        :param pulumi.Input[Sequence[pulumi.Input[builtins.str]]] private_ips: List of private network IP addresses.
        :param pulumi.Input[Sequence[pulumi.Input['DwsClusterPublicEndpointArgs']]] public_endpoints: Public network connection information about the cluster.
        :param pulumi.Input[builtins.str] security_group_id: The security group ID.
        :param pulumi.Input[builtins.str] status: The cluster status.
        :param pulumi.Input[builtins.str] sub_status: Sub-status of clusters in the AVAILABLE state.
        :param pulumi.Input[Mapping[str, pulumi.Input[builtins.str]]] tags: The key/value pairs to associate with the cluster.
        :param pulumi.Input[builtins.str] task_status: Cluster management task.
        :param pulumi.Input[builtins.str] updated: The updated time of the cluster.
        :param pulumi.Input[builtins.str] user_name: Administrator username for logging in to a data warehouse cluster.
        :param pulumi.Input[builtins.str] user_pwd: Administrator password for logging in to a data warehouse cluster.
        :param pulumi.Input[builtins.str] version: schema: Required
        :param pulumi.Input[builtins.str] vpc_id: The VPC ID.
        """
        if availability_zone is not None:
            pulumi.set(__self__, "availability_zone", availability_zone)
        if created is not None:
            pulumi.set(__self__, "created", created)
        if description is not None:
            pulumi.set(__self__, "description", description)
        if dss_pool_id is not None:
            pulumi.set(__self__, "dss_pool_id", dss_pool_id)
        if elb_id is not None:
            pulumi.set(__self__, "elb_id", elb_id)
        if elbs is not None:
            pulumi.set(__self__, "elbs", elbs)
        if endpoints is not None:
            pulumi.set(__self__, "endpoints", endpoints)
        if enterprise_project_id is not None:
            pulumi.set(__self__, "enterprise_project_id", enterprise_project_id)
        if force_backup is not None:
            pulumi.set(__self__, "force_backup", force_backup)
        if keep_last_manual_snapshot is not None:
            pulumi.set(__self__, "keep_last_manual_snapshot", keep_last_manual_snapshot)
        if kms_key_id is not None:
            pulumi.set(__self__, "kms_key_id", kms_key_id)
        if logical_cluster_enable is not None:
            pulumi.set(__self__, "logical_cluster_enable", logical_cluster_enable)
        if lts_enable is not None:
            pulumi.set(__self__, "lts_enable", lts_enable)
        if maintain_windows is not None:
            pulumi.set(__self__, "maintain_windows", maintain_windows)
        if name is not None:
            pulumi.set(__self__, "name", name)
        if network_id is not None:
            pulumi.set(__self__, "network_id", network_id)
        if node_type is not None:
            pulumi.set(__self__, "node_type", node_type)
        if number_of_cn is not None:
            pulumi.set(__self__, "number_of_cn", number_of_cn)
        if number_of_node is not None:
            pulumi.set(__self__, "number_of_node", number_of_node)
        if port is not None:
            pulumi.set(__self__, "port", port)
        if private_ips is not None:
            pulumi.set(__self__, "private_ips", private_ips)
        if public_endpoints is not None:
            pulumi.set(__self__, "public_endpoints", public_endpoints)
        if public_ip is not None:
            pulumi.set(__self__, "public_ip", public_ip)
        if recent_event is not None:
            pulumi.set(__self__, "recent_event", recent_event)
        if region is not None:
            pulumi.set(__self__, "region", region)
        if security_group_id is not None:
            pulumi.set(__self__, "security_group_id", security_group_id)
        if status is not None:
            pulumi.set(__self__, "status", status)
        if sub_status is not None:
            pulumi.set(__self__, "sub_status", sub_status)
        if tags is not None:
            pulumi.set(__self__, "tags", tags)
        if task_status is not None:
            pulumi.set(__self__, "task_status", task_status)
        if updated is not None:
            pulumi.set(__self__, "updated", updated)
        if user_name is not None:
            pulumi.set(__self__, "user_name", user_name)
        if user_pwd is not None:
            pulumi.set(__self__, "user_pwd", user_pwd)
        if version is not None:
            pulumi.set(__self__, "version", version)
        if volume is not None:
            pulumi.set(__self__, "volume", volume)
        if vpc_id is not None:
            pulumi.set(__self__, "vpc_id", vpc_id)

    @property
    @pulumi.getter(name="availabilityZone")
    def availability_zone(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The availability zone in which to create the cluster instance.
        """
        return pulumi.get(self, "availability_zone")

    @availability_zone.setter
    def availability_zone(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "availability_zone", value)

    @property
    @pulumi.getter
    def created(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The creation time of the cluster.
        """
        return pulumi.get(self, "created")

    @created.setter
    def created(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "created", value)

    @property
    @pulumi.getter
    def description(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The description of the cluster.
        """
        return pulumi.get(self, "description")

    @description.setter
    def description(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "description", value)

    @property
    @pulumi.getter(name="dssPoolId")
    def dss_pool_id(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        Dedicated storage pool ID.
        """
        return pulumi.get(self, "dss_pool_id")

    @dss_pool_id.setter
    def dss_pool_id(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "dss_pool_id", value)

    @property
    @pulumi.getter(name="elbId")
    def elb_id(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The ID of the ELB load balancer.
        """
        return pulumi.get(self, "elb_id")

    @elb_id.setter
    def elb_id(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "elb_id", value)

    @property
    @pulumi.getter
    def elbs(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['DwsClusterElbArgs']]]]:
        """
        The ELB information bound to the cluster.
        """
        return pulumi.get(self, "elbs")

    @elbs.setter
    def elbs(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['DwsClusterElbArgs']]]]):
        pulumi.set(self, "elbs", value)

    @property
    @pulumi.getter
    def endpoints(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['DwsClusterEndpointArgs']]]]:
        """
        Private network connection information about the cluster.
        """
        return pulumi.get(self, "endpoints")

    @endpoints.setter
    def endpoints(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['DwsClusterEndpointArgs']]]]):
        pulumi.set(self, "endpoints", value)

    @property
    @pulumi.getter(name="enterpriseProjectId")
    def enterprise_project_id(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The enterprise project ID.
        """
        return pulumi.get(self, "enterprise_project_id")

    @enterprise_project_id.setter
    def enterprise_project_id(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "enterprise_project_id", value)

    @property
    @pulumi.getter(name="forceBackup")
    def force_backup(self) -> Optional[pulumi.Input[builtins.bool]]:
        """
        Whether to automatically execute snapshot when shrinking the number of nodes.
        """
        return pulumi.get(self, "force_backup")

    @force_backup.setter
    def force_backup(self, value: Optional[pulumi.Input[builtins.bool]]):
        pulumi.set(self, "force_backup", value)

    @property
    @pulumi.getter(name="keepLastManualSnapshot")
    def keep_last_manual_snapshot(self) -> Optional[pulumi.Input[builtins.int]]:
        """
        The number of latest manual snapshots that need to be retained when deleting the cluster.
        """
        return pulumi.get(self, "keep_last_manual_snapshot")

    @keep_last_manual_snapshot.setter
    def keep_last_manual_snapshot(self, value: Optional[pulumi.Input[builtins.int]]):
        pulumi.set(self, "keep_last_manual_snapshot", value)

    @property
    @pulumi.getter(name="kmsKeyId")
    def kms_key_id(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The KMS key ID.
        """
        return pulumi.get(self, "kms_key_id")

    @kms_key_id.setter
    def kms_key_id(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "kms_key_id", value)

    @property
    @pulumi.getter(name="logicalClusterEnable")
    def logical_cluster_enable(self) -> Optional[pulumi.Input[builtins.bool]]:
        """
        Whether to enable logical cluster.
        """
        return pulumi.get(self, "logical_cluster_enable")

    @logical_cluster_enable.setter
    def logical_cluster_enable(self, value: Optional[pulumi.Input[builtins.bool]]):
        pulumi.set(self, "logical_cluster_enable", value)

    @property
    @pulumi.getter(name="ltsEnable")
    def lts_enable(self) -> Optional[pulumi.Input[builtins.bool]]:
        """
        Whether to enable LTS.
        """
        return pulumi.get(self, "lts_enable")

    @lts_enable.setter
    def lts_enable(self, value: Optional[pulumi.Input[builtins.bool]]):
        pulumi.set(self, "lts_enable", value)

    @property
    @pulumi.getter(name="maintainWindows")
    def maintain_windows(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['DwsClusterMaintainWindowArgs']]]]:
        """
        Cluster maintenance window.
        """
        return pulumi.get(self, "maintain_windows")

    @maintain_windows.setter
    def maintain_windows(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['DwsClusterMaintainWindowArgs']]]]):
        pulumi.set(self, "maintain_windows", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The cluster name.
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter(name="networkId")
    def network_id(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The subnet ID.
        """
        return pulumi.get(self, "network_id")

    @network_id.setter
    def network_id(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "network_id", value)

    @property
    @pulumi.getter(name="nodeType")
    def node_type(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The flavor of the cluster.
        """
        return pulumi.get(self, "node_type")

    @node_type.setter
    def node_type(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "node_type", value)

    @property
    @pulumi.getter(name="numberOfCn")
    def number_of_cn(self) -> Optional[pulumi.Input[builtins.int]]:
        """
        schema: Required
        """
        return pulumi.get(self, "number_of_cn")

    @number_of_cn.setter
    def number_of_cn(self, value: Optional[pulumi.Input[builtins.int]]):
        pulumi.set(self, "number_of_cn", value)

    @property
    @pulumi.getter(name="numberOfNode")
    def number_of_node(self) -> Optional[pulumi.Input[builtins.int]]:
        """
        Number of nodes in a cluster.
        """
        return pulumi.get(self, "number_of_node")

    @number_of_node.setter
    def number_of_node(self, value: Optional[pulumi.Input[builtins.int]]):
        pulumi.set(self, "number_of_node", value)

    @property
    @pulumi.getter
    def port(self) -> Optional[pulumi.Input[builtins.int]]:
        """
        Service port of a cluster (8000 to 10000). The default value is 8000.
        """
        return pulumi.get(self, "port")

    @port.setter
    def port(self, value: Optional[pulumi.Input[builtins.int]]):
        pulumi.set(self, "port", value)

    @property
    @pulumi.getter(name="privateIps")
    def private_ips(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]]:
        """
        List of private network IP addresses.
        """
        return pulumi.get(self, "private_ips")

    @private_ips.setter
    def private_ips(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]]):
        pulumi.set(self, "private_ips", value)

    @property
    @pulumi.getter(name="publicEndpoints")
    def public_endpoints(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['DwsClusterPublicEndpointArgs']]]]:
        """
        Public network connection information about the cluster.
        """
        return pulumi.get(self, "public_endpoints")

    @public_endpoints.setter
    def public_endpoints(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['DwsClusterPublicEndpointArgs']]]]):
        pulumi.set(self, "public_endpoints", value)

    @property
    @pulumi.getter(name="publicIp")
    def public_ip(self) -> Optional[pulumi.Input['DwsClusterPublicIpArgs']]:
        return pulumi.get(self, "public_ip")

    @public_ip.setter
    def public_ip(self, value: Optional[pulumi.Input['DwsClusterPublicIpArgs']]):
        pulumi.set(self, "public_ip", value)

    @property
    @pulumi.getter(name="recentEvent")
    def recent_event(self) -> Optional[pulumi.Input[builtins.int]]:
        return pulumi.get(self, "recent_event")

    @recent_event.setter
    def recent_event(self, value: Optional[pulumi.Input[builtins.int]]):
        pulumi.set(self, "recent_event", value)

    @property
    @pulumi.getter
    def region(self) -> Optional[pulumi.Input[builtins.str]]:
        return pulumi.get(self, "region")

    @region.setter
    def region(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "region", value)

    @property
    @pulumi.getter(name="securityGroupId")
    def security_group_id(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The security group ID.
        """
        return pulumi.get(self, "security_group_id")

    @security_group_id.setter
    def security_group_id(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "security_group_id", value)

    @property
    @pulumi.getter
    def status(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The cluster status.
        """
        return pulumi.get(self, "status")

    @status.setter
    def status(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "status", value)

    @property
    @pulumi.getter(name="subStatus")
    def sub_status(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        Sub-status of clusters in the AVAILABLE state.
        """
        return pulumi.get(self, "sub_status")

    @sub_status.setter
    def sub_status(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "sub_status", value)

    @property
    @pulumi.getter
    def tags(self) -> Optional[pulumi.Input[Mapping[str, pulumi.Input[builtins.str]]]]:
        """
        The key/value pairs to associate with the cluster.
        """
        return pulumi.get(self, "tags")

    @tags.setter
    def tags(self, value: Optional[pulumi.Input[Mapping[str, pulumi.Input[builtins.str]]]]):
        pulumi.set(self, "tags", value)

    @property
    @pulumi.getter(name="taskStatus")
    def task_status(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        Cluster management task.
        """
        return pulumi.get(self, "task_status")

    @task_status.setter
    def task_status(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "task_status", value)

    @property
    @pulumi.getter
    def updated(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The updated time of the cluster.
        """
        return pulumi.get(self, "updated")

    @updated.setter
    def updated(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "updated", value)

    @property
    @pulumi.getter(name="userName")
    def user_name(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        Administrator username for logging in to a data warehouse cluster.
        """
        return pulumi.get(self, "user_name")

    @user_name.setter
    def user_name(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "user_name", value)

    @property
    @pulumi.getter(name="userPwd")
    def user_pwd(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        Administrator password for logging in to a data warehouse cluster.
        """
        return pulumi.get(self, "user_pwd")

    @user_pwd.setter
    def user_pwd(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "user_pwd", value)

    @property
    @pulumi.getter
    def version(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        schema: Required
        """
        return pulumi.get(self, "version")

    @version.setter
    def version(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "version", value)

    @property
    @pulumi.getter
    def volume(self) -> Optional[pulumi.Input['DwsClusterVolumeArgs']]:
        return pulumi.get(self, "volume")

    @volume.setter
    def volume(self, value: Optional[pulumi.Input['DwsClusterVolumeArgs']]):
        pulumi.set(self, "volume", value)

    @property
    @pulumi.getter(name="vpcId")
    def vpc_id(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The VPC ID.
        """
        return pulumi.get(self, "vpc_id")

    @vpc_id.setter
    def vpc_id(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "vpc_id", value)


class DwsCluster(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 availability_zone: Optional[pulumi.Input[builtins.str]] = None,
                 description: Optional[pulumi.Input[builtins.str]] = None,
                 dss_pool_id: Optional[pulumi.Input[builtins.str]] = None,
                 elb_id: Optional[pulumi.Input[builtins.str]] = None,
                 enterprise_project_id: Optional[pulumi.Input[builtins.str]] = None,
                 force_backup: Optional[pulumi.Input[builtins.bool]] = None,
                 keep_last_manual_snapshot: Optional[pulumi.Input[builtins.int]] = None,
                 kms_key_id: Optional[pulumi.Input[builtins.str]] = None,
                 logical_cluster_enable: Optional[pulumi.Input[builtins.bool]] = None,
                 lts_enable: Optional[pulumi.Input[builtins.bool]] = None,
                 name: Optional[pulumi.Input[builtins.str]] = None,
                 network_id: Optional[pulumi.Input[builtins.str]] = None,
                 node_type: Optional[pulumi.Input[builtins.str]] = None,
                 number_of_cn: Optional[pulumi.Input[builtins.int]] = None,
                 number_of_node: Optional[pulumi.Input[builtins.int]] = None,
                 port: Optional[pulumi.Input[builtins.int]] = None,
                 public_ip: Optional[pulumi.Input[Union['DwsClusterPublicIpArgs', 'DwsClusterPublicIpArgsDict']]] = None,
                 region: Optional[pulumi.Input[builtins.str]] = None,
                 security_group_id: Optional[pulumi.Input[builtins.str]] = None,
                 tags: Optional[pulumi.Input[Mapping[str, pulumi.Input[builtins.str]]]] = None,
                 user_name: Optional[pulumi.Input[builtins.str]] = None,
                 user_pwd: Optional[pulumi.Input[builtins.str]] = None,
                 version: Optional[pulumi.Input[builtins.str]] = None,
                 volume: Optional[pulumi.Input[Union['DwsClusterVolumeArgs', 'DwsClusterVolumeArgsDict']]] = None,
                 vpc_id: Optional[pulumi.Input[builtins.str]] = None,
                 __props__=None):
        """
        Create a DwsCluster resource with the given unique name, props, and options.
        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[builtins.str] availability_zone: The availability zone in which to create the cluster instance.
        :param pulumi.Input[builtins.str] description: The description of the cluster.
        :param pulumi.Input[builtins.str] dss_pool_id: Dedicated storage pool ID.
        :param pulumi.Input[builtins.str] elb_id: The ID of the ELB load balancer.
        :param pulumi.Input[builtins.str] enterprise_project_id: The enterprise project ID.
        :param pulumi.Input[builtins.bool] force_backup: Whether to automatically execute snapshot when shrinking the number of nodes.
        :param pulumi.Input[builtins.int] keep_last_manual_snapshot: The number of latest manual snapshots that need to be retained when deleting the cluster.
        :param pulumi.Input[builtins.str] kms_key_id: The KMS key ID.
        :param pulumi.Input[builtins.bool] logical_cluster_enable: Whether to enable logical cluster.
        :param pulumi.Input[builtins.bool] lts_enable: Whether to enable LTS.
        :param pulumi.Input[builtins.str] name: The cluster name.
        :param pulumi.Input[builtins.str] network_id: The subnet ID.
        :param pulumi.Input[builtins.str] node_type: The flavor of the cluster.
        :param pulumi.Input[builtins.int] number_of_cn: schema: Required
        :param pulumi.Input[builtins.int] number_of_node: Number of nodes in a cluster.
        :param pulumi.Input[builtins.int] port: Service port of a cluster (8000 to 10000). The default value is 8000.
        :param pulumi.Input[builtins.str] security_group_id: The security group ID.
        :param pulumi.Input[Mapping[str, pulumi.Input[builtins.str]]] tags: The key/value pairs to associate with the cluster.
        :param pulumi.Input[builtins.str] user_name: Administrator username for logging in to a data warehouse cluster.
        :param pulumi.Input[builtins.str] user_pwd: Administrator password for logging in to a data warehouse cluster.
        :param pulumi.Input[builtins.str] version: schema: Required
        :param pulumi.Input[builtins.str] vpc_id: The VPC ID.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: DwsClusterArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Create a DwsCluster resource with the given unique name, props, and options.
        :param str resource_name: The name of the resource.
        :param DwsClusterArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(DwsClusterArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 availability_zone: Optional[pulumi.Input[builtins.str]] = None,
                 description: Optional[pulumi.Input[builtins.str]] = None,
                 dss_pool_id: Optional[pulumi.Input[builtins.str]] = None,
                 elb_id: Optional[pulumi.Input[builtins.str]] = None,
                 enterprise_project_id: Optional[pulumi.Input[builtins.str]] = None,
                 force_backup: Optional[pulumi.Input[builtins.bool]] = None,
                 keep_last_manual_snapshot: Optional[pulumi.Input[builtins.int]] = None,
                 kms_key_id: Optional[pulumi.Input[builtins.str]] = None,
                 logical_cluster_enable: Optional[pulumi.Input[builtins.bool]] = None,
                 lts_enable: Optional[pulumi.Input[builtins.bool]] = None,
                 name: Optional[pulumi.Input[builtins.str]] = None,
                 network_id: Optional[pulumi.Input[builtins.str]] = None,
                 node_type: Optional[pulumi.Input[builtins.str]] = None,
                 number_of_cn: Optional[pulumi.Input[builtins.int]] = None,
                 number_of_node: Optional[pulumi.Input[builtins.int]] = None,
                 port: Optional[pulumi.Input[builtins.int]] = None,
                 public_ip: Optional[pulumi.Input[Union['DwsClusterPublicIpArgs', 'DwsClusterPublicIpArgsDict']]] = None,
                 region: Optional[pulumi.Input[builtins.str]] = None,
                 security_group_id: Optional[pulumi.Input[builtins.str]] = None,
                 tags: Optional[pulumi.Input[Mapping[str, pulumi.Input[builtins.str]]]] = None,
                 user_name: Optional[pulumi.Input[builtins.str]] = None,
                 user_pwd: Optional[pulumi.Input[builtins.str]] = None,
                 version: Optional[pulumi.Input[builtins.str]] = None,
                 volume: Optional[pulumi.Input[Union['DwsClusterVolumeArgs', 'DwsClusterVolumeArgsDict']]] = None,
                 vpc_id: Optional[pulumi.Input[builtins.str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = DwsClusterArgs.__new__(DwsClusterArgs)

            if availability_zone is None and not opts.urn:
                raise TypeError("Missing required property 'availability_zone'")
            __props__.__dict__["availability_zone"] = availability_zone
            __props__.__dict__["description"] = description
            __props__.__dict__["dss_pool_id"] = dss_pool_id
            __props__.__dict__["elb_id"] = elb_id
            __props__.__dict__["enterprise_project_id"] = enterprise_project_id
            __props__.__dict__["force_backup"] = force_backup
            __props__.__dict__["keep_last_manual_snapshot"] = keep_last_manual_snapshot
            __props__.__dict__["kms_key_id"] = kms_key_id
            __props__.__dict__["logical_cluster_enable"] = logical_cluster_enable
            __props__.__dict__["lts_enable"] = lts_enable
            __props__.__dict__["name"] = name
            if network_id is None and not opts.urn:
                raise TypeError("Missing required property 'network_id'")
            __props__.__dict__["network_id"] = network_id
            if node_type is None and not opts.urn:
                raise TypeError("Missing required property 'node_type'")
            __props__.__dict__["node_type"] = node_type
            __props__.__dict__["number_of_cn"] = number_of_cn
            if number_of_node is None and not opts.urn:
                raise TypeError("Missing required property 'number_of_node'")
            __props__.__dict__["number_of_node"] = number_of_node
            __props__.__dict__["port"] = port
            __props__.__dict__["public_ip"] = public_ip
            __props__.__dict__["region"] = region
            if security_group_id is None and not opts.urn:
                raise TypeError("Missing required property 'security_group_id'")
            __props__.__dict__["security_group_id"] = security_group_id
            __props__.__dict__["tags"] = tags
            if user_name is None and not opts.urn:
                raise TypeError("Missing required property 'user_name'")
            __props__.__dict__["user_name"] = user_name
            if user_pwd is None and not opts.urn:
                raise TypeError("Missing required property 'user_pwd'")
            __props__.__dict__["user_pwd"] = None if user_pwd is None else pulumi.Output.secret(user_pwd)
            __props__.__dict__["version"] = version
            __props__.__dict__["volume"] = volume
            if vpc_id is None and not opts.urn:
                raise TypeError("Missing required property 'vpc_id'")
            __props__.__dict__["vpc_id"] = vpc_id
            __props__.__dict__["created"] = None
            __props__.__dict__["elbs"] = None
            __props__.__dict__["endpoints"] = None
            __props__.__dict__["maintain_windows"] = None
            __props__.__dict__["private_ips"] = None
            __props__.__dict__["public_endpoints"] = None
            __props__.__dict__["recent_event"] = None
            __props__.__dict__["status"] = None
            __props__.__dict__["sub_status"] = None
            __props__.__dict__["task_status"] = None
            __props__.__dict__["updated"] = None
        secret_opts = pulumi.ResourceOptions(additional_secret_outputs=["userPwd"])
        opts = pulumi.ResourceOptions.merge(opts, secret_opts)
        super(DwsCluster, __self__).__init__(
            'sbercloud:index/dwsCluster:DwsCluster',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            availability_zone: Optional[pulumi.Input[builtins.str]] = None,
            created: Optional[pulumi.Input[builtins.str]] = None,
            description: Optional[pulumi.Input[builtins.str]] = None,
            dss_pool_id: Optional[pulumi.Input[builtins.str]] = None,
            elb_id: Optional[pulumi.Input[builtins.str]] = None,
            elbs: Optional[pulumi.Input[Sequence[pulumi.Input[Union['DwsClusterElbArgs', 'DwsClusterElbArgsDict']]]]] = None,
            endpoints: Optional[pulumi.Input[Sequence[pulumi.Input[Union['DwsClusterEndpointArgs', 'DwsClusterEndpointArgsDict']]]]] = None,
            enterprise_project_id: Optional[pulumi.Input[builtins.str]] = None,
            force_backup: Optional[pulumi.Input[builtins.bool]] = None,
            keep_last_manual_snapshot: Optional[pulumi.Input[builtins.int]] = None,
            kms_key_id: Optional[pulumi.Input[builtins.str]] = None,
            logical_cluster_enable: Optional[pulumi.Input[builtins.bool]] = None,
            lts_enable: Optional[pulumi.Input[builtins.bool]] = None,
            maintain_windows: Optional[pulumi.Input[Sequence[pulumi.Input[Union['DwsClusterMaintainWindowArgs', 'DwsClusterMaintainWindowArgsDict']]]]] = None,
            name: Optional[pulumi.Input[builtins.str]] = None,
            network_id: Optional[pulumi.Input[builtins.str]] = None,
            node_type: Optional[pulumi.Input[builtins.str]] = None,
            number_of_cn: Optional[pulumi.Input[builtins.int]] = None,
            number_of_node: Optional[pulumi.Input[builtins.int]] = None,
            port: Optional[pulumi.Input[builtins.int]] = None,
            private_ips: Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]] = None,
            public_endpoints: Optional[pulumi.Input[Sequence[pulumi.Input[Union['DwsClusterPublicEndpointArgs', 'DwsClusterPublicEndpointArgsDict']]]]] = None,
            public_ip: Optional[pulumi.Input[Union['DwsClusterPublicIpArgs', 'DwsClusterPublicIpArgsDict']]] = None,
            recent_event: Optional[pulumi.Input[builtins.int]] = None,
            region: Optional[pulumi.Input[builtins.str]] = None,
            security_group_id: Optional[pulumi.Input[builtins.str]] = None,
            status: Optional[pulumi.Input[builtins.str]] = None,
            sub_status: Optional[pulumi.Input[builtins.str]] = None,
            tags: Optional[pulumi.Input[Mapping[str, pulumi.Input[builtins.str]]]] = None,
            task_status: Optional[pulumi.Input[builtins.str]] = None,
            updated: Optional[pulumi.Input[builtins.str]] = None,
            user_name: Optional[pulumi.Input[builtins.str]] = None,
            user_pwd: Optional[pulumi.Input[builtins.str]] = None,
            version: Optional[pulumi.Input[builtins.str]] = None,
            volume: Optional[pulumi.Input[Union['DwsClusterVolumeArgs', 'DwsClusterVolumeArgsDict']]] = None,
            vpc_id: Optional[pulumi.Input[builtins.str]] = None) -> 'DwsCluster':
        """
        Get an existing DwsCluster resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[builtins.str] availability_zone: The availability zone in which to create the cluster instance.
        :param pulumi.Input[builtins.str] created: The creation time of the cluster.
        :param pulumi.Input[builtins.str] description: The description of the cluster.
        :param pulumi.Input[builtins.str] dss_pool_id: Dedicated storage pool ID.
        :param pulumi.Input[builtins.str] elb_id: The ID of the ELB load balancer.
        :param pulumi.Input[Sequence[pulumi.Input[Union['DwsClusterElbArgs', 'DwsClusterElbArgsDict']]]] elbs: The ELB information bound to the cluster.
        :param pulumi.Input[Sequence[pulumi.Input[Union['DwsClusterEndpointArgs', 'DwsClusterEndpointArgsDict']]]] endpoints: Private network connection information about the cluster.
        :param pulumi.Input[builtins.str] enterprise_project_id: The enterprise project ID.
        :param pulumi.Input[builtins.bool] force_backup: Whether to automatically execute snapshot when shrinking the number of nodes.
        :param pulumi.Input[builtins.int] keep_last_manual_snapshot: The number of latest manual snapshots that need to be retained when deleting the cluster.
        :param pulumi.Input[builtins.str] kms_key_id: The KMS key ID.
        :param pulumi.Input[builtins.bool] logical_cluster_enable: Whether to enable logical cluster.
        :param pulumi.Input[builtins.bool] lts_enable: Whether to enable LTS.
        :param pulumi.Input[Sequence[pulumi.Input[Union['DwsClusterMaintainWindowArgs', 'DwsClusterMaintainWindowArgsDict']]]] maintain_windows: Cluster maintenance window.
        :param pulumi.Input[builtins.str] name: The cluster name.
        :param pulumi.Input[builtins.str] network_id: The subnet ID.
        :param pulumi.Input[builtins.str] node_type: The flavor of the cluster.
        :param pulumi.Input[builtins.int] number_of_cn: schema: Required
        :param pulumi.Input[builtins.int] number_of_node: Number of nodes in a cluster.
        :param pulumi.Input[builtins.int] port: Service port of a cluster (8000 to 10000). The default value is 8000.
        :param pulumi.Input[Sequence[pulumi.Input[builtins.str]]] private_ips: List of private network IP addresses.
        :param pulumi.Input[Sequence[pulumi.Input[Union['DwsClusterPublicEndpointArgs', 'DwsClusterPublicEndpointArgsDict']]]] public_endpoints: Public network connection information about the cluster.
        :param pulumi.Input[builtins.str] security_group_id: The security group ID.
        :param pulumi.Input[builtins.str] status: The cluster status.
        :param pulumi.Input[builtins.str] sub_status: Sub-status of clusters in the AVAILABLE state.
        :param pulumi.Input[Mapping[str, pulumi.Input[builtins.str]]] tags: The key/value pairs to associate with the cluster.
        :param pulumi.Input[builtins.str] task_status: Cluster management task.
        :param pulumi.Input[builtins.str] updated: The updated time of the cluster.
        :param pulumi.Input[builtins.str] user_name: Administrator username for logging in to a data warehouse cluster.
        :param pulumi.Input[builtins.str] user_pwd: Administrator password for logging in to a data warehouse cluster.
        :param pulumi.Input[builtins.str] version: schema: Required
        :param pulumi.Input[builtins.str] vpc_id: The VPC ID.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _DwsClusterState.__new__(_DwsClusterState)

        __props__.__dict__["availability_zone"] = availability_zone
        __props__.__dict__["created"] = created
        __props__.__dict__["description"] = description
        __props__.__dict__["dss_pool_id"] = dss_pool_id
        __props__.__dict__["elb_id"] = elb_id
        __props__.__dict__["elbs"] = elbs
        __props__.__dict__["endpoints"] = endpoints
        __props__.__dict__["enterprise_project_id"] = enterprise_project_id
        __props__.__dict__["force_backup"] = force_backup
        __props__.__dict__["keep_last_manual_snapshot"] = keep_last_manual_snapshot
        __props__.__dict__["kms_key_id"] = kms_key_id
        __props__.__dict__["logical_cluster_enable"] = logical_cluster_enable
        __props__.__dict__["lts_enable"] = lts_enable
        __props__.__dict__["maintain_windows"] = maintain_windows
        __props__.__dict__["name"] = name
        __props__.__dict__["network_id"] = network_id
        __props__.__dict__["node_type"] = node_type
        __props__.__dict__["number_of_cn"] = number_of_cn
        __props__.__dict__["number_of_node"] = number_of_node
        __props__.__dict__["port"] = port
        __props__.__dict__["private_ips"] = private_ips
        __props__.__dict__["public_endpoints"] = public_endpoints
        __props__.__dict__["public_ip"] = public_ip
        __props__.__dict__["recent_event"] = recent_event
        __props__.__dict__["region"] = region
        __props__.__dict__["security_group_id"] = security_group_id
        __props__.__dict__["status"] = status
        __props__.__dict__["sub_status"] = sub_status
        __props__.__dict__["tags"] = tags
        __props__.__dict__["task_status"] = task_status
        __props__.__dict__["updated"] = updated
        __props__.__dict__["user_name"] = user_name
        __props__.__dict__["user_pwd"] = user_pwd
        __props__.__dict__["version"] = version
        __props__.__dict__["volume"] = volume
        __props__.__dict__["vpc_id"] = vpc_id
        return DwsCluster(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="availabilityZone")
    def availability_zone(self) -> pulumi.Output[builtins.str]:
        """
        The availability zone in which to create the cluster instance.
        """
        return pulumi.get(self, "availability_zone")

    @property
    @pulumi.getter
    def created(self) -> pulumi.Output[builtins.str]:
        """
        The creation time of the cluster.
        """
        return pulumi.get(self, "created")

    @property
    @pulumi.getter
    def description(self) -> pulumi.Output[Optional[builtins.str]]:
        """
        The description of the cluster.
        """
        return pulumi.get(self, "description")

    @property
    @pulumi.getter(name="dssPoolId")
    def dss_pool_id(self) -> pulumi.Output[builtins.str]:
        """
        Dedicated storage pool ID.
        """
        return pulumi.get(self, "dss_pool_id")

    @property
    @pulumi.getter(name="elbId")
    def elb_id(self) -> pulumi.Output[Optional[builtins.str]]:
        """
        The ID of the ELB load balancer.
        """
        return pulumi.get(self, "elb_id")

    @property
    @pulumi.getter
    def elbs(self) -> pulumi.Output[Sequence['outputs.DwsClusterElb']]:
        """
        The ELB information bound to the cluster.
        """
        return pulumi.get(self, "elbs")

    @property
    @pulumi.getter
    def endpoints(self) -> pulumi.Output[Sequence['outputs.DwsClusterEndpoint']]:
        """
        Private network connection information about the cluster.
        """
        return pulumi.get(self, "endpoints")

    @property
    @pulumi.getter(name="enterpriseProjectId")
    def enterprise_project_id(self) -> pulumi.Output[builtins.str]:
        """
        The enterprise project ID.
        """
        return pulumi.get(self, "enterprise_project_id")

    @property
    @pulumi.getter(name="forceBackup")
    def force_backup(self) -> pulumi.Output[Optional[builtins.bool]]:
        """
        Whether to automatically execute snapshot when shrinking the number of nodes.
        """
        return pulumi.get(self, "force_backup")

    @property
    @pulumi.getter(name="keepLastManualSnapshot")
    def keep_last_manual_snapshot(self) -> pulumi.Output[Optional[builtins.int]]:
        """
        The number of latest manual snapshots that need to be retained when deleting the cluster.
        """
        return pulumi.get(self, "keep_last_manual_snapshot")

    @property
    @pulumi.getter(name="kmsKeyId")
    def kms_key_id(self) -> pulumi.Output[builtins.str]:
        """
        The KMS key ID.
        """
        return pulumi.get(self, "kms_key_id")

    @property
    @pulumi.getter(name="logicalClusterEnable")
    def logical_cluster_enable(self) -> pulumi.Output[Optional[builtins.bool]]:
        """
        Whether to enable logical cluster.
        """
        return pulumi.get(self, "logical_cluster_enable")

    @property
    @pulumi.getter(name="ltsEnable")
    def lts_enable(self) -> pulumi.Output[Optional[builtins.bool]]:
        """
        Whether to enable LTS.
        """
        return pulumi.get(self, "lts_enable")

    @property
    @pulumi.getter(name="maintainWindows")
    def maintain_windows(self) -> pulumi.Output[Sequence['outputs.DwsClusterMaintainWindow']]:
        """
        Cluster maintenance window.
        """
        return pulumi.get(self, "maintain_windows")

    @property
    @pulumi.getter
    def name(self) -> pulumi.Output[builtins.str]:
        """
        The cluster name.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="networkId")
    def network_id(self) -> pulumi.Output[builtins.str]:
        """
        The subnet ID.
        """
        return pulumi.get(self, "network_id")

    @property
    @pulumi.getter(name="nodeType")
    def node_type(self) -> pulumi.Output[builtins.str]:
        """
        The flavor of the cluster.
        """
        return pulumi.get(self, "node_type")

    @property
    @pulumi.getter(name="numberOfCn")
    def number_of_cn(self) -> pulumi.Output[Optional[builtins.int]]:
        """
        schema: Required
        """
        return pulumi.get(self, "number_of_cn")

    @property
    @pulumi.getter(name="numberOfNode")
    def number_of_node(self) -> pulumi.Output[builtins.int]:
        """
        Number of nodes in a cluster.
        """
        return pulumi.get(self, "number_of_node")

    @property
    @pulumi.getter
    def port(self) -> pulumi.Output[Optional[builtins.int]]:
        """
        Service port of a cluster (8000 to 10000). The default value is 8000.
        """
        return pulumi.get(self, "port")

    @property
    @pulumi.getter(name="privateIps")
    def private_ips(self) -> pulumi.Output[Sequence[builtins.str]]:
        """
        List of private network IP addresses.
        """
        return pulumi.get(self, "private_ips")

    @property
    @pulumi.getter(name="publicEndpoints")
    def public_endpoints(self) -> pulumi.Output[Sequence['outputs.DwsClusterPublicEndpoint']]:
        """
        Public network connection information about the cluster.
        """
        return pulumi.get(self, "public_endpoints")

    @property
    @pulumi.getter(name="publicIp")
    def public_ip(self) -> pulumi.Output['outputs.DwsClusterPublicIp']:
        return pulumi.get(self, "public_ip")

    @property
    @pulumi.getter(name="recentEvent")
    def recent_event(self) -> pulumi.Output[builtins.int]:
        return pulumi.get(self, "recent_event")

    @property
    @pulumi.getter
    def region(self) -> pulumi.Output[builtins.str]:
        return pulumi.get(self, "region")

    @property
    @pulumi.getter(name="securityGroupId")
    def security_group_id(self) -> pulumi.Output[builtins.str]:
        """
        The security group ID.
        """
        return pulumi.get(self, "security_group_id")

    @property
    @pulumi.getter
    def status(self) -> pulumi.Output[builtins.str]:
        """
        The cluster status.
        """
        return pulumi.get(self, "status")

    @property
    @pulumi.getter(name="subStatus")
    def sub_status(self) -> pulumi.Output[builtins.str]:
        """
        Sub-status of clusters in the AVAILABLE state.
        """
        return pulumi.get(self, "sub_status")

    @property
    @pulumi.getter
    def tags(self) -> pulumi.Output[Optional[Mapping[str, builtins.str]]]:
        """
        The key/value pairs to associate with the cluster.
        """
        return pulumi.get(self, "tags")

    @property
    @pulumi.getter(name="taskStatus")
    def task_status(self) -> pulumi.Output[builtins.str]:
        """
        Cluster management task.
        """
        return pulumi.get(self, "task_status")

    @property
    @pulumi.getter
    def updated(self) -> pulumi.Output[builtins.str]:
        """
        The updated time of the cluster.
        """
        return pulumi.get(self, "updated")

    @property
    @pulumi.getter(name="userName")
    def user_name(self) -> pulumi.Output[builtins.str]:
        """
        Administrator username for logging in to a data warehouse cluster.
        """
        return pulumi.get(self, "user_name")

    @property
    @pulumi.getter(name="userPwd")
    def user_pwd(self) -> pulumi.Output[builtins.str]:
        """
        Administrator password for logging in to a data warehouse cluster.
        """
        return pulumi.get(self, "user_pwd")

    @property
    @pulumi.getter
    def version(self) -> pulumi.Output[builtins.str]:
        """
        schema: Required
        """
        return pulumi.get(self, "version")

    @property
    @pulumi.getter
    def volume(self) -> pulumi.Output['outputs.DwsClusterVolume']:
        return pulumi.get(self, "volume")

    @property
    @pulumi.getter(name="vpcId")
    def vpc_id(self) -> pulumi.Output[builtins.str]:
        """
        The VPC ID.
        """
        return pulumi.get(self, "vpc_id")

