# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from . import _utilities
from . import outputs

__all__ = [
    'GetDwsFlavorsResult',
    'AwaitableGetDwsFlavorsResult',
    'get_dws_flavors',
    'get_dws_flavors_output',
]

@pulumi.output_type
class GetDwsFlavorsResult:
    """
    A collection of values returned by getDwsFlavors.
    """
    def __init__(__self__, availability_zone=None, datastore_type=None, flavors=None, id=None, memory=None, region=None, vcpus=None):
        if availability_zone and not isinstance(availability_zone, str):
            raise TypeError("Expected argument 'availability_zone' to be a str")
        pulumi.set(__self__, "availability_zone", availability_zone)
        if datastore_type and not isinstance(datastore_type, str):
            raise TypeError("Expected argument 'datastore_type' to be a str")
        pulumi.set(__self__, "datastore_type", datastore_type)
        if flavors and not isinstance(flavors, list):
            raise TypeError("Expected argument 'flavors' to be a list")
        pulumi.set(__self__, "flavors", flavors)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if memory and not isinstance(memory, int):
            raise TypeError("Expected argument 'memory' to be a int")
        pulumi.set(__self__, "memory", memory)
        if region and not isinstance(region, str):
            raise TypeError("Expected argument 'region' to be a str")
        pulumi.set(__self__, "region", region)
        if vcpus and not isinstance(vcpus, int):
            raise TypeError("Expected argument 'vcpus' to be a int")
        pulumi.set(__self__, "vcpus", vcpus)

    @property
    @pulumi.getter(name="availabilityZone")
    def availability_zone(self) -> Optional[builtins.str]:
        return pulumi.get(self, "availability_zone")

    @property
    @pulumi.getter(name="datastoreType")
    def datastore_type(self) -> Optional[builtins.str]:
        return pulumi.get(self, "datastore_type")

    @property
    @pulumi.getter
    def flavors(self) -> Sequence['outputs.GetDwsFlavorsFlavorResult']:
        return pulumi.get(self, "flavors")

    @property
    @pulumi.getter
    def id(self) -> builtins.str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def memory(self) -> Optional[builtins.int]:
        return pulumi.get(self, "memory")

    @property
    @pulumi.getter
    def region(self) -> builtins.str:
        return pulumi.get(self, "region")

    @property
    @pulumi.getter
    def vcpus(self) -> Optional[builtins.int]:
        return pulumi.get(self, "vcpus")


class AwaitableGetDwsFlavorsResult(GetDwsFlavorsResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetDwsFlavorsResult(
            availability_zone=self.availability_zone,
            datastore_type=self.datastore_type,
            flavors=self.flavors,
            id=self.id,
            memory=self.memory,
            region=self.region,
            vcpus=self.vcpus)


def get_dws_flavors(availability_zone: Optional[builtins.str] = None,
                    datastore_type: Optional[builtins.str] = None,
                    memory: Optional[builtins.int] = None,
                    region: Optional[builtins.str] = None,
                    vcpus: Optional[builtins.int] = None,
                    opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetDwsFlavorsResult:
    """
    Use this data source to access information about an existing resource.
    """
    __args__ = dict()
    __args__['availabilityZone'] = availability_zone
    __args__['datastoreType'] = datastore_type
    __args__['memory'] = memory
    __args__['region'] = region
    __args__['vcpus'] = vcpus
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('sbercloud:index/getDwsFlavors:getDwsFlavors', __args__, opts=opts, typ=GetDwsFlavorsResult).value

    return AwaitableGetDwsFlavorsResult(
        availability_zone=pulumi.get(__ret__, 'availability_zone'),
        datastore_type=pulumi.get(__ret__, 'datastore_type'),
        flavors=pulumi.get(__ret__, 'flavors'),
        id=pulumi.get(__ret__, 'id'),
        memory=pulumi.get(__ret__, 'memory'),
        region=pulumi.get(__ret__, 'region'),
        vcpus=pulumi.get(__ret__, 'vcpus'))
def get_dws_flavors_output(availability_zone: Optional[pulumi.Input[Optional[builtins.str]]] = None,
                           datastore_type: Optional[pulumi.Input[Optional[builtins.str]]] = None,
                           memory: Optional[pulumi.Input[Optional[builtins.int]]] = None,
                           region: Optional[pulumi.Input[Optional[builtins.str]]] = None,
                           vcpus: Optional[pulumi.Input[Optional[builtins.int]]] = None,
                           opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[GetDwsFlavorsResult]:
    """
    Use this data source to access information about an existing resource.
    """
    __args__ = dict()
    __args__['availabilityZone'] = availability_zone
    __args__['datastoreType'] = datastore_type
    __args__['memory'] = memory
    __args__['region'] = region
    __args__['vcpus'] = vcpus
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('sbercloud:index/getDwsFlavors:getDwsFlavors', __args__, opts=opts, typ=GetDwsFlavorsResult)
    return __ret__.apply(lambda __response__: GetDwsFlavorsResult(
        availability_zone=pulumi.get(__response__, 'availability_zone'),
        datastore_type=pulumi.get(__response__, 'datastore_type'),
        flavors=pulumi.get(__response__, 'flavors'),
        id=pulumi.get(__response__, 'id'),
        memory=pulumi.get(__response__, 'memory'),
        region=pulumi.get(__response__, 'region'),
        vcpus=pulumi.get(__response__, 'vcpus')))
