# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from . import _utilities
from . import outputs
from ._inputs import *

__all__ = ['RdsPgHbaArgs', 'RdsPgHba']

@pulumi.input_type
class RdsPgHbaArgs:
    def __init__(__self__, *,
                 host_based_authentications: pulumi.Input[Sequence[pulumi.Input['RdsPgHbaHostBasedAuthenticationArgs']]],
                 instance_id: pulumi.Input[builtins.str],
                 region: Optional[pulumi.Input[builtins.str]] = None):
        """
        The set of arguments for constructing a RdsPgHba resource.
        :param pulumi.Input[Sequence[pulumi.Input['RdsPgHbaHostBasedAuthenticationArgs']]] host_based_authentications: Specifies the list of host based authentications.
        :param pulumi.Input[builtins.str] instance_id: Specifies the ID of the RDS PostgreSQL instance.
        """
        pulumi.set(__self__, "host_based_authentications", host_based_authentications)
        pulumi.set(__self__, "instance_id", instance_id)
        if region is not None:
            pulumi.set(__self__, "region", region)

    @property
    @pulumi.getter(name="hostBasedAuthentications")
    def host_based_authentications(self) -> pulumi.Input[Sequence[pulumi.Input['RdsPgHbaHostBasedAuthenticationArgs']]]:
        """
        Specifies the list of host based authentications.
        """
        return pulumi.get(self, "host_based_authentications")

    @host_based_authentications.setter
    def host_based_authentications(self, value: pulumi.Input[Sequence[pulumi.Input['RdsPgHbaHostBasedAuthenticationArgs']]]):
        pulumi.set(self, "host_based_authentications", value)

    @property
    @pulumi.getter(name="instanceId")
    def instance_id(self) -> pulumi.Input[builtins.str]:
        """
        Specifies the ID of the RDS PostgreSQL instance.
        """
        return pulumi.get(self, "instance_id")

    @instance_id.setter
    def instance_id(self, value: pulumi.Input[builtins.str]):
        pulumi.set(self, "instance_id", value)

    @property
    @pulumi.getter
    def region(self) -> Optional[pulumi.Input[builtins.str]]:
        return pulumi.get(self, "region")

    @region.setter
    def region(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "region", value)


@pulumi.input_type
class _RdsPgHbaState:
    def __init__(__self__, *,
                 host_based_authentications: Optional[pulumi.Input[Sequence[pulumi.Input['RdsPgHbaHostBasedAuthenticationArgs']]]] = None,
                 instance_id: Optional[pulumi.Input[builtins.str]] = None,
                 region: Optional[pulumi.Input[builtins.str]] = None):
        """
        Input properties used for looking up and filtering RdsPgHba resources.
        :param pulumi.Input[Sequence[pulumi.Input['RdsPgHbaHostBasedAuthenticationArgs']]] host_based_authentications: Specifies the list of host based authentications.
        :param pulumi.Input[builtins.str] instance_id: Specifies the ID of the RDS PostgreSQL instance.
        """
        if host_based_authentications is not None:
            pulumi.set(__self__, "host_based_authentications", host_based_authentications)
        if instance_id is not None:
            pulumi.set(__self__, "instance_id", instance_id)
        if region is not None:
            pulumi.set(__self__, "region", region)

    @property
    @pulumi.getter(name="hostBasedAuthentications")
    def host_based_authentications(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['RdsPgHbaHostBasedAuthenticationArgs']]]]:
        """
        Specifies the list of host based authentications.
        """
        return pulumi.get(self, "host_based_authentications")

    @host_based_authentications.setter
    def host_based_authentications(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['RdsPgHbaHostBasedAuthenticationArgs']]]]):
        pulumi.set(self, "host_based_authentications", value)

    @property
    @pulumi.getter(name="instanceId")
    def instance_id(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        Specifies the ID of the RDS PostgreSQL instance.
        """
        return pulumi.get(self, "instance_id")

    @instance_id.setter
    def instance_id(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "instance_id", value)

    @property
    @pulumi.getter
    def region(self) -> Optional[pulumi.Input[builtins.str]]:
        return pulumi.get(self, "region")

    @region.setter
    def region(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "region", value)


class RdsPgHba(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 host_based_authentications: Optional[pulumi.Input[Sequence[pulumi.Input[Union['RdsPgHbaHostBasedAuthenticationArgs', 'RdsPgHbaHostBasedAuthenticationArgsDict']]]]] = None,
                 instance_id: Optional[pulumi.Input[builtins.str]] = None,
                 region: Optional[pulumi.Input[builtins.str]] = None,
                 __props__=None):
        """
        Create a RdsPgHba resource with the given unique name, props, and options.
        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[Sequence[pulumi.Input[Union['RdsPgHbaHostBasedAuthenticationArgs', 'RdsPgHbaHostBasedAuthenticationArgsDict']]]] host_based_authentications: Specifies the list of host based authentications.
        :param pulumi.Input[builtins.str] instance_id: Specifies the ID of the RDS PostgreSQL instance.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: RdsPgHbaArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Create a RdsPgHba resource with the given unique name, props, and options.
        :param str resource_name: The name of the resource.
        :param RdsPgHbaArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(RdsPgHbaArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 host_based_authentications: Optional[pulumi.Input[Sequence[pulumi.Input[Union['RdsPgHbaHostBasedAuthenticationArgs', 'RdsPgHbaHostBasedAuthenticationArgsDict']]]]] = None,
                 instance_id: Optional[pulumi.Input[builtins.str]] = None,
                 region: Optional[pulumi.Input[builtins.str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = RdsPgHbaArgs.__new__(RdsPgHbaArgs)

            if host_based_authentications is None and not opts.urn:
                raise TypeError("Missing required property 'host_based_authentications'")
            __props__.__dict__["host_based_authentications"] = host_based_authentications
            if instance_id is None and not opts.urn:
                raise TypeError("Missing required property 'instance_id'")
            __props__.__dict__["instance_id"] = instance_id
            __props__.__dict__["region"] = region
        super(RdsPgHba, __self__).__init__(
            'sbercloud:index/rdsPgHba:RdsPgHba',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            host_based_authentications: Optional[pulumi.Input[Sequence[pulumi.Input[Union['RdsPgHbaHostBasedAuthenticationArgs', 'RdsPgHbaHostBasedAuthenticationArgsDict']]]]] = None,
            instance_id: Optional[pulumi.Input[builtins.str]] = None,
            region: Optional[pulumi.Input[builtins.str]] = None) -> 'RdsPgHba':
        """
        Get an existing RdsPgHba resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[Sequence[pulumi.Input[Union['RdsPgHbaHostBasedAuthenticationArgs', 'RdsPgHbaHostBasedAuthenticationArgsDict']]]] host_based_authentications: Specifies the list of host based authentications.
        :param pulumi.Input[builtins.str] instance_id: Specifies the ID of the RDS PostgreSQL instance.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _RdsPgHbaState.__new__(_RdsPgHbaState)

        __props__.__dict__["host_based_authentications"] = host_based_authentications
        __props__.__dict__["instance_id"] = instance_id
        __props__.__dict__["region"] = region
        return RdsPgHba(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="hostBasedAuthentications")
    def host_based_authentications(self) -> pulumi.Output[Sequence['outputs.RdsPgHbaHostBasedAuthentication']]:
        """
        Specifies the list of host based authentications.
        """
        return pulumi.get(self, "host_based_authentications")

    @property
    @pulumi.getter(name="instanceId")
    def instance_id(self) -> pulumi.Output[builtins.str]:
        """
        Specifies the ID of the RDS PostgreSQL instance.
        """
        return pulumi.get(self, "instance_id")

    @property
    @pulumi.getter
    def region(self) -> pulumi.Output[builtins.str]:
        return pulumi.get(self, "region")

