# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from . import _utilities
from . import outputs
from ._inputs import *

__all__ = ['RdsSqlserverDatabasePrivilegeArgs', 'RdsSqlserverDatabasePrivilege']

@pulumi.input_type
class RdsSqlserverDatabasePrivilegeArgs:
    def __init__(__self__, *,
                 db_name: pulumi.Input[builtins.str],
                 instance_id: pulumi.Input[builtins.str],
                 users: pulumi.Input[Sequence[pulumi.Input['RdsSqlserverDatabasePrivilegeUserArgs']]],
                 region: Optional[pulumi.Input[builtins.str]] = None):
        """
        The set of arguments for constructing a RdsSqlserverDatabasePrivilege resource.
        :param pulumi.Input[builtins.str] db_name: Specifies the database name.
        :param pulumi.Input[builtins.str] instance_id: Specifies the ID of the RDS SQL Server instance.
        :param pulumi.Input[Sequence[pulumi.Input['RdsSqlserverDatabasePrivilegeUserArgs']]] users: Specifies the account that associated with the database
        """
        pulumi.set(__self__, "db_name", db_name)
        pulumi.set(__self__, "instance_id", instance_id)
        pulumi.set(__self__, "users", users)
        if region is not None:
            pulumi.set(__self__, "region", region)

    @property
    @pulumi.getter(name="dbName")
    def db_name(self) -> pulumi.Input[builtins.str]:
        """
        Specifies the database name.
        """
        return pulumi.get(self, "db_name")

    @db_name.setter
    def db_name(self, value: pulumi.Input[builtins.str]):
        pulumi.set(self, "db_name", value)

    @property
    @pulumi.getter(name="instanceId")
    def instance_id(self) -> pulumi.Input[builtins.str]:
        """
        Specifies the ID of the RDS SQL Server instance.
        """
        return pulumi.get(self, "instance_id")

    @instance_id.setter
    def instance_id(self, value: pulumi.Input[builtins.str]):
        pulumi.set(self, "instance_id", value)

    @property
    @pulumi.getter
    def users(self) -> pulumi.Input[Sequence[pulumi.Input['RdsSqlserverDatabasePrivilegeUserArgs']]]:
        """
        Specifies the account that associated with the database
        """
        return pulumi.get(self, "users")

    @users.setter
    def users(self, value: pulumi.Input[Sequence[pulumi.Input['RdsSqlserverDatabasePrivilegeUserArgs']]]):
        pulumi.set(self, "users", value)

    @property
    @pulumi.getter
    def region(self) -> Optional[pulumi.Input[builtins.str]]:
        return pulumi.get(self, "region")

    @region.setter
    def region(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "region", value)


@pulumi.input_type
class _RdsSqlserverDatabasePrivilegeState:
    def __init__(__self__, *,
                 db_name: Optional[pulumi.Input[builtins.str]] = None,
                 instance_id: Optional[pulumi.Input[builtins.str]] = None,
                 region: Optional[pulumi.Input[builtins.str]] = None,
                 users: Optional[pulumi.Input[Sequence[pulumi.Input['RdsSqlserverDatabasePrivilegeUserArgs']]]] = None):
        """
        Input properties used for looking up and filtering RdsSqlserverDatabasePrivilege resources.
        :param pulumi.Input[builtins.str] db_name: Specifies the database name.
        :param pulumi.Input[builtins.str] instance_id: Specifies the ID of the RDS SQL Server instance.
        :param pulumi.Input[Sequence[pulumi.Input['RdsSqlserverDatabasePrivilegeUserArgs']]] users: Specifies the account that associated with the database
        """
        if db_name is not None:
            pulumi.set(__self__, "db_name", db_name)
        if instance_id is not None:
            pulumi.set(__self__, "instance_id", instance_id)
        if region is not None:
            pulumi.set(__self__, "region", region)
        if users is not None:
            pulumi.set(__self__, "users", users)

    @property
    @pulumi.getter(name="dbName")
    def db_name(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        Specifies the database name.
        """
        return pulumi.get(self, "db_name")

    @db_name.setter
    def db_name(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "db_name", value)

    @property
    @pulumi.getter(name="instanceId")
    def instance_id(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        Specifies the ID of the RDS SQL Server instance.
        """
        return pulumi.get(self, "instance_id")

    @instance_id.setter
    def instance_id(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "instance_id", value)

    @property
    @pulumi.getter
    def region(self) -> Optional[pulumi.Input[builtins.str]]:
        return pulumi.get(self, "region")

    @region.setter
    def region(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "region", value)

    @property
    @pulumi.getter
    def users(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['RdsSqlserverDatabasePrivilegeUserArgs']]]]:
        """
        Specifies the account that associated with the database
        """
        return pulumi.get(self, "users")

    @users.setter
    def users(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['RdsSqlserverDatabasePrivilegeUserArgs']]]]):
        pulumi.set(self, "users", value)


class RdsSqlserverDatabasePrivilege(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 db_name: Optional[pulumi.Input[builtins.str]] = None,
                 instance_id: Optional[pulumi.Input[builtins.str]] = None,
                 region: Optional[pulumi.Input[builtins.str]] = None,
                 users: Optional[pulumi.Input[Sequence[pulumi.Input[Union['RdsSqlserverDatabasePrivilegeUserArgs', 'RdsSqlserverDatabasePrivilegeUserArgsDict']]]]] = None,
                 __props__=None):
        """
        Create a RdsSqlserverDatabasePrivilege resource with the given unique name, props, and options.
        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[builtins.str] db_name: Specifies the database name.
        :param pulumi.Input[builtins.str] instance_id: Specifies the ID of the RDS SQL Server instance.
        :param pulumi.Input[Sequence[pulumi.Input[Union['RdsSqlserverDatabasePrivilegeUserArgs', 'RdsSqlserverDatabasePrivilegeUserArgsDict']]]] users: Specifies the account that associated with the database
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: RdsSqlserverDatabasePrivilegeArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Create a RdsSqlserverDatabasePrivilege resource with the given unique name, props, and options.
        :param str resource_name: The name of the resource.
        :param RdsSqlserverDatabasePrivilegeArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(RdsSqlserverDatabasePrivilegeArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 db_name: Optional[pulumi.Input[builtins.str]] = None,
                 instance_id: Optional[pulumi.Input[builtins.str]] = None,
                 region: Optional[pulumi.Input[builtins.str]] = None,
                 users: Optional[pulumi.Input[Sequence[pulumi.Input[Union['RdsSqlserverDatabasePrivilegeUserArgs', 'RdsSqlserverDatabasePrivilegeUserArgsDict']]]]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = RdsSqlserverDatabasePrivilegeArgs.__new__(RdsSqlserverDatabasePrivilegeArgs)

            if db_name is None and not opts.urn:
                raise TypeError("Missing required property 'db_name'")
            __props__.__dict__["db_name"] = db_name
            if instance_id is None and not opts.urn:
                raise TypeError("Missing required property 'instance_id'")
            __props__.__dict__["instance_id"] = instance_id
            __props__.__dict__["region"] = region
            if users is None and not opts.urn:
                raise TypeError("Missing required property 'users'")
            __props__.__dict__["users"] = users
        super(RdsSqlserverDatabasePrivilege, __self__).__init__(
            'sbercloud:index/rdsSqlserverDatabasePrivilege:RdsSqlserverDatabasePrivilege',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            db_name: Optional[pulumi.Input[builtins.str]] = None,
            instance_id: Optional[pulumi.Input[builtins.str]] = None,
            region: Optional[pulumi.Input[builtins.str]] = None,
            users: Optional[pulumi.Input[Sequence[pulumi.Input[Union['RdsSqlserverDatabasePrivilegeUserArgs', 'RdsSqlserverDatabasePrivilegeUserArgsDict']]]]] = None) -> 'RdsSqlserverDatabasePrivilege':
        """
        Get an existing RdsSqlserverDatabasePrivilege resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[builtins.str] db_name: Specifies the database name.
        :param pulumi.Input[builtins.str] instance_id: Specifies the ID of the RDS SQL Server instance.
        :param pulumi.Input[Sequence[pulumi.Input[Union['RdsSqlserverDatabasePrivilegeUserArgs', 'RdsSqlserverDatabasePrivilegeUserArgsDict']]]] users: Specifies the account that associated with the database
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _RdsSqlserverDatabasePrivilegeState.__new__(_RdsSqlserverDatabasePrivilegeState)

        __props__.__dict__["db_name"] = db_name
        __props__.__dict__["instance_id"] = instance_id
        __props__.__dict__["region"] = region
        __props__.__dict__["users"] = users
        return RdsSqlserverDatabasePrivilege(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="dbName")
    def db_name(self) -> pulumi.Output[builtins.str]:
        """
        Specifies the database name.
        """
        return pulumi.get(self, "db_name")

    @property
    @pulumi.getter(name="instanceId")
    def instance_id(self) -> pulumi.Output[builtins.str]:
        """
        Specifies the ID of the RDS SQL Server instance.
        """
        return pulumi.get(self, "instance_id")

    @property
    @pulumi.getter
    def region(self) -> pulumi.Output[builtins.str]:
        return pulumi.get(self, "region")

    @property
    @pulumi.getter
    def users(self) -> pulumi.Output[Sequence['outputs.RdsSqlserverDatabasePrivilegeUser']]:
        """
        Specifies the account that associated with the database
        """
        return pulumi.get(self, "users")

