# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from . import _utilities
from . import outputs
from ._inputs import *

__all__ = ['SmnSubscriptionArgs', 'SmnSubscription']

@pulumi.input_type
class SmnSubscriptionArgs:
    def __init__(__self__, *,
                 endpoint: pulumi.Input[builtins.str],
                 protocol: pulumi.Input[builtins.str],
                 topic_urn: pulumi.Input[builtins.str],
                 extension: Optional[pulumi.Input['SmnSubscriptionExtensionArgs']] = None,
                 region: Optional[pulumi.Input[builtins.str]] = None,
                 remark: Optional[pulumi.Input[builtins.str]] = None):
        """
        The set of arguments for constructing a SmnSubscription resource.
        """
        pulumi.set(__self__, "endpoint", endpoint)
        pulumi.set(__self__, "protocol", protocol)
        pulumi.set(__self__, "topic_urn", topic_urn)
        if extension is not None:
            pulumi.set(__self__, "extension", extension)
        if region is not None:
            pulumi.set(__self__, "region", region)
        if remark is not None:
            pulumi.set(__self__, "remark", remark)

    @property
    @pulumi.getter
    def endpoint(self) -> pulumi.Input[builtins.str]:
        return pulumi.get(self, "endpoint")

    @endpoint.setter
    def endpoint(self, value: pulumi.Input[builtins.str]):
        pulumi.set(self, "endpoint", value)

    @property
    @pulumi.getter
    def protocol(self) -> pulumi.Input[builtins.str]:
        return pulumi.get(self, "protocol")

    @protocol.setter
    def protocol(self, value: pulumi.Input[builtins.str]):
        pulumi.set(self, "protocol", value)

    @property
    @pulumi.getter(name="topicUrn")
    def topic_urn(self) -> pulumi.Input[builtins.str]:
        return pulumi.get(self, "topic_urn")

    @topic_urn.setter
    def topic_urn(self, value: pulumi.Input[builtins.str]):
        pulumi.set(self, "topic_urn", value)

    @property
    @pulumi.getter
    def extension(self) -> Optional[pulumi.Input['SmnSubscriptionExtensionArgs']]:
        return pulumi.get(self, "extension")

    @extension.setter
    def extension(self, value: Optional[pulumi.Input['SmnSubscriptionExtensionArgs']]):
        pulumi.set(self, "extension", value)

    @property
    @pulumi.getter
    def region(self) -> Optional[pulumi.Input[builtins.str]]:
        return pulumi.get(self, "region")

    @region.setter
    def region(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "region", value)

    @property
    @pulumi.getter
    def remark(self) -> Optional[pulumi.Input[builtins.str]]:
        return pulumi.get(self, "remark")

    @remark.setter
    def remark(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "remark", value)


@pulumi.input_type
class _SmnSubscriptionState:
    def __init__(__self__, *,
                 endpoint: Optional[pulumi.Input[builtins.str]] = None,
                 extension: Optional[pulumi.Input['SmnSubscriptionExtensionArgs']] = None,
                 filter_policies: Optional[pulumi.Input[Sequence[pulumi.Input['SmnSubscriptionFilterPolicyArgs']]]] = None,
                 owner: Optional[pulumi.Input[builtins.str]] = None,
                 protocol: Optional[pulumi.Input[builtins.str]] = None,
                 region: Optional[pulumi.Input[builtins.str]] = None,
                 remark: Optional[pulumi.Input[builtins.str]] = None,
                 status: Optional[pulumi.Input[builtins.int]] = None,
                 subscription_urn: Optional[pulumi.Input[builtins.str]] = None,
                 topic_urn: Optional[pulumi.Input[builtins.str]] = None):
        """
        Input properties used for looking up and filtering SmnSubscription resources.
        :param pulumi.Input[Sequence[pulumi.Input['SmnSubscriptionFilterPolicyArgs']]] filter_policies: The message filter policies of a subscriber.
        """
        if endpoint is not None:
            pulumi.set(__self__, "endpoint", endpoint)
        if extension is not None:
            pulumi.set(__self__, "extension", extension)
        if filter_policies is not None:
            pulumi.set(__self__, "filter_policies", filter_policies)
        if owner is not None:
            pulumi.set(__self__, "owner", owner)
        if protocol is not None:
            pulumi.set(__self__, "protocol", protocol)
        if region is not None:
            pulumi.set(__self__, "region", region)
        if remark is not None:
            pulumi.set(__self__, "remark", remark)
        if status is not None:
            pulumi.set(__self__, "status", status)
        if subscription_urn is not None:
            pulumi.set(__self__, "subscription_urn", subscription_urn)
        if topic_urn is not None:
            pulumi.set(__self__, "topic_urn", topic_urn)

    @property
    @pulumi.getter
    def endpoint(self) -> Optional[pulumi.Input[builtins.str]]:
        return pulumi.get(self, "endpoint")

    @endpoint.setter
    def endpoint(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "endpoint", value)

    @property
    @pulumi.getter
    def extension(self) -> Optional[pulumi.Input['SmnSubscriptionExtensionArgs']]:
        return pulumi.get(self, "extension")

    @extension.setter
    def extension(self, value: Optional[pulumi.Input['SmnSubscriptionExtensionArgs']]):
        pulumi.set(self, "extension", value)

    @property
    @pulumi.getter(name="filterPolicies")
    def filter_policies(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['SmnSubscriptionFilterPolicyArgs']]]]:
        """
        The message filter policies of a subscriber.
        """
        return pulumi.get(self, "filter_policies")

    @filter_policies.setter
    def filter_policies(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['SmnSubscriptionFilterPolicyArgs']]]]):
        pulumi.set(self, "filter_policies", value)

    @property
    @pulumi.getter
    def owner(self) -> Optional[pulumi.Input[builtins.str]]:
        return pulumi.get(self, "owner")

    @owner.setter
    def owner(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "owner", value)

    @property
    @pulumi.getter
    def protocol(self) -> Optional[pulumi.Input[builtins.str]]:
        return pulumi.get(self, "protocol")

    @protocol.setter
    def protocol(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "protocol", value)

    @property
    @pulumi.getter
    def region(self) -> Optional[pulumi.Input[builtins.str]]:
        return pulumi.get(self, "region")

    @region.setter
    def region(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "region", value)

    @property
    @pulumi.getter
    def remark(self) -> Optional[pulumi.Input[builtins.str]]:
        return pulumi.get(self, "remark")

    @remark.setter
    def remark(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "remark", value)

    @property
    @pulumi.getter
    def status(self) -> Optional[pulumi.Input[builtins.int]]:
        return pulumi.get(self, "status")

    @status.setter
    def status(self, value: Optional[pulumi.Input[builtins.int]]):
        pulumi.set(self, "status", value)

    @property
    @pulumi.getter(name="subscriptionUrn")
    def subscription_urn(self) -> Optional[pulumi.Input[builtins.str]]:
        return pulumi.get(self, "subscription_urn")

    @subscription_urn.setter
    def subscription_urn(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "subscription_urn", value)

    @property
    @pulumi.getter(name="topicUrn")
    def topic_urn(self) -> Optional[pulumi.Input[builtins.str]]:
        return pulumi.get(self, "topic_urn")

    @topic_urn.setter
    def topic_urn(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "topic_urn", value)


class SmnSubscription(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 endpoint: Optional[pulumi.Input[builtins.str]] = None,
                 extension: Optional[pulumi.Input[Union['SmnSubscriptionExtensionArgs', 'SmnSubscriptionExtensionArgsDict']]] = None,
                 protocol: Optional[pulumi.Input[builtins.str]] = None,
                 region: Optional[pulumi.Input[builtins.str]] = None,
                 remark: Optional[pulumi.Input[builtins.str]] = None,
                 topic_urn: Optional[pulumi.Input[builtins.str]] = None,
                 __props__=None):
        """
        Create a SmnSubscription resource with the given unique name, props, and options.
        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: SmnSubscriptionArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Create a SmnSubscription resource with the given unique name, props, and options.
        :param str resource_name: The name of the resource.
        :param SmnSubscriptionArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(SmnSubscriptionArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 endpoint: Optional[pulumi.Input[builtins.str]] = None,
                 extension: Optional[pulumi.Input[Union['SmnSubscriptionExtensionArgs', 'SmnSubscriptionExtensionArgsDict']]] = None,
                 protocol: Optional[pulumi.Input[builtins.str]] = None,
                 region: Optional[pulumi.Input[builtins.str]] = None,
                 remark: Optional[pulumi.Input[builtins.str]] = None,
                 topic_urn: Optional[pulumi.Input[builtins.str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = SmnSubscriptionArgs.__new__(SmnSubscriptionArgs)

            if endpoint is None and not opts.urn:
                raise TypeError("Missing required property 'endpoint'")
            __props__.__dict__["endpoint"] = endpoint
            __props__.__dict__["extension"] = extension
            if protocol is None and not opts.urn:
                raise TypeError("Missing required property 'protocol'")
            __props__.__dict__["protocol"] = protocol
            __props__.__dict__["region"] = region
            __props__.__dict__["remark"] = remark
            if topic_urn is None and not opts.urn:
                raise TypeError("Missing required property 'topic_urn'")
            __props__.__dict__["topic_urn"] = topic_urn
            __props__.__dict__["filter_policies"] = None
            __props__.__dict__["owner"] = None
            __props__.__dict__["status"] = None
            __props__.__dict__["subscription_urn"] = None
        super(SmnSubscription, __self__).__init__(
            'sbercloud:index/smnSubscription:SmnSubscription',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            endpoint: Optional[pulumi.Input[builtins.str]] = None,
            extension: Optional[pulumi.Input[Union['SmnSubscriptionExtensionArgs', 'SmnSubscriptionExtensionArgsDict']]] = None,
            filter_policies: Optional[pulumi.Input[Sequence[pulumi.Input[Union['SmnSubscriptionFilterPolicyArgs', 'SmnSubscriptionFilterPolicyArgsDict']]]]] = None,
            owner: Optional[pulumi.Input[builtins.str]] = None,
            protocol: Optional[pulumi.Input[builtins.str]] = None,
            region: Optional[pulumi.Input[builtins.str]] = None,
            remark: Optional[pulumi.Input[builtins.str]] = None,
            status: Optional[pulumi.Input[builtins.int]] = None,
            subscription_urn: Optional[pulumi.Input[builtins.str]] = None,
            topic_urn: Optional[pulumi.Input[builtins.str]] = None) -> 'SmnSubscription':
        """
        Get an existing SmnSubscription resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[Sequence[pulumi.Input[Union['SmnSubscriptionFilterPolicyArgs', 'SmnSubscriptionFilterPolicyArgsDict']]]] filter_policies: The message filter policies of a subscriber.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _SmnSubscriptionState.__new__(_SmnSubscriptionState)

        __props__.__dict__["endpoint"] = endpoint
        __props__.__dict__["extension"] = extension
        __props__.__dict__["filter_policies"] = filter_policies
        __props__.__dict__["owner"] = owner
        __props__.__dict__["protocol"] = protocol
        __props__.__dict__["region"] = region
        __props__.__dict__["remark"] = remark
        __props__.__dict__["status"] = status
        __props__.__dict__["subscription_urn"] = subscription_urn
        __props__.__dict__["topic_urn"] = topic_urn
        return SmnSubscription(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter
    def endpoint(self) -> pulumi.Output[builtins.str]:
        return pulumi.get(self, "endpoint")

    @property
    @pulumi.getter
    def extension(self) -> pulumi.Output['outputs.SmnSubscriptionExtension']:
        return pulumi.get(self, "extension")

    @property
    @pulumi.getter(name="filterPolicies")
    def filter_policies(self) -> pulumi.Output[Sequence['outputs.SmnSubscriptionFilterPolicy']]:
        """
        The message filter policies of a subscriber.
        """
        return pulumi.get(self, "filter_policies")

    @property
    @pulumi.getter
    def owner(self) -> pulumi.Output[builtins.str]:
        return pulumi.get(self, "owner")

    @property
    @pulumi.getter
    def protocol(self) -> pulumi.Output[builtins.str]:
        return pulumi.get(self, "protocol")

    @property
    @pulumi.getter
    def region(self) -> pulumi.Output[builtins.str]:
        return pulumi.get(self, "region")

    @property
    @pulumi.getter
    def remark(self) -> pulumi.Output[Optional[builtins.str]]:
        return pulumi.get(self, "remark")

    @property
    @pulumi.getter
    def status(self) -> pulumi.Output[builtins.int]:
        return pulumi.get(self, "status")

    @property
    @pulumi.getter(name="subscriptionUrn")
    def subscription_urn(self) -> pulumi.Output[builtins.str]:
        return pulumi.get(self, "subscription_urn")

    @property
    @pulumi.getter(name="topicUrn")
    def topic_urn(self) -> pulumi.Output[builtins.str]:
        return pulumi.get(self, "topic_urn")

