# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from . import _utilities
from . import outputs
from ._inputs import *

__all__ = ['SwrOrganizationPermissionsArgs', 'SwrOrganizationPermissions']

@pulumi.input_type
class SwrOrganizationPermissionsArgs:
    def __init__(__self__, *,
                 organization: pulumi.Input[builtins.str],
                 users: pulumi.Input[Sequence[pulumi.Input['SwrOrganizationPermissionsUserArgs']]],
                 region: Optional[pulumi.Input[builtins.str]] = None):
        """
        The set of arguments for constructing a SwrOrganizationPermissions resource.
        """
        pulumi.set(__self__, "organization", organization)
        pulumi.set(__self__, "users", users)
        if region is not None:
            pulumi.set(__self__, "region", region)

    @property
    @pulumi.getter
    def organization(self) -> pulumi.Input[builtins.str]:
        return pulumi.get(self, "organization")

    @organization.setter
    def organization(self, value: pulumi.Input[builtins.str]):
        pulumi.set(self, "organization", value)

    @property
    @pulumi.getter
    def users(self) -> pulumi.Input[Sequence[pulumi.Input['SwrOrganizationPermissionsUserArgs']]]:
        return pulumi.get(self, "users")

    @users.setter
    def users(self, value: pulumi.Input[Sequence[pulumi.Input['SwrOrganizationPermissionsUserArgs']]]):
        pulumi.set(self, "users", value)

    @property
    @pulumi.getter
    def region(self) -> Optional[pulumi.Input[builtins.str]]:
        return pulumi.get(self, "region")

    @region.setter
    def region(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "region", value)


@pulumi.input_type
class _SwrOrganizationPermissionsState:
    def __init__(__self__, *,
                 creator: Optional[pulumi.Input[builtins.str]] = None,
                 organization: Optional[pulumi.Input[builtins.str]] = None,
                 region: Optional[pulumi.Input[builtins.str]] = None,
                 self_permissions: Optional[pulumi.Input[Sequence[pulumi.Input['SwrOrganizationPermissionsSelfPermissionArgs']]]] = None,
                 users: Optional[pulumi.Input[Sequence[pulumi.Input['SwrOrganizationPermissionsUserArgs']]]] = None):
        """
        Input properties used for looking up and filtering SwrOrganizationPermissions resources.
        """
        if creator is not None:
            pulumi.set(__self__, "creator", creator)
        if organization is not None:
            pulumi.set(__self__, "organization", organization)
        if region is not None:
            pulumi.set(__self__, "region", region)
        if self_permissions is not None:
            pulumi.set(__self__, "self_permissions", self_permissions)
        if users is not None:
            pulumi.set(__self__, "users", users)

    @property
    @pulumi.getter
    def creator(self) -> Optional[pulumi.Input[builtins.str]]:
        return pulumi.get(self, "creator")

    @creator.setter
    def creator(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "creator", value)

    @property
    @pulumi.getter
    def organization(self) -> Optional[pulumi.Input[builtins.str]]:
        return pulumi.get(self, "organization")

    @organization.setter
    def organization(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "organization", value)

    @property
    @pulumi.getter
    def region(self) -> Optional[pulumi.Input[builtins.str]]:
        return pulumi.get(self, "region")

    @region.setter
    def region(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "region", value)

    @property
    @pulumi.getter(name="selfPermissions")
    def self_permissions(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['SwrOrganizationPermissionsSelfPermissionArgs']]]]:
        return pulumi.get(self, "self_permissions")

    @self_permissions.setter
    def self_permissions(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['SwrOrganizationPermissionsSelfPermissionArgs']]]]):
        pulumi.set(self, "self_permissions", value)

    @property
    @pulumi.getter
    def users(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['SwrOrganizationPermissionsUserArgs']]]]:
        return pulumi.get(self, "users")

    @users.setter
    def users(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['SwrOrganizationPermissionsUserArgs']]]]):
        pulumi.set(self, "users", value)


class SwrOrganizationPermissions(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 organization: Optional[pulumi.Input[builtins.str]] = None,
                 region: Optional[pulumi.Input[builtins.str]] = None,
                 users: Optional[pulumi.Input[Sequence[pulumi.Input[Union['SwrOrganizationPermissionsUserArgs', 'SwrOrganizationPermissionsUserArgsDict']]]]] = None,
                 __props__=None):
        """
        Create a SwrOrganizationPermissions resource with the given unique name, props, and options.
        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: SwrOrganizationPermissionsArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Create a SwrOrganizationPermissions resource with the given unique name, props, and options.
        :param str resource_name: The name of the resource.
        :param SwrOrganizationPermissionsArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(SwrOrganizationPermissionsArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 organization: Optional[pulumi.Input[builtins.str]] = None,
                 region: Optional[pulumi.Input[builtins.str]] = None,
                 users: Optional[pulumi.Input[Sequence[pulumi.Input[Union['SwrOrganizationPermissionsUserArgs', 'SwrOrganizationPermissionsUserArgsDict']]]]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = SwrOrganizationPermissionsArgs.__new__(SwrOrganizationPermissionsArgs)

            if organization is None and not opts.urn:
                raise TypeError("Missing required property 'organization'")
            __props__.__dict__["organization"] = organization
            __props__.__dict__["region"] = region
            if users is None and not opts.urn:
                raise TypeError("Missing required property 'users'")
            __props__.__dict__["users"] = users
            __props__.__dict__["creator"] = None
            __props__.__dict__["self_permissions"] = None
        super(SwrOrganizationPermissions, __self__).__init__(
            'sbercloud:index/swrOrganizationPermissions:SwrOrganizationPermissions',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            creator: Optional[pulumi.Input[builtins.str]] = None,
            organization: Optional[pulumi.Input[builtins.str]] = None,
            region: Optional[pulumi.Input[builtins.str]] = None,
            self_permissions: Optional[pulumi.Input[Sequence[pulumi.Input[Union['SwrOrganizationPermissionsSelfPermissionArgs', 'SwrOrganizationPermissionsSelfPermissionArgsDict']]]]] = None,
            users: Optional[pulumi.Input[Sequence[pulumi.Input[Union['SwrOrganizationPermissionsUserArgs', 'SwrOrganizationPermissionsUserArgsDict']]]]] = None) -> 'SwrOrganizationPermissions':
        """
        Get an existing SwrOrganizationPermissions resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _SwrOrganizationPermissionsState.__new__(_SwrOrganizationPermissionsState)

        __props__.__dict__["creator"] = creator
        __props__.__dict__["organization"] = organization
        __props__.__dict__["region"] = region
        __props__.__dict__["self_permissions"] = self_permissions
        __props__.__dict__["users"] = users
        return SwrOrganizationPermissions(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter
    def creator(self) -> pulumi.Output[builtins.str]:
        return pulumi.get(self, "creator")

    @property
    @pulumi.getter
    def organization(self) -> pulumi.Output[builtins.str]:
        return pulumi.get(self, "organization")

    @property
    @pulumi.getter
    def region(self) -> pulumi.Output[builtins.str]:
        return pulumi.get(self, "region")

    @property
    @pulumi.getter(name="selfPermissions")
    def self_permissions(self) -> pulumi.Output[Sequence['outputs.SwrOrganizationPermissionsSelfPermission']]:
        return pulumi.get(self, "self_permissions")

    @property
    @pulumi.getter
    def users(self) -> pulumi.Output[Sequence['outputs.SwrOrganizationPermissionsUser']]:
        return pulumi.get(self, "users")

