# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from . import _utilities
from . import outputs
from ._inputs import *

__all__ = ['VpnConnectionArgs', 'VpnConnection']

@pulumi.input_type
class VpnConnectionArgs:
    def __init__(__self__, *,
                 customer_gateway_id: pulumi.Input[builtins.str],
                 gateway_id: pulumi.Input[builtins.str],
                 gateway_ip: pulumi.Input[builtins.str],
                 psk: pulumi.Input[builtins.str],
                 vpn_type: pulumi.Input[builtins.str],
                 enable_nqa: Optional[pulumi.Input[builtins.bool]] = None,
                 enterprise_project_id: Optional[pulumi.Input[builtins.str]] = None,
                 ha_role: Optional[pulumi.Input[builtins.str]] = None,
                 ikepolicy: Optional[pulumi.Input['VpnConnectionIkepolicyArgs']] = None,
                 ipsecpolicy: Optional[pulumi.Input['VpnConnectionIpsecpolicyArgs']] = None,
                 name: Optional[pulumi.Input[builtins.str]] = None,
                 peer_subnets: Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]] = None,
                 policy_rules: Optional[pulumi.Input[Sequence[pulumi.Input['VpnConnectionPolicyRuleArgs']]]] = None,
                 region: Optional[pulumi.Input[builtins.str]] = None,
                 tags: Optional[pulumi.Input[Mapping[str, pulumi.Input[builtins.str]]]] = None,
                 tunnel_local_address: Optional[pulumi.Input[builtins.str]] = None,
                 tunnel_peer_address: Optional[pulumi.Input[builtins.str]] = None):
        """
        The set of arguments for constructing a VpnConnection resource.
        :param pulumi.Input[builtins.str] customer_gateway_id: The customer gateway ID.
        :param pulumi.Input[builtins.str] gateway_id: The VPN gateway ID.
        :param pulumi.Input[builtins.str] gateway_ip: The VPN gateway IP ID.
        :param pulumi.Input[builtins.str] psk: The pre-shared key.
        :param pulumi.Input[builtins.str] vpn_type: The connection type. The value can be **policy**, **static** or **bgp**.
        :param pulumi.Input[builtins.bool] enable_nqa: Whether to enable NQA check.
        :param pulumi.Input[builtins.str] enterprise_project_id: The enterprise project ID.
        :param pulumi.Input[builtins.str] name: The name of the VPN connection.
        :param pulumi.Input[Sequence[pulumi.Input[builtins.str]]] peer_subnets: The customer subnets.
        :param pulumi.Input[Sequence[pulumi.Input['VpnConnectionPolicyRuleArgs']]] policy_rules: The policy rules. Only works when vpn_type is set to **policy**
        :param pulumi.Input[builtins.str] tunnel_local_address: The local tunnel address.
        :param pulumi.Input[builtins.str] tunnel_peer_address: The peer tunnel address.
        """
        pulumi.set(__self__, "customer_gateway_id", customer_gateway_id)
        pulumi.set(__self__, "gateway_id", gateway_id)
        pulumi.set(__self__, "gateway_ip", gateway_ip)
        pulumi.set(__self__, "psk", psk)
        pulumi.set(__self__, "vpn_type", vpn_type)
        if enable_nqa is not None:
            pulumi.set(__self__, "enable_nqa", enable_nqa)
        if enterprise_project_id is not None:
            pulumi.set(__self__, "enterprise_project_id", enterprise_project_id)
        if ha_role is not None:
            pulumi.set(__self__, "ha_role", ha_role)
        if ikepolicy is not None:
            pulumi.set(__self__, "ikepolicy", ikepolicy)
        if ipsecpolicy is not None:
            pulumi.set(__self__, "ipsecpolicy", ipsecpolicy)
        if name is not None:
            pulumi.set(__self__, "name", name)
        if peer_subnets is not None:
            pulumi.set(__self__, "peer_subnets", peer_subnets)
        if policy_rules is not None:
            pulumi.set(__self__, "policy_rules", policy_rules)
        if region is not None:
            pulumi.set(__self__, "region", region)
        if tags is not None:
            pulumi.set(__self__, "tags", tags)
        if tunnel_local_address is not None:
            pulumi.set(__self__, "tunnel_local_address", tunnel_local_address)
        if tunnel_peer_address is not None:
            pulumi.set(__self__, "tunnel_peer_address", tunnel_peer_address)

    @property
    @pulumi.getter(name="customerGatewayId")
    def customer_gateway_id(self) -> pulumi.Input[builtins.str]:
        """
        The customer gateway ID.
        """
        return pulumi.get(self, "customer_gateway_id")

    @customer_gateway_id.setter
    def customer_gateway_id(self, value: pulumi.Input[builtins.str]):
        pulumi.set(self, "customer_gateway_id", value)

    @property
    @pulumi.getter(name="gatewayId")
    def gateway_id(self) -> pulumi.Input[builtins.str]:
        """
        The VPN gateway ID.
        """
        return pulumi.get(self, "gateway_id")

    @gateway_id.setter
    def gateway_id(self, value: pulumi.Input[builtins.str]):
        pulumi.set(self, "gateway_id", value)

    @property
    @pulumi.getter(name="gatewayIp")
    def gateway_ip(self) -> pulumi.Input[builtins.str]:
        """
        The VPN gateway IP ID.
        """
        return pulumi.get(self, "gateway_ip")

    @gateway_ip.setter
    def gateway_ip(self, value: pulumi.Input[builtins.str]):
        pulumi.set(self, "gateway_ip", value)

    @property
    @pulumi.getter
    def psk(self) -> pulumi.Input[builtins.str]:
        """
        The pre-shared key.
        """
        return pulumi.get(self, "psk")

    @psk.setter
    def psk(self, value: pulumi.Input[builtins.str]):
        pulumi.set(self, "psk", value)

    @property
    @pulumi.getter(name="vpnType")
    def vpn_type(self) -> pulumi.Input[builtins.str]:
        """
        The connection type. The value can be **policy**, **static** or **bgp**.
        """
        return pulumi.get(self, "vpn_type")

    @vpn_type.setter
    def vpn_type(self, value: pulumi.Input[builtins.str]):
        pulumi.set(self, "vpn_type", value)

    @property
    @pulumi.getter(name="enableNqa")
    def enable_nqa(self) -> Optional[pulumi.Input[builtins.bool]]:
        """
        Whether to enable NQA check.
        """
        return pulumi.get(self, "enable_nqa")

    @enable_nqa.setter
    def enable_nqa(self, value: Optional[pulumi.Input[builtins.bool]]):
        pulumi.set(self, "enable_nqa", value)

    @property
    @pulumi.getter(name="enterpriseProjectId")
    def enterprise_project_id(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The enterprise project ID.
        """
        return pulumi.get(self, "enterprise_project_id")

    @enterprise_project_id.setter
    def enterprise_project_id(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "enterprise_project_id", value)

    @property
    @pulumi.getter(name="haRole")
    def ha_role(self) -> Optional[pulumi.Input[builtins.str]]:
        return pulumi.get(self, "ha_role")

    @ha_role.setter
    def ha_role(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "ha_role", value)

    @property
    @pulumi.getter
    def ikepolicy(self) -> Optional[pulumi.Input['VpnConnectionIkepolicyArgs']]:
        return pulumi.get(self, "ikepolicy")

    @ikepolicy.setter
    def ikepolicy(self, value: Optional[pulumi.Input['VpnConnectionIkepolicyArgs']]):
        pulumi.set(self, "ikepolicy", value)

    @property
    @pulumi.getter
    def ipsecpolicy(self) -> Optional[pulumi.Input['VpnConnectionIpsecpolicyArgs']]:
        return pulumi.get(self, "ipsecpolicy")

    @ipsecpolicy.setter
    def ipsecpolicy(self, value: Optional[pulumi.Input['VpnConnectionIpsecpolicyArgs']]):
        pulumi.set(self, "ipsecpolicy", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The name of the VPN connection.
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter(name="peerSubnets")
    def peer_subnets(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]]:
        """
        The customer subnets.
        """
        return pulumi.get(self, "peer_subnets")

    @peer_subnets.setter
    def peer_subnets(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]]):
        pulumi.set(self, "peer_subnets", value)

    @property
    @pulumi.getter(name="policyRules")
    def policy_rules(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['VpnConnectionPolicyRuleArgs']]]]:
        """
        The policy rules. Only works when vpn_type is set to **policy**
        """
        return pulumi.get(self, "policy_rules")

    @policy_rules.setter
    def policy_rules(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['VpnConnectionPolicyRuleArgs']]]]):
        pulumi.set(self, "policy_rules", value)

    @property
    @pulumi.getter
    def region(self) -> Optional[pulumi.Input[builtins.str]]:
        return pulumi.get(self, "region")

    @region.setter
    def region(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "region", value)

    @property
    @pulumi.getter
    def tags(self) -> Optional[pulumi.Input[Mapping[str, pulumi.Input[builtins.str]]]]:
        return pulumi.get(self, "tags")

    @tags.setter
    def tags(self, value: Optional[pulumi.Input[Mapping[str, pulumi.Input[builtins.str]]]]):
        pulumi.set(self, "tags", value)

    @property
    @pulumi.getter(name="tunnelLocalAddress")
    def tunnel_local_address(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The local tunnel address.
        """
        return pulumi.get(self, "tunnel_local_address")

    @tunnel_local_address.setter
    def tunnel_local_address(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "tunnel_local_address", value)

    @property
    @pulumi.getter(name="tunnelPeerAddress")
    def tunnel_peer_address(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The peer tunnel address.
        """
        return pulumi.get(self, "tunnel_peer_address")

    @tunnel_peer_address.setter
    def tunnel_peer_address(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "tunnel_peer_address", value)


@pulumi.input_type
class _VpnConnectionState:
    def __init__(__self__, *,
                 created_at: Optional[pulumi.Input[builtins.str]] = None,
                 customer_gateway_id: Optional[pulumi.Input[builtins.str]] = None,
                 enable_nqa: Optional[pulumi.Input[builtins.bool]] = None,
                 enterprise_project_id: Optional[pulumi.Input[builtins.str]] = None,
                 gateway_id: Optional[pulumi.Input[builtins.str]] = None,
                 gateway_ip: Optional[pulumi.Input[builtins.str]] = None,
                 ha_role: Optional[pulumi.Input[builtins.str]] = None,
                 ikepolicy: Optional[pulumi.Input['VpnConnectionIkepolicyArgs']] = None,
                 ipsecpolicy: Optional[pulumi.Input['VpnConnectionIpsecpolicyArgs']] = None,
                 name: Optional[pulumi.Input[builtins.str]] = None,
                 peer_subnets: Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]] = None,
                 policy_rules: Optional[pulumi.Input[Sequence[pulumi.Input['VpnConnectionPolicyRuleArgs']]]] = None,
                 psk: Optional[pulumi.Input[builtins.str]] = None,
                 region: Optional[pulumi.Input[builtins.str]] = None,
                 status: Optional[pulumi.Input[builtins.str]] = None,
                 tags: Optional[pulumi.Input[Mapping[str, pulumi.Input[builtins.str]]]] = None,
                 tunnel_local_address: Optional[pulumi.Input[builtins.str]] = None,
                 tunnel_peer_address: Optional[pulumi.Input[builtins.str]] = None,
                 updated_at: Optional[pulumi.Input[builtins.str]] = None,
                 vpn_type: Optional[pulumi.Input[builtins.str]] = None):
        """
        Input properties used for looking up and filtering VpnConnection resources.
        :param pulumi.Input[builtins.str] created_at: The create time.
        :param pulumi.Input[builtins.str] customer_gateway_id: The customer gateway ID.
        :param pulumi.Input[builtins.bool] enable_nqa: Whether to enable NQA check.
        :param pulumi.Input[builtins.str] enterprise_project_id: The enterprise project ID.
        :param pulumi.Input[builtins.str] gateway_id: The VPN gateway ID.
        :param pulumi.Input[builtins.str] gateway_ip: The VPN gateway IP ID.
        :param pulumi.Input[builtins.str] name: The name of the VPN connection.
        :param pulumi.Input[Sequence[pulumi.Input[builtins.str]]] peer_subnets: The customer subnets.
        :param pulumi.Input[Sequence[pulumi.Input['VpnConnectionPolicyRuleArgs']]] policy_rules: The policy rules. Only works when vpn_type is set to **policy**
        :param pulumi.Input[builtins.str] psk: The pre-shared key.
        :param pulumi.Input[builtins.str] status: The status of the VPN connection.
        :param pulumi.Input[builtins.str] tunnel_local_address: The local tunnel address.
        :param pulumi.Input[builtins.str] tunnel_peer_address: The peer tunnel address.
        :param pulumi.Input[builtins.str] updated_at: The update time.
        :param pulumi.Input[builtins.str] vpn_type: The connection type. The value can be **policy**, **static** or **bgp**.
        """
        if created_at is not None:
            pulumi.set(__self__, "created_at", created_at)
        if customer_gateway_id is not None:
            pulumi.set(__self__, "customer_gateway_id", customer_gateway_id)
        if enable_nqa is not None:
            pulumi.set(__self__, "enable_nqa", enable_nqa)
        if enterprise_project_id is not None:
            pulumi.set(__self__, "enterprise_project_id", enterprise_project_id)
        if gateway_id is not None:
            pulumi.set(__self__, "gateway_id", gateway_id)
        if gateway_ip is not None:
            pulumi.set(__self__, "gateway_ip", gateway_ip)
        if ha_role is not None:
            pulumi.set(__self__, "ha_role", ha_role)
        if ikepolicy is not None:
            pulumi.set(__self__, "ikepolicy", ikepolicy)
        if ipsecpolicy is not None:
            pulumi.set(__self__, "ipsecpolicy", ipsecpolicy)
        if name is not None:
            pulumi.set(__self__, "name", name)
        if peer_subnets is not None:
            pulumi.set(__self__, "peer_subnets", peer_subnets)
        if policy_rules is not None:
            pulumi.set(__self__, "policy_rules", policy_rules)
        if psk is not None:
            pulumi.set(__self__, "psk", psk)
        if region is not None:
            pulumi.set(__self__, "region", region)
        if status is not None:
            pulumi.set(__self__, "status", status)
        if tags is not None:
            pulumi.set(__self__, "tags", tags)
        if tunnel_local_address is not None:
            pulumi.set(__self__, "tunnel_local_address", tunnel_local_address)
        if tunnel_peer_address is not None:
            pulumi.set(__self__, "tunnel_peer_address", tunnel_peer_address)
        if updated_at is not None:
            pulumi.set(__self__, "updated_at", updated_at)
        if vpn_type is not None:
            pulumi.set(__self__, "vpn_type", vpn_type)

    @property
    @pulumi.getter(name="createdAt")
    def created_at(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The create time.
        """
        return pulumi.get(self, "created_at")

    @created_at.setter
    def created_at(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "created_at", value)

    @property
    @pulumi.getter(name="customerGatewayId")
    def customer_gateway_id(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The customer gateway ID.
        """
        return pulumi.get(self, "customer_gateway_id")

    @customer_gateway_id.setter
    def customer_gateway_id(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "customer_gateway_id", value)

    @property
    @pulumi.getter(name="enableNqa")
    def enable_nqa(self) -> Optional[pulumi.Input[builtins.bool]]:
        """
        Whether to enable NQA check.
        """
        return pulumi.get(self, "enable_nqa")

    @enable_nqa.setter
    def enable_nqa(self, value: Optional[pulumi.Input[builtins.bool]]):
        pulumi.set(self, "enable_nqa", value)

    @property
    @pulumi.getter(name="enterpriseProjectId")
    def enterprise_project_id(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The enterprise project ID.
        """
        return pulumi.get(self, "enterprise_project_id")

    @enterprise_project_id.setter
    def enterprise_project_id(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "enterprise_project_id", value)

    @property
    @pulumi.getter(name="gatewayId")
    def gateway_id(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The VPN gateway ID.
        """
        return pulumi.get(self, "gateway_id")

    @gateway_id.setter
    def gateway_id(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "gateway_id", value)

    @property
    @pulumi.getter(name="gatewayIp")
    def gateway_ip(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The VPN gateway IP ID.
        """
        return pulumi.get(self, "gateway_ip")

    @gateway_ip.setter
    def gateway_ip(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "gateway_ip", value)

    @property
    @pulumi.getter(name="haRole")
    def ha_role(self) -> Optional[pulumi.Input[builtins.str]]:
        return pulumi.get(self, "ha_role")

    @ha_role.setter
    def ha_role(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "ha_role", value)

    @property
    @pulumi.getter
    def ikepolicy(self) -> Optional[pulumi.Input['VpnConnectionIkepolicyArgs']]:
        return pulumi.get(self, "ikepolicy")

    @ikepolicy.setter
    def ikepolicy(self, value: Optional[pulumi.Input['VpnConnectionIkepolicyArgs']]):
        pulumi.set(self, "ikepolicy", value)

    @property
    @pulumi.getter
    def ipsecpolicy(self) -> Optional[pulumi.Input['VpnConnectionIpsecpolicyArgs']]:
        return pulumi.get(self, "ipsecpolicy")

    @ipsecpolicy.setter
    def ipsecpolicy(self, value: Optional[pulumi.Input['VpnConnectionIpsecpolicyArgs']]):
        pulumi.set(self, "ipsecpolicy", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The name of the VPN connection.
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter(name="peerSubnets")
    def peer_subnets(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]]:
        """
        The customer subnets.
        """
        return pulumi.get(self, "peer_subnets")

    @peer_subnets.setter
    def peer_subnets(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]]):
        pulumi.set(self, "peer_subnets", value)

    @property
    @pulumi.getter(name="policyRules")
    def policy_rules(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['VpnConnectionPolicyRuleArgs']]]]:
        """
        The policy rules. Only works when vpn_type is set to **policy**
        """
        return pulumi.get(self, "policy_rules")

    @policy_rules.setter
    def policy_rules(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['VpnConnectionPolicyRuleArgs']]]]):
        pulumi.set(self, "policy_rules", value)

    @property
    @pulumi.getter
    def psk(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The pre-shared key.
        """
        return pulumi.get(self, "psk")

    @psk.setter
    def psk(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "psk", value)

    @property
    @pulumi.getter
    def region(self) -> Optional[pulumi.Input[builtins.str]]:
        return pulumi.get(self, "region")

    @region.setter
    def region(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "region", value)

    @property
    @pulumi.getter
    def status(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The status of the VPN connection.
        """
        return pulumi.get(self, "status")

    @status.setter
    def status(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "status", value)

    @property
    @pulumi.getter
    def tags(self) -> Optional[pulumi.Input[Mapping[str, pulumi.Input[builtins.str]]]]:
        return pulumi.get(self, "tags")

    @tags.setter
    def tags(self, value: Optional[pulumi.Input[Mapping[str, pulumi.Input[builtins.str]]]]):
        pulumi.set(self, "tags", value)

    @property
    @pulumi.getter(name="tunnelLocalAddress")
    def tunnel_local_address(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The local tunnel address.
        """
        return pulumi.get(self, "tunnel_local_address")

    @tunnel_local_address.setter
    def tunnel_local_address(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "tunnel_local_address", value)

    @property
    @pulumi.getter(name="tunnelPeerAddress")
    def tunnel_peer_address(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The peer tunnel address.
        """
        return pulumi.get(self, "tunnel_peer_address")

    @tunnel_peer_address.setter
    def tunnel_peer_address(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "tunnel_peer_address", value)

    @property
    @pulumi.getter(name="updatedAt")
    def updated_at(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The update time.
        """
        return pulumi.get(self, "updated_at")

    @updated_at.setter
    def updated_at(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "updated_at", value)

    @property
    @pulumi.getter(name="vpnType")
    def vpn_type(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The connection type. The value can be **policy**, **static** or **bgp**.
        """
        return pulumi.get(self, "vpn_type")

    @vpn_type.setter
    def vpn_type(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "vpn_type", value)


class VpnConnection(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 customer_gateway_id: Optional[pulumi.Input[builtins.str]] = None,
                 enable_nqa: Optional[pulumi.Input[builtins.bool]] = None,
                 enterprise_project_id: Optional[pulumi.Input[builtins.str]] = None,
                 gateway_id: Optional[pulumi.Input[builtins.str]] = None,
                 gateway_ip: Optional[pulumi.Input[builtins.str]] = None,
                 ha_role: Optional[pulumi.Input[builtins.str]] = None,
                 ikepolicy: Optional[pulumi.Input[Union['VpnConnectionIkepolicyArgs', 'VpnConnectionIkepolicyArgsDict']]] = None,
                 ipsecpolicy: Optional[pulumi.Input[Union['VpnConnectionIpsecpolicyArgs', 'VpnConnectionIpsecpolicyArgsDict']]] = None,
                 name: Optional[pulumi.Input[builtins.str]] = None,
                 peer_subnets: Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]] = None,
                 policy_rules: Optional[pulumi.Input[Sequence[pulumi.Input[Union['VpnConnectionPolicyRuleArgs', 'VpnConnectionPolicyRuleArgsDict']]]]] = None,
                 psk: Optional[pulumi.Input[builtins.str]] = None,
                 region: Optional[pulumi.Input[builtins.str]] = None,
                 tags: Optional[pulumi.Input[Mapping[str, pulumi.Input[builtins.str]]]] = None,
                 tunnel_local_address: Optional[pulumi.Input[builtins.str]] = None,
                 tunnel_peer_address: Optional[pulumi.Input[builtins.str]] = None,
                 vpn_type: Optional[pulumi.Input[builtins.str]] = None,
                 __props__=None):
        """
        Create a VpnConnection resource with the given unique name, props, and options.
        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[builtins.str] customer_gateway_id: The customer gateway ID.
        :param pulumi.Input[builtins.bool] enable_nqa: Whether to enable NQA check.
        :param pulumi.Input[builtins.str] enterprise_project_id: The enterprise project ID.
        :param pulumi.Input[builtins.str] gateway_id: The VPN gateway ID.
        :param pulumi.Input[builtins.str] gateway_ip: The VPN gateway IP ID.
        :param pulumi.Input[builtins.str] name: The name of the VPN connection.
        :param pulumi.Input[Sequence[pulumi.Input[builtins.str]]] peer_subnets: The customer subnets.
        :param pulumi.Input[Sequence[pulumi.Input[Union['VpnConnectionPolicyRuleArgs', 'VpnConnectionPolicyRuleArgsDict']]]] policy_rules: The policy rules. Only works when vpn_type is set to **policy**
        :param pulumi.Input[builtins.str] psk: The pre-shared key.
        :param pulumi.Input[builtins.str] tunnel_local_address: The local tunnel address.
        :param pulumi.Input[builtins.str] tunnel_peer_address: The peer tunnel address.
        :param pulumi.Input[builtins.str] vpn_type: The connection type. The value can be **policy**, **static** or **bgp**.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: VpnConnectionArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Create a VpnConnection resource with the given unique name, props, and options.
        :param str resource_name: The name of the resource.
        :param VpnConnectionArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(VpnConnectionArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 customer_gateway_id: Optional[pulumi.Input[builtins.str]] = None,
                 enable_nqa: Optional[pulumi.Input[builtins.bool]] = None,
                 enterprise_project_id: Optional[pulumi.Input[builtins.str]] = None,
                 gateway_id: Optional[pulumi.Input[builtins.str]] = None,
                 gateway_ip: Optional[pulumi.Input[builtins.str]] = None,
                 ha_role: Optional[pulumi.Input[builtins.str]] = None,
                 ikepolicy: Optional[pulumi.Input[Union['VpnConnectionIkepolicyArgs', 'VpnConnectionIkepolicyArgsDict']]] = None,
                 ipsecpolicy: Optional[pulumi.Input[Union['VpnConnectionIpsecpolicyArgs', 'VpnConnectionIpsecpolicyArgsDict']]] = None,
                 name: Optional[pulumi.Input[builtins.str]] = None,
                 peer_subnets: Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]] = None,
                 policy_rules: Optional[pulumi.Input[Sequence[pulumi.Input[Union['VpnConnectionPolicyRuleArgs', 'VpnConnectionPolicyRuleArgsDict']]]]] = None,
                 psk: Optional[pulumi.Input[builtins.str]] = None,
                 region: Optional[pulumi.Input[builtins.str]] = None,
                 tags: Optional[pulumi.Input[Mapping[str, pulumi.Input[builtins.str]]]] = None,
                 tunnel_local_address: Optional[pulumi.Input[builtins.str]] = None,
                 tunnel_peer_address: Optional[pulumi.Input[builtins.str]] = None,
                 vpn_type: Optional[pulumi.Input[builtins.str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = VpnConnectionArgs.__new__(VpnConnectionArgs)

            if customer_gateway_id is None and not opts.urn:
                raise TypeError("Missing required property 'customer_gateway_id'")
            __props__.__dict__["customer_gateway_id"] = customer_gateway_id
            __props__.__dict__["enable_nqa"] = enable_nqa
            __props__.__dict__["enterprise_project_id"] = enterprise_project_id
            if gateway_id is None and not opts.urn:
                raise TypeError("Missing required property 'gateway_id'")
            __props__.__dict__["gateway_id"] = gateway_id
            if gateway_ip is None and not opts.urn:
                raise TypeError("Missing required property 'gateway_ip'")
            __props__.__dict__["gateway_ip"] = gateway_ip
            __props__.__dict__["ha_role"] = ha_role
            __props__.__dict__["ikepolicy"] = ikepolicy
            __props__.__dict__["ipsecpolicy"] = ipsecpolicy
            __props__.__dict__["name"] = name
            __props__.__dict__["peer_subnets"] = peer_subnets
            __props__.__dict__["policy_rules"] = policy_rules
            if psk is None and not opts.urn:
                raise TypeError("Missing required property 'psk'")
            __props__.__dict__["psk"] = psk
            __props__.__dict__["region"] = region
            __props__.__dict__["tags"] = tags
            __props__.__dict__["tunnel_local_address"] = tunnel_local_address
            __props__.__dict__["tunnel_peer_address"] = tunnel_peer_address
            if vpn_type is None and not opts.urn:
                raise TypeError("Missing required property 'vpn_type'")
            __props__.__dict__["vpn_type"] = vpn_type
            __props__.__dict__["created_at"] = None
            __props__.__dict__["status"] = None
            __props__.__dict__["updated_at"] = None
        super(VpnConnection, __self__).__init__(
            'sbercloud:index/vpnConnection:VpnConnection',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            created_at: Optional[pulumi.Input[builtins.str]] = None,
            customer_gateway_id: Optional[pulumi.Input[builtins.str]] = None,
            enable_nqa: Optional[pulumi.Input[builtins.bool]] = None,
            enterprise_project_id: Optional[pulumi.Input[builtins.str]] = None,
            gateway_id: Optional[pulumi.Input[builtins.str]] = None,
            gateway_ip: Optional[pulumi.Input[builtins.str]] = None,
            ha_role: Optional[pulumi.Input[builtins.str]] = None,
            ikepolicy: Optional[pulumi.Input[Union['VpnConnectionIkepolicyArgs', 'VpnConnectionIkepolicyArgsDict']]] = None,
            ipsecpolicy: Optional[pulumi.Input[Union['VpnConnectionIpsecpolicyArgs', 'VpnConnectionIpsecpolicyArgsDict']]] = None,
            name: Optional[pulumi.Input[builtins.str]] = None,
            peer_subnets: Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]] = None,
            policy_rules: Optional[pulumi.Input[Sequence[pulumi.Input[Union['VpnConnectionPolicyRuleArgs', 'VpnConnectionPolicyRuleArgsDict']]]]] = None,
            psk: Optional[pulumi.Input[builtins.str]] = None,
            region: Optional[pulumi.Input[builtins.str]] = None,
            status: Optional[pulumi.Input[builtins.str]] = None,
            tags: Optional[pulumi.Input[Mapping[str, pulumi.Input[builtins.str]]]] = None,
            tunnel_local_address: Optional[pulumi.Input[builtins.str]] = None,
            tunnel_peer_address: Optional[pulumi.Input[builtins.str]] = None,
            updated_at: Optional[pulumi.Input[builtins.str]] = None,
            vpn_type: Optional[pulumi.Input[builtins.str]] = None) -> 'VpnConnection':
        """
        Get an existing VpnConnection resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[builtins.str] created_at: The create time.
        :param pulumi.Input[builtins.str] customer_gateway_id: The customer gateway ID.
        :param pulumi.Input[builtins.bool] enable_nqa: Whether to enable NQA check.
        :param pulumi.Input[builtins.str] enterprise_project_id: The enterprise project ID.
        :param pulumi.Input[builtins.str] gateway_id: The VPN gateway ID.
        :param pulumi.Input[builtins.str] gateway_ip: The VPN gateway IP ID.
        :param pulumi.Input[builtins.str] name: The name of the VPN connection.
        :param pulumi.Input[Sequence[pulumi.Input[builtins.str]]] peer_subnets: The customer subnets.
        :param pulumi.Input[Sequence[pulumi.Input[Union['VpnConnectionPolicyRuleArgs', 'VpnConnectionPolicyRuleArgsDict']]]] policy_rules: The policy rules. Only works when vpn_type is set to **policy**
        :param pulumi.Input[builtins.str] psk: The pre-shared key.
        :param pulumi.Input[builtins.str] status: The status of the VPN connection.
        :param pulumi.Input[builtins.str] tunnel_local_address: The local tunnel address.
        :param pulumi.Input[builtins.str] tunnel_peer_address: The peer tunnel address.
        :param pulumi.Input[builtins.str] updated_at: The update time.
        :param pulumi.Input[builtins.str] vpn_type: The connection type. The value can be **policy**, **static** or **bgp**.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _VpnConnectionState.__new__(_VpnConnectionState)

        __props__.__dict__["created_at"] = created_at
        __props__.__dict__["customer_gateway_id"] = customer_gateway_id
        __props__.__dict__["enable_nqa"] = enable_nqa
        __props__.__dict__["enterprise_project_id"] = enterprise_project_id
        __props__.__dict__["gateway_id"] = gateway_id
        __props__.__dict__["gateway_ip"] = gateway_ip
        __props__.__dict__["ha_role"] = ha_role
        __props__.__dict__["ikepolicy"] = ikepolicy
        __props__.__dict__["ipsecpolicy"] = ipsecpolicy
        __props__.__dict__["name"] = name
        __props__.__dict__["peer_subnets"] = peer_subnets
        __props__.__dict__["policy_rules"] = policy_rules
        __props__.__dict__["psk"] = psk
        __props__.__dict__["region"] = region
        __props__.__dict__["status"] = status
        __props__.__dict__["tags"] = tags
        __props__.__dict__["tunnel_local_address"] = tunnel_local_address
        __props__.__dict__["tunnel_peer_address"] = tunnel_peer_address
        __props__.__dict__["updated_at"] = updated_at
        __props__.__dict__["vpn_type"] = vpn_type
        return VpnConnection(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="createdAt")
    def created_at(self) -> pulumi.Output[builtins.str]:
        """
        The create time.
        """
        return pulumi.get(self, "created_at")

    @property
    @pulumi.getter(name="customerGatewayId")
    def customer_gateway_id(self) -> pulumi.Output[builtins.str]:
        """
        The customer gateway ID.
        """
        return pulumi.get(self, "customer_gateway_id")

    @property
    @pulumi.getter(name="enableNqa")
    def enable_nqa(self) -> pulumi.Output[builtins.bool]:
        """
        Whether to enable NQA check.
        """
        return pulumi.get(self, "enable_nqa")

    @property
    @pulumi.getter(name="enterpriseProjectId")
    def enterprise_project_id(self) -> pulumi.Output[builtins.str]:
        """
        The enterprise project ID.
        """
        return pulumi.get(self, "enterprise_project_id")

    @property
    @pulumi.getter(name="gatewayId")
    def gateway_id(self) -> pulumi.Output[builtins.str]:
        """
        The VPN gateway ID.
        """
        return pulumi.get(self, "gateway_id")

    @property
    @pulumi.getter(name="gatewayIp")
    def gateway_ip(self) -> pulumi.Output[builtins.str]:
        """
        The VPN gateway IP ID.
        """
        return pulumi.get(self, "gateway_ip")

    @property
    @pulumi.getter(name="haRole")
    def ha_role(self) -> pulumi.Output[builtins.str]:
        return pulumi.get(self, "ha_role")

    @property
    @pulumi.getter
    def ikepolicy(self) -> pulumi.Output['outputs.VpnConnectionIkepolicy']:
        return pulumi.get(self, "ikepolicy")

    @property
    @pulumi.getter
    def ipsecpolicy(self) -> pulumi.Output['outputs.VpnConnectionIpsecpolicy']:
        return pulumi.get(self, "ipsecpolicy")

    @property
    @pulumi.getter
    def name(self) -> pulumi.Output[builtins.str]:
        """
        The name of the VPN connection.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="peerSubnets")
    def peer_subnets(self) -> pulumi.Output[Sequence[builtins.str]]:
        """
        The customer subnets.
        """
        return pulumi.get(self, "peer_subnets")

    @property
    @pulumi.getter(name="policyRules")
    def policy_rules(self) -> pulumi.Output[Sequence['outputs.VpnConnectionPolicyRule']]:
        """
        The policy rules. Only works when vpn_type is set to **policy**
        """
        return pulumi.get(self, "policy_rules")

    @property
    @pulumi.getter
    def psk(self) -> pulumi.Output[builtins.str]:
        """
        The pre-shared key.
        """
        return pulumi.get(self, "psk")

    @property
    @pulumi.getter
    def region(self) -> pulumi.Output[builtins.str]:
        return pulumi.get(self, "region")

    @property
    @pulumi.getter
    def status(self) -> pulumi.Output[builtins.str]:
        """
        The status of the VPN connection.
        """
        return pulumi.get(self, "status")

    @property
    @pulumi.getter
    def tags(self) -> pulumi.Output[Optional[Mapping[str, builtins.str]]]:
        return pulumi.get(self, "tags")

    @property
    @pulumi.getter(name="tunnelLocalAddress")
    def tunnel_local_address(self) -> pulumi.Output[builtins.str]:
        """
        The local tunnel address.
        """
        return pulumi.get(self, "tunnel_local_address")

    @property
    @pulumi.getter(name="tunnelPeerAddress")
    def tunnel_peer_address(self) -> pulumi.Output[builtins.str]:
        """
        The peer tunnel address.
        """
        return pulumi.get(self, "tunnel_peer_address")

    @property
    @pulumi.getter(name="updatedAt")
    def updated_at(self) -> pulumi.Output[builtins.str]:
        """
        The update time.
        """
        return pulumi.get(self, "updated_at")

    @property
    @pulumi.getter(name="vpnType")
    def vpn_type(self) -> pulumi.Output[builtins.str]:
        """
        The connection type. The value can be **policy**, **static** or **bgp**.
        """
        return pulumi.get(self, "vpn_type")

