# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from . import _utilities
from . import outputs
from ._inputs import *

__all__ = ['VpnGatewayArgs', 'VpnGateway']

@pulumi.input_type
class VpnGatewayArgs:
    def __init__(__self__, *,
                 availability_zones: pulumi.Input[Sequence[pulumi.Input[builtins.str]]],
                 access_private_ip1: Optional[pulumi.Input[builtins.str]] = None,
                 access_private_ip2: Optional[pulumi.Input[builtins.str]] = None,
                 access_subnet_id: Optional[pulumi.Input[builtins.str]] = None,
                 access_vpc_id: Optional[pulumi.Input[builtins.str]] = None,
                 asn: Optional[pulumi.Input[builtins.int]] = None,
                 attachment_type: Optional[pulumi.Input[builtins.str]] = None,
                 certificate: Optional[pulumi.Input['VpnGatewayCertificateArgs']] = None,
                 connect_subnet: Optional[pulumi.Input[builtins.str]] = None,
                 delete_eip_on_termination: Optional[pulumi.Input[builtins.bool]] = None,
                 eip1: Optional[pulumi.Input['VpnGatewayEip1Args']] = None,
                 eip2: Optional[pulumi.Input['VpnGatewayEip2Args']] = None,
                 enterprise_project_id: Optional[pulumi.Input[builtins.str]] = None,
                 er_id: Optional[pulumi.Input[builtins.str]] = None,
                 flavor: Optional[pulumi.Input[builtins.str]] = None,
                 ha_mode: Optional[pulumi.Input[builtins.str]] = None,
                 local_subnets: Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]] = None,
                 master_eip: Optional[pulumi.Input['VpnGatewayMasterEipArgs']] = None,
                 name: Optional[pulumi.Input[builtins.str]] = None,
                 network_type: Optional[pulumi.Input[builtins.str]] = None,
                 region: Optional[pulumi.Input[builtins.str]] = None,
                 slave_eip: Optional[pulumi.Input['VpnGatewaySlaveEipArgs']] = None,
                 tags: Optional[pulumi.Input[Mapping[str, pulumi.Input[builtins.str]]]] = None,
                 vpc_id: Optional[pulumi.Input[builtins.str]] = None):
        """
        The set of arguments for constructing a VpnGateway resource.
        :param pulumi.Input[Sequence[pulumi.Input[builtins.str]]] availability_zones: The availability zone IDs.
        :param pulumi.Input[builtins.str] access_subnet_id: The access subnet ID of the VPN gateway.
        :param pulumi.Input[builtins.str] access_vpc_id: The access VPC ID of the VPN gateway.
        :param pulumi.Input[builtins.int] asn: The ASN number of BGP
        :param pulumi.Input[builtins.str] attachment_type: The attachment type.
        :param pulumi.Input[builtins.str] connect_subnet: The Network ID of the VPC subnet used by the VPN gateway.
        :param pulumi.Input[builtins.bool] delete_eip_on_termination: Whether to delete the EIP when the VPN gateway is deleted.
        :param pulumi.Input[builtins.str] enterprise_project_id: The enterprise project ID
        :param pulumi.Input[builtins.str] er_id: The enterprise router ID to attach with to VPN gateway.
        :param pulumi.Input[builtins.str] flavor: The flavor of the VPN gateway.
        :param pulumi.Input[builtins.str] ha_mode: The HA mode of the VPN gateway.
        :param pulumi.Input[Sequence[pulumi.Input[builtins.str]]] local_subnets: The local subnets.
        :param pulumi.Input[builtins.str] name: The name of the VPN gateway. Only letters, digits, underscores(_) and hypens(-) are supported.
        :param pulumi.Input[builtins.str] network_type: The network type of the VPN gateway.
        :param pulumi.Input[builtins.str] vpc_id: The ID of the VPC to which the VPN gateway is connected.
        """
        pulumi.set(__self__, "availability_zones", availability_zones)
        if access_private_ip1 is not None:
            pulumi.set(__self__, "access_private_ip1", access_private_ip1)
        if access_private_ip2 is not None:
            pulumi.set(__self__, "access_private_ip2", access_private_ip2)
        if access_subnet_id is not None:
            pulumi.set(__self__, "access_subnet_id", access_subnet_id)
        if access_vpc_id is not None:
            pulumi.set(__self__, "access_vpc_id", access_vpc_id)
        if asn is not None:
            pulumi.set(__self__, "asn", asn)
        if attachment_type is not None:
            pulumi.set(__self__, "attachment_type", attachment_type)
        if certificate is not None:
            pulumi.set(__self__, "certificate", certificate)
        if connect_subnet is not None:
            pulumi.set(__self__, "connect_subnet", connect_subnet)
        if delete_eip_on_termination is not None:
            pulumi.set(__self__, "delete_eip_on_termination", delete_eip_on_termination)
        if eip1 is not None:
            pulumi.set(__self__, "eip1", eip1)
        if eip2 is not None:
            pulumi.set(__self__, "eip2", eip2)
        if enterprise_project_id is not None:
            pulumi.set(__self__, "enterprise_project_id", enterprise_project_id)
        if er_id is not None:
            pulumi.set(__self__, "er_id", er_id)
        if flavor is not None:
            pulumi.set(__self__, "flavor", flavor)
        if ha_mode is not None:
            pulumi.set(__self__, "ha_mode", ha_mode)
        if local_subnets is not None:
            pulumi.set(__self__, "local_subnets", local_subnets)
        if master_eip is not None:
            pulumi.set(__self__, "master_eip", master_eip)
        if name is not None:
            pulumi.set(__self__, "name", name)
        if network_type is not None:
            pulumi.set(__self__, "network_type", network_type)
        if region is not None:
            pulumi.set(__self__, "region", region)
        if slave_eip is not None:
            pulumi.set(__self__, "slave_eip", slave_eip)
        if tags is not None:
            pulumi.set(__self__, "tags", tags)
        if vpc_id is not None:
            pulumi.set(__self__, "vpc_id", vpc_id)

    @property
    @pulumi.getter(name="availabilityZones")
    def availability_zones(self) -> pulumi.Input[Sequence[pulumi.Input[builtins.str]]]:
        """
        The availability zone IDs.
        """
        return pulumi.get(self, "availability_zones")

    @availability_zones.setter
    def availability_zones(self, value: pulumi.Input[Sequence[pulumi.Input[builtins.str]]]):
        pulumi.set(self, "availability_zones", value)

    @property
    @pulumi.getter(name="accessPrivateIp1")
    def access_private_ip1(self) -> Optional[pulumi.Input[builtins.str]]:
        return pulumi.get(self, "access_private_ip1")

    @access_private_ip1.setter
    def access_private_ip1(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "access_private_ip1", value)

    @property
    @pulumi.getter(name="accessPrivateIp2")
    def access_private_ip2(self) -> Optional[pulumi.Input[builtins.str]]:
        return pulumi.get(self, "access_private_ip2")

    @access_private_ip2.setter
    def access_private_ip2(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "access_private_ip2", value)

    @property
    @pulumi.getter(name="accessSubnetId")
    def access_subnet_id(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The access subnet ID of the VPN gateway.
        """
        return pulumi.get(self, "access_subnet_id")

    @access_subnet_id.setter
    def access_subnet_id(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "access_subnet_id", value)

    @property
    @pulumi.getter(name="accessVpcId")
    def access_vpc_id(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The access VPC ID of the VPN gateway.
        """
        return pulumi.get(self, "access_vpc_id")

    @access_vpc_id.setter
    def access_vpc_id(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "access_vpc_id", value)

    @property
    @pulumi.getter
    def asn(self) -> Optional[pulumi.Input[builtins.int]]:
        """
        The ASN number of BGP
        """
        return pulumi.get(self, "asn")

    @asn.setter
    def asn(self, value: Optional[pulumi.Input[builtins.int]]):
        pulumi.set(self, "asn", value)

    @property
    @pulumi.getter(name="attachmentType")
    def attachment_type(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The attachment type.
        """
        return pulumi.get(self, "attachment_type")

    @attachment_type.setter
    def attachment_type(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "attachment_type", value)

    @property
    @pulumi.getter
    def certificate(self) -> Optional[pulumi.Input['VpnGatewayCertificateArgs']]:
        return pulumi.get(self, "certificate")

    @certificate.setter
    def certificate(self, value: Optional[pulumi.Input['VpnGatewayCertificateArgs']]):
        pulumi.set(self, "certificate", value)

    @property
    @pulumi.getter(name="connectSubnet")
    def connect_subnet(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The Network ID of the VPC subnet used by the VPN gateway.
        """
        return pulumi.get(self, "connect_subnet")

    @connect_subnet.setter
    def connect_subnet(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "connect_subnet", value)

    @property
    @pulumi.getter(name="deleteEipOnTermination")
    def delete_eip_on_termination(self) -> Optional[pulumi.Input[builtins.bool]]:
        """
        Whether to delete the EIP when the VPN gateway is deleted.
        """
        return pulumi.get(self, "delete_eip_on_termination")

    @delete_eip_on_termination.setter
    def delete_eip_on_termination(self, value: Optional[pulumi.Input[builtins.bool]]):
        pulumi.set(self, "delete_eip_on_termination", value)

    @property
    @pulumi.getter
    def eip1(self) -> Optional[pulumi.Input['VpnGatewayEip1Args']]:
        return pulumi.get(self, "eip1")

    @eip1.setter
    def eip1(self, value: Optional[pulumi.Input['VpnGatewayEip1Args']]):
        pulumi.set(self, "eip1", value)

    @property
    @pulumi.getter
    def eip2(self) -> Optional[pulumi.Input['VpnGatewayEip2Args']]:
        return pulumi.get(self, "eip2")

    @eip2.setter
    def eip2(self, value: Optional[pulumi.Input['VpnGatewayEip2Args']]):
        pulumi.set(self, "eip2", value)

    @property
    @pulumi.getter(name="enterpriseProjectId")
    def enterprise_project_id(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The enterprise project ID
        """
        return pulumi.get(self, "enterprise_project_id")

    @enterprise_project_id.setter
    def enterprise_project_id(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "enterprise_project_id", value)

    @property
    @pulumi.getter(name="erId")
    def er_id(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The enterprise router ID to attach with to VPN gateway.
        """
        return pulumi.get(self, "er_id")

    @er_id.setter
    def er_id(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "er_id", value)

    @property
    @pulumi.getter
    def flavor(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The flavor of the VPN gateway.
        """
        return pulumi.get(self, "flavor")

    @flavor.setter
    def flavor(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "flavor", value)

    @property
    @pulumi.getter(name="haMode")
    def ha_mode(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The HA mode of the VPN gateway.
        """
        return pulumi.get(self, "ha_mode")

    @ha_mode.setter
    def ha_mode(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "ha_mode", value)

    @property
    @pulumi.getter(name="localSubnets")
    def local_subnets(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]]:
        """
        The local subnets.
        """
        return pulumi.get(self, "local_subnets")

    @local_subnets.setter
    def local_subnets(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]]):
        pulumi.set(self, "local_subnets", value)

    @property
    @pulumi.getter(name="masterEip")
    def master_eip(self) -> Optional[pulumi.Input['VpnGatewayMasterEipArgs']]:
        return pulumi.get(self, "master_eip")

    @master_eip.setter
    def master_eip(self, value: Optional[pulumi.Input['VpnGatewayMasterEipArgs']]):
        pulumi.set(self, "master_eip", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The name of the VPN gateway. Only letters, digits, underscores(_) and hypens(-) are supported.
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter(name="networkType")
    def network_type(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The network type of the VPN gateway.
        """
        return pulumi.get(self, "network_type")

    @network_type.setter
    def network_type(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "network_type", value)

    @property
    @pulumi.getter
    def region(self) -> Optional[pulumi.Input[builtins.str]]:
        return pulumi.get(self, "region")

    @region.setter
    def region(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "region", value)

    @property
    @pulumi.getter(name="slaveEip")
    def slave_eip(self) -> Optional[pulumi.Input['VpnGatewaySlaveEipArgs']]:
        return pulumi.get(self, "slave_eip")

    @slave_eip.setter
    def slave_eip(self, value: Optional[pulumi.Input['VpnGatewaySlaveEipArgs']]):
        pulumi.set(self, "slave_eip", value)

    @property
    @pulumi.getter
    def tags(self) -> Optional[pulumi.Input[Mapping[str, pulumi.Input[builtins.str]]]]:
        return pulumi.get(self, "tags")

    @tags.setter
    def tags(self, value: Optional[pulumi.Input[Mapping[str, pulumi.Input[builtins.str]]]]):
        pulumi.set(self, "tags", value)

    @property
    @pulumi.getter(name="vpcId")
    def vpc_id(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The ID of the VPC to which the VPN gateway is connected.
        """
        return pulumi.get(self, "vpc_id")

    @vpc_id.setter
    def vpc_id(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "vpc_id", value)


@pulumi.input_type
class _VpnGatewayState:
    def __init__(__self__, *,
                 access_private_ip1: Optional[pulumi.Input[builtins.str]] = None,
                 access_private_ip2: Optional[pulumi.Input[builtins.str]] = None,
                 access_subnet_id: Optional[pulumi.Input[builtins.str]] = None,
                 access_vpc_id: Optional[pulumi.Input[builtins.str]] = None,
                 asn: Optional[pulumi.Input[builtins.int]] = None,
                 attachment_type: Optional[pulumi.Input[builtins.str]] = None,
                 availability_zones: Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]] = None,
                 certificate: Optional[pulumi.Input['VpnGatewayCertificateArgs']] = None,
                 connect_subnet: Optional[pulumi.Input[builtins.str]] = None,
                 created_at: Optional[pulumi.Input[builtins.str]] = None,
                 delete_eip_on_termination: Optional[pulumi.Input[builtins.bool]] = None,
                 eip1: Optional[pulumi.Input['VpnGatewayEip1Args']] = None,
                 eip2: Optional[pulumi.Input['VpnGatewayEip2Args']] = None,
                 enterprise_project_id: Optional[pulumi.Input[builtins.str]] = None,
                 er_attachment_id: Optional[pulumi.Input[builtins.str]] = None,
                 er_id: Optional[pulumi.Input[builtins.str]] = None,
                 flavor: Optional[pulumi.Input[builtins.str]] = None,
                 ha_mode: Optional[pulumi.Input[builtins.str]] = None,
                 local_subnets: Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]] = None,
                 master_eip: Optional[pulumi.Input['VpnGatewayMasterEipArgs']] = None,
                 name: Optional[pulumi.Input[builtins.str]] = None,
                 network_type: Optional[pulumi.Input[builtins.str]] = None,
                 region: Optional[pulumi.Input[builtins.str]] = None,
                 slave_eip: Optional[pulumi.Input['VpnGatewaySlaveEipArgs']] = None,
                 status: Optional[pulumi.Input[builtins.str]] = None,
                 tags: Optional[pulumi.Input[Mapping[str, pulumi.Input[builtins.str]]]] = None,
                 updated_at: Optional[pulumi.Input[builtins.str]] = None,
                 used_connection_group: Optional[pulumi.Input[builtins.int]] = None,
                 used_connection_number: Optional[pulumi.Input[builtins.int]] = None,
                 vpc_id: Optional[pulumi.Input[builtins.str]] = None):
        """
        Input properties used for looking up and filtering VpnGateway resources.
        :param pulumi.Input[builtins.str] access_subnet_id: The access subnet ID of the VPN gateway.
        :param pulumi.Input[builtins.str] access_vpc_id: The access VPC ID of the VPN gateway.
        :param pulumi.Input[builtins.int] asn: The ASN number of BGP
        :param pulumi.Input[builtins.str] attachment_type: The attachment type.
        :param pulumi.Input[Sequence[pulumi.Input[builtins.str]]] availability_zones: The availability zone IDs.
        :param pulumi.Input[builtins.str] connect_subnet: The Network ID of the VPC subnet used by the VPN gateway.
        :param pulumi.Input[builtins.str] created_at: The create time.
        :param pulumi.Input[builtins.bool] delete_eip_on_termination: Whether to delete the EIP when the VPN gateway is deleted.
        :param pulumi.Input[builtins.str] enterprise_project_id: The enterprise project ID
        :param pulumi.Input[builtins.str] er_attachment_id: The ER attachment ID.
        :param pulumi.Input[builtins.str] er_id: The enterprise router ID to attach with to VPN gateway.
        :param pulumi.Input[builtins.str] flavor: The flavor of the VPN gateway.
        :param pulumi.Input[builtins.str] ha_mode: The HA mode of the VPN gateway.
        :param pulumi.Input[Sequence[pulumi.Input[builtins.str]]] local_subnets: The local subnets.
        :param pulumi.Input[builtins.str] name: The name of the VPN gateway. Only letters, digits, underscores(_) and hypens(-) are supported.
        :param pulumi.Input[builtins.str] network_type: The network type of the VPN gateway.
        :param pulumi.Input[builtins.str] status: The status of VPN gateway.
        :param pulumi.Input[builtins.str] updated_at: The update time.
        :param pulumi.Input[builtins.int] used_connection_group: The number of used connection groups.
        :param pulumi.Input[builtins.int] used_connection_number: The number of used connections.
        :param pulumi.Input[builtins.str] vpc_id: The ID of the VPC to which the VPN gateway is connected.
        """
        if access_private_ip1 is not None:
            pulumi.set(__self__, "access_private_ip1", access_private_ip1)
        if access_private_ip2 is not None:
            pulumi.set(__self__, "access_private_ip2", access_private_ip2)
        if access_subnet_id is not None:
            pulumi.set(__self__, "access_subnet_id", access_subnet_id)
        if access_vpc_id is not None:
            pulumi.set(__self__, "access_vpc_id", access_vpc_id)
        if asn is not None:
            pulumi.set(__self__, "asn", asn)
        if attachment_type is not None:
            pulumi.set(__self__, "attachment_type", attachment_type)
        if availability_zones is not None:
            pulumi.set(__self__, "availability_zones", availability_zones)
        if certificate is not None:
            pulumi.set(__self__, "certificate", certificate)
        if connect_subnet is not None:
            pulumi.set(__self__, "connect_subnet", connect_subnet)
        if created_at is not None:
            pulumi.set(__self__, "created_at", created_at)
        if delete_eip_on_termination is not None:
            pulumi.set(__self__, "delete_eip_on_termination", delete_eip_on_termination)
        if eip1 is not None:
            pulumi.set(__self__, "eip1", eip1)
        if eip2 is not None:
            pulumi.set(__self__, "eip2", eip2)
        if enterprise_project_id is not None:
            pulumi.set(__self__, "enterprise_project_id", enterprise_project_id)
        if er_attachment_id is not None:
            pulumi.set(__self__, "er_attachment_id", er_attachment_id)
        if er_id is not None:
            pulumi.set(__self__, "er_id", er_id)
        if flavor is not None:
            pulumi.set(__self__, "flavor", flavor)
        if ha_mode is not None:
            pulumi.set(__self__, "ha_mode", ha_mode)
        if local_subnets is not None:
            pulumi.set(__self__, "local_subnets", local_subnets)
        if master_eip is not None:
            pulumi.set(__self__, "master_eip", master_eip)
        if name is not None:
            pulumi.set(__self__, "name", name)
        if network_type is not None:
            pulumi.set(__self__, "network_type", network_type)
        if region is not None:
            pulumi.set(__self__, "region", region)
        if slave_eip is not None:
            pulumi.set(__self__, "slave_eip", slave_eip)
        if status is not None:
            pulumi.set(__self__, "status", status)
        if tags is not None:
            pulumi.set(__self__, "tags", tags)
        if updated_at is not None:
            pulumi.set(__self__, "updated_at", updated_at)
        if used_connection_group is not None:
            pulumi.set(__self__, "used_connection_group", used_connection_group)
        if used_connection_number is not None:
            pulumi.set(__self__, "used_connection_number", used_connection_number)
        if vpc_id is not None:
            pulumi.set(__self__, "vpc_id", vpc_id)

    @property
    @pulumi.getter(name="accessPrivateIp1")
    def access_private_ip1(self) -> Optional[pulumi.Input[builtins.str]]:
        return pulumi.get(self, "access_private_ip1")

    @access_private_ip1.setter
    def access_private_ip1(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "access_private_ip1", value)

    @property
    @pulumi.getter(name="accessPrivateIp2")
    def access_private_ip2(self) -> Optional[pulumi.Input[builtins.str]]:
        return pulumi.get(self, "access_private_ip2")

    @access_private_ip2.setter
    def access_private_ip2(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "access_private_ip2", value)

    @property
    @pulumi.getter(name="accessSubnetId")
    def access_subnet_id(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The access subnet ID of the VPN gateway.
        """
        return pulumi.get(self, "access_subnet_id")

    @access_subnet_id.setter
    def access_subnet_id(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "access_subnet_id", value)

    @property
    @pulumi.getter(name="accessVpcId")
    def access_vpc_id(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The access VPC ID of the VPN gateway.
        """
        return pulumi.get(self, "access_vpc_id")

    @access_vpc_id.setter
    def access_vpc_id(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "access_vpc_id", value)

    @property
    @pulumi.getter
    def asn(self) -> Optional[pulumi.Input[builtins.int]]:
        """
        The ASN number of BGP
        """
        return pulumi.get(self, "asn")

    @asn.setter
    def asn(self, value: Optional[pulumi.Input[builtins.int]]):
        pulumi.set(self, "asn", value)

    @property
    @pulumi.getter(name="attachmentType")
    def attachment_type(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The attachment type.
        """
        return pulumi.get(self, "attachment_type")

    @attachment_type.setter
    def attachment_type(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "attachment_type", value)

    @property
    @pulumi.getter(name="availabilityZones")
    def availability_zones(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]]:
        """
        The availability zone IDs.
        """
        return pulumi.get(self, "availability_zones")

    @availability_zones.setter
    def availability_zones(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]]):
        pulumi.set(self, "availability_zones", value)

    @property
    @pulumi.getter
    def certificate(self) -> Optional[pulumi.Input['VpnGatewayCertificateArgs']]:
        return pulumi.get(self, "certificate")

    @certificate.setter
    def certificate(self, value: Optional[pulumi.Input['VpnGatewayCertificateArgs']]):
        pulumi.set(self, "certificate", value)

    @property
    @pulumi.getter(name="connectSubnet")
    def connect_subnet(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The Network ID of the VPC subnet used by the VPN gateway.
        """
        return pulumi.get(self, "connect_subnet")

    @connect_subnet.setter
    def connect_subnet(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "connect_subnet", value)

    @property
    @pulumi.getter(name="createdAt")
    def created_at(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The create time.
        """
        return pulumi.get(self, "created_at")

    @created_at.setter
    def created_at(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "created_at", value)

    @property
    @pulumi.getter(name="deleteEipOnTermination")
    def delete_eip_on_termination(self) -> Optional[pulumi.Input[builtins.bool]]:
        """
        Whether to delete the EIP when the VPN gateway is deleted.
        """
        return pulumi.get(self, "delete_eip_on_termination")

    @delete_eip_on_termination.setter
    def delete_eip_on_termination(self, value: Optional[pulumi.Input[builtins.bool]]):
        pulumi.set(self, "delete_eip_on_termination", value)

    @property
    @pulumi.getter
    def eip1(self) -> Optional[pulumi.Input['VpnGatewayEip1Args']]:
        return pulumi.get(self, "eip1")

    @eip1.setter
    def eip1(self, value: Optional[pulumi.Input['VpnGatewayEip1Args']]):
        pulumi.set(self, "eip1", value)

    @property
    @pulumi.getter
    def eip2(self) -> Optional[pulumi.Input['VpnGatewayEip2Args']]:
        return pulumi.get(self, "eip2")

    @eip2.setter
    def eip2(self, value: Optional[pulumi.Input['VpnGatewayEip2Args']]):
        pulumi.set(self, "eip2", value)

    @property
    @pulumi.getter(name="enterpriseProjectId")
    def enterprise_project_id(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The enterprise project ID
        """
        return pulumi.get(self, "enterprise_project_id")

    @enterprise_project_id.setter
    def enterprise_project_id(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "enterprise_project_id", value)

    @property
    @pulumi.getter(name="erAttachmentId")
    def er_attachment_id(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The ER attachment ID.
        """
        return pulumi.get(self, "er_attachment_id")

    @er_attachment_id.setter
    def er_attachment_id(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "er_attachment_id", value)

    @property
    @pulumi.getter(name="erId")
    def er_id(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The enterprise router ID to attach with to VPN gateway.
        """
        return pulumi.get(self, "er_id")

    @er_id.setter
    def er_id(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "er_id", value)

    @property
    @pulumi.getter
    def flavor(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The flavor of the VPN gateway.
        """
        return pulumi.get(self, "flavor")

    @flavor.setter
    def flavor(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "flavor", value)

    @property
    @pulumi.getter(name="haMode")
    def ha_mode(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The HA mode of the VPN gateway.
        """
        return pulumi.get(self, "ha_mode")

    @ha_mode.setter
    def ha_mode(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "ha_mode", value)

    @property
    @pulumi.getter(name="localSubnets")
    def local_subnets(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]]:
        """
        The local subnets.
        """
        return pulumi.get(self, "local_subnets")

    @local_subnets.setter
    def local_subnets(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]]):
        pulumi.set(self, "local_subnets", value)

    @property
    @pulumi.getter(name="masterEip")
    def master_eip(self) -> Optional[pulumi.Input['VpnGatewayMasterEipArgs']]:
        return pulumi.get(self, "master_eip")

    @master_eip.setter
    def master_eip(self, value: Optional[pulumi.Input['VpnGatewayMasterEipArgs']]):
        pulumi.set(self, "master_eip", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The name of the VPN gateway. Only letters, digits, underscores(_) and hypens(-) are supported.
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter(name="networkType")
    def network_type(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The network type of the VPN gateway.
        """
        return pulumi.get(self, "network_type")

    @network_type.setter
    def network_type(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "network_type", value)

    @property
    @pulumi.getter
    def region(self) -> Optional[pulumi.Input[builtins.str]]:
        return pulumi.get(self, "region")

    @region.setter
    def region(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "region", value)

    @property
    @pulumi.getter(name="slaveEip")
    def slave_eip(self) -> Optional[pulumi.Input['VpnGatewaySlaveEipArgs']]:
        return pulumi.get(self, "slave_eip")

    @slave_eip.setter
    def slave_eip(self, value: Optional[pulumi.Input['VpnGatewaySlaveEipArgs']]):
        pulumi.set(self, "slave_eip", value)

    @property
    @pulumi.getter
    def status(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The status of VPN gateway.
        """
        return pulumi.get(self, "status")

    @status.setter
    def status(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "status", value)

    @property
    @pulumi.getter
    def tags(self) -> Optional[pulumi.Input[Mapping[str, pulumi.Input[builtins.str]]]]:
        return pulumi.get(self, "tags")

    @tags.setter
    def tags(self, value: Optional[pulumi.Input[Mapping[str, pulumi.Input[builtins.str]]]]):
        pulumi.set(self, "tags", value)

    @property
    @pulumi.getter(name="updatedAt")
    def updated_at(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The update time.
        """
        return pulumi.get(self, "updated_at")

    @updated_at.setter
    def updated_at(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "updated_at", value)

    @property
    @pulumi.getter(name="usedConnectionGroup")
    def used_connection_group(self) -> Optional[pulumi.Input[builtins.int]]:
        """
        The number of used connection groups.
        """
        return pulumi.get(self, "used_connection_group")

    @used_connection_group.setter
    def used_connection_group(self, value: Optional[pulumi.Input[builtins.int]]):
        pulumi.set(self, "used_connection_group", value)

    @property
    @pulumi.getter(name="usedConnectionNumber")
    def used_connection_number(self) -> Optional[pulumi.Input[builtins.int]]:
        """
        The number of used connections.
        """
        return pulumi.get(self, "used_connection_number")

    @used_connection_number.setter
    def used_connection_number(self, value: Optional[pulumi.Input[builtins.int]]):
        pulumi.set(self, "used_connection_number", value)

    @property
    @pulumi.getter(name="vpcId")
    def vpc_id(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The ID of the VPC to which the VPN gateway is connected.
        """
        return pulumi.get(self, "vpc_id")

    @vpc_id.setter
    def vpc_id(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "vpc_id", value)


class VpnGateway(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 access_private_ip1: Optional[pulumi.Input[builtins.str]] = None,
                 access_private_ip2: Optional[pulumi.Input[builtins.str]] = None,
                 access_subnet_id: Optional[pulumi.Input[builtins.str]] = None,
                 access_vpc_id: Optional[pulumi.Input[builtins.str]] = None,
                 asn: Optional[pulumi.Input[builtins.int]] = None,
                 attachment_type: Optional[pulumi.Input[builtins.str]] = None,
                 availability_zones: Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]] = None,
                 certificate: Optional[pulumi.Input[Union['VpnGatewayCertificateArgs', 'VpnGatewayCertificateArgsDict']]] = None,
                 connect_subnet: Optional[pulumi.Input[builtins.str]] = None,
                 delete_eip_on_termination: Optional[pulumi.Input[builtins.bool]] = None,
                 eip1: Optional[pulumi.Input[Union['VpnGatewayEip1Args', 'VpnGatewayEip1ArgsDict']]] = None,
                 eip2: Optional[pulumi.Input[Union['VpnGatewayEip2Args', 'VpnGatewayEip2ArgsDict']]] = None,
                 enterprise_project_id: Optional[pulumi.Input[builtins.str]] = None,
                 er_id: Optional[pulumi.Input[builtins.str]] = None,
                 flavor: Optional[pulumi.Input[builtins.str]] = None,
                 ha_mode: Optional[pulumi.Input[builtins.str]] = None,
                 local_subnets: Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]] = None,
                 master_eip: Optional[pulumi.Input[Union['VpnGatewayMasterEipArgs', 'VpnGatewayMasterEipArgsDict']]] = None,
                 name: Optional[pulumi.Input[builtins.str]] = None,
                 network_type: Optional[pulumi.Input[builtins.str]] = None,
                 region: Optional[pulumi.Input[builtins.str]] = None,
                 slave_eip: Optional[pulumi.Input[Union['VpnGatewaySlaveEipArgs', 'VpnGatewaySlaveEipArgsDict']]] = None,
                 tags: Optional[pulumi.Input[Mapping[str, pulumi.Input[builtins.str]]]] = None,
                 vpc_id: Optional[pulumi.Input[builtins.str]] = None,
                 __props__=None):
        """
        Create a VpnGateway resource with the given unique name, props, and options.
        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[builtins.str] access_subnet_id: The access subnet ID of the VPN gateway.
        :param pulumi.Input[builtins.str] access_vpc_id: The access VPC ID of the VPN gateway.
        :param pulumi.Input[builtins.int] asn: The ASN number of BGP
        :param pulumi.Input[builtins.str] attachment_type: The attachment type.
        :param pulumi.Input[Sequence[pulumi.Input[builtins.str]]] availability_zones: The availability zone IDs.
        :param pulumi.Input[builtins.str] connect_subnet: The Network ID of the VPC subnet used by the VPN gateway.
        :param pulumi.Input[builtins.bool] delete_eip_on_termination: Whether to delete the EIP when the VPN gateway is deleted.
        :param pulumi.Input[builtins.str] enterprise_project_id: The enterprise project ID
        :param pulumi.Input[builtins.str] er_id: The enterprise router ID to attach with to VPN gateway.
        :param pulumi.Input[builtins.str] flavor: The flavor of the VPN gateway.
        :param pulumi.Input[builtins.str] ha_mode: The HA mode of the VPN gateway.
        :param pulumi.Input[Sequence[pulumi.Input[builtins.str]]] local_subnets: The local subnets.
        :param pulumi.Input[builtins.str] name: The name of the VPN gateway. Only letters, digits, underscores(_) and hypens(-) are supported.
        :param pulumi.Input[builtins.str] network_type: The network type of the VPN gateway.
        :param pulumi.Input[builtins.str] vpc_id: The ID of the VPC to which the VPN gateway is connected.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: VpnGatewayArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Create a VpnGateway resource with the given unique name, props, and options.
        :param str resource_name: The name of the resource.
        :param VpnGatewayArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(VpnGatewayArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 access_private_ip1: Optional[pulumi.Input[builtins.str]] = None,
                 access_private_ip2: Optional[pulumi.Input[builtins.str]] = None,
                 access_subnet_id: Optional[pulumi.Input[builtins.str]] = None,
                 access_vpc_id: Optional[pulumi.Input[builtins.str]] = None,
                 asn: Optional[pulumi.Input[builtins.int]] = None,
                 attachment_type: Optional[pulumi.Input[builtins.str]] = None,
                 availability_zones: Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]] = None,
                 certificate: Optional[pulumi.Input[Union['VpnGatewayCertificateArgs', 'VpnGatewayCertificateArgsDict']]] = None,
                 connect_subnet: Optional[pulumi.Input[builtins.str]] = None,
                 delete_eip_on_termination: Optional[pulumi.Input[builtins.bool]] = None,
                 eip1: Optional[pulumi.Input[Union['VpnGatewayEip1Args', 'VpnGatewayEip1ArgsDict']]] = None,
                 eip2: Optional[pulumi.Input[Union['VpnGatewayEip2Args', 'VpnGatewayEip2ArgsDict']]] = None,
                 enterprise_project_id: Optional[pulumi.Input[builtins.str]] = None,
                 er_id: Optional[pulumi.Input[builtins.str]] = None,
                 flavor: Optional[pulumi.Input[builtins.str]] = None,
                 ha_mode: Optional[pulumi.Input[builtins.str]] = None,
                 local_subnets: Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]] = None,
                 master_eip: Optional[pulumi.Input[Union['VpnGatewayMasterEipArgs', 'VpnGatewayMasterEipArgsDict']]] = None,
                 name: Optional[pulumi.Input[builtins.str]] = None,
                 network_type: Optional[pulumi.Input[builtins.str]] = None,
                 region: Optional[pulumi.Input[builtins.str]] = None,
                 slave_eip: Optional[pulumi.Input[Union['VpnGatewaySlaveEipArgs', 'VpnGatewaySlaveEipArgsDict']]] = None,
                 tags: Optional[pulumi.Input[Mapping[str, pulumi.Input[builtins.str]]]] = None,
                 vpc_id: Optional[pulumi.Input[builtins.str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = VpnGatewayArgs.__new__(VpnGatewayArgs)

            __props__.__dict__["access_private_ip1"] = access_private_ip1
            __props__.__dict__["access_private_ip2"] = access_private_ip2
            __props__.__dict__["access_subnet_id"] = access_subnet_id
            __props__.__dict__["access_vpc_id"] = access_vpc_id
            __props__.__dict__["asn"] = asn
            __props__.__dict__["attachment_type"] = attachment_type
            if availability_zones is None and not opts.urn:
                raise TypeError("Missing required property 'availability_zones'")
            __props__.__dict__["availability_zones"] = availability_zones
            __props__.__dict__["certificate"] = certificate
            __props__.__dict__["connect_subnet"] = connect_subnet
            __props__.__dict__["delete_eip_on_termination"] = delete_eip_on_termination
            __props__.__dict__["eip1"] = eip1
            __props__.__dict__["eip2"] = eip2
            __props__.__dict__["enterprise_project_id"] = enterprise_project_id
            __props__.__dict__["er_id"] = er_id
            __props__.__dict__["flavor"] = flavor
            __props__.__dict__["ha_mode"] = ha_mode
            __props__.__dict__["local_subnets"] = local_subnets
            __props__.__dict__["master_eip"] = master_eip
            __props__.__dict__["name"] = name
            __props__.__dict__["network_type"] = network_type
            __props__.__dict__["region"] = region
            __props__.__dict__["slave_eip"] = slave_eip
            __props__.__dict__["tags"] = tags
            __props__.__dict__["vpc_id"] = vpc_id
            __props__.__dict__["created_at"] = None
            __props__.__dict__["er_attachment_id"] = None
            __props__.__dict__["status"] = None
            __props__.__dict__["updated_at"] = None
            __props__.__dict__["used_connection_group"] = None
            __props__.__dict__["used_connection_number"] = None
        super(VpnGateway, __self__).__init__(
            'sbercloud:index/vpnGateway:VpnGateway',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            access_private_ip1: Optional[pulumi.Input[builtins.str]] = None,
            access_private_ip2: Optional[pulumi.Input[builtins.str]] = None,
            access_subnet_id: Optional[pulumi.Input[builtins.str]] = None,
            access_vpc_id: Optional[pulumi.Input[builtins.str]] = None,
            asn: Optional[pulumi.Input[builtins.int]] = None,
            attachment_type: Optional[pulumi.Input[builtins.str]] = None,
            availability_zones: Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]] = None,
            certificate: Optional[pulumi.Input[Union['VpnGatewayCertificateArgs', 'VpnGatewayCertificateArgsDict']]] = None,
            connect_subnet: Optional[pulumi.Input[builtins.str]] = None,
            created_at: Optional[pulumi.Input[builtins.str]] = None,
            delete_eip_on_termination: Optional[pulumi.Input[builtins.bool]] = None,
            eip1: Optional[pulumi.Input[Union['VpnGatewayEip1Args', 'VpnGatewayEip1ArgsDict']]] = None,
            eip2: Optional[pulumi.Input[Union['VpnGatewayEip2Args', 'VpnGatewayEip2ArgsDict']]] = None,
            enterprise_project_id: Optional[pulumi.Input[builtins.str]] = None,
            er_attachment_id: Optional[pulumi.Input[builtins.str]] = None,
            er_id: Optional[pulumi.Input[builtins.str]] = None,
            flavor: Optional[pulumi.Input[builtins.str]] = None,
            ha_mode: Optional[pulumi.Input[builtins.str]] = None,
            local_subnets: Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]] = None,
            master_eip: Optional[pulumi.Input[Union['VpnGatewayMasterEipArgs', 'VpnGatewayMasterEipArgsDict']]] = None,
            name: Optional[pulumi.Input[builtins.str]] = None,
            network_type: Optional[pulumi.Input[builtins.str]] = None,
            region: Optional[pulumi.Input[builtins.str]] = None,
            slave_eip: Optional[pulumi.Input[Union['VpnGatewaySlaveEipArgs', 'VpnGatewaySlaveEipArgsDict']]] = None,
            status: Optional[pulumi.Input[builtins.str]] = None,
            tags: Optional[pulumi.Input[Mapping[str, pulumi.Input[builtins.str]]]] = None,
            updated_at: Optional[pulumi.Input[builtins.str]] = None,
            used_connection_group: Optional[pulumi.Input[builtins.int]] = None,
            used_connection_number: Optional[pulumi.Input[builtins.int]] = None,
            vpc_id: Optional[pulumi.Input[builtins.str]] = None) -> 'VpnGateway':
        """
        Get an existing VpnGateway resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[builtins.str] access_subnet_id: The access subnet ID of the VPN gateway.
        :param pulumi.Input[builtins.str] access_vpc_id: The access VPC ID of the VPN gateway.
        :param pulumi.Input[builtins.int] asn: The ASN number of BGP
        :param pulumi.Input[builtins.str] attachment_type: The attachment type.
        :param pulumi.Input[Sequence[pulumi.Input[builtins.str]]] availability_zones: The availability zone IDs.
        :param pulumi.Input[builtins.str] connect_subnet: The Network ID of the VPC subnet used by the VPN gateway.
        :param pulumi.Input[builtins.str] created_at: The create time.
        :param pulumi.Input[builtins.bool] delete_eip_on_termination: Whether to delete the EIP when the VPN gateway is deleted.
        :param pulumi.Input[builtins.str] enterprise_project_id: The enterprise project ID
        :param pulumi.Input[builtins.str] er_attachment_id: The ER attachment ID.
        :param pulumi.Input[builtins.str] er_id: The enterprise router ID to attach with to VPN gateway.
        :param pulumi.Input[builtins.str] flavor: The flavor of the VPN gateway.
        :param pulumi.Input[builtins.str] ha_mode: The HA mode of the VPN gateway.
        :param pulumi.Input[Sequence[pulumi.Input[builtins.str]]] local_subnets: The local subnets.
        :param pulumi.Input[builtins.str] name: The name of the VPN gateway. Only letters, digits, underscores(_) and hypens(-) are supported.
        :param pulumi.Input[builtins.str] network_type: The network type of the VPN gateway.
        :param pulumi.Input[builtins.str] status: The status of VPN gateway.
        :param pulumi.Input[builtins.str] updated_at: The update time.
        :param pulumi.Input[builtins.int] used_connection_group: The number of used connection groups.
        :param pulumi.Input[builtins.int] used_connection_number: The number of used connections.
        :param pulumi.Input[builtins.str] vpc_id: The ID of the VPC to which the VPN gateway is connected.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _VpnGatewayState.__new__(_VpnGatewayState)

        __props__.__dict__["access_private_ip1"] = access_private_ip1
        __props__.__dict__["access_private_ip2"] = access_private_ip2
        __props__.__dict__["access_subnet_id"] = access_subnet_id
        __props__.__dict__["access_vpc_id"] = access_vpc_id
        __props__.__dict__["asn"] = asn
        __props__.__dict__["attachment_type"] = attachment_type
        __props__.__dict__["availability_zones"] = availability_zones
        __props__.__dict__["certificate"] = certificate
        __props__.__dict__["connect_subnet"] = connect_subnet
        __props__.__dict__["created_at"] = created_at
        __props__.__dict__["delete_eip_on_termination"] = delete_eip_on_termination
        __props__.__dict__["eip1"] = eip1
        __props__.__dict__["eip2"] = eip2
        __props__.__dict__["enterprise_project_id"] = enterprise_project_id
        __props__.__dict__["er_attachment_id"] = er_attachment_id
        __props__.__dict__["er_id"] = er_id
        __props__.__dict__["flavor"] = flavor
        __props__.__dict__["ha_mode"] = ha_mode
        __props__.__dict__["local_subnets"] = local_subnets
        __props__.__dict__["master_eip"] = master_eip
        __props__.__dict__["name"] = name
        __props__.__dict__["network_type"] = network_type
        __props__.__dict__["region"] = region
        __props__.__dict__["slave_eip"] = slave_eip
        __props__.__dict__["status"] = status
        __props__.__dict__["tags"] = tags
        __props__.__dict__["updated_at"] = updated_at
        __props__.__dict__["used_connection_group"] = used_connection_group
        __props__.__dict__["used_connection_number"] = used_connection_number
        __props__.__dict__["vpc_id"] = vpc_id
        return VpnGateway(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="accessPrivateIp1")
    def access_private_ip1(self) -> pulumi.Output[builtins.str]:
        return pulumi.get(self, "access_private_ip1")

    @property
    @pulumi.getter(name="accessPrivateIp2")
    def access_private_ip2(self) -> pulumi.Output[builtins.str]:
        return pulumi.get(self, "access_private_ip2")

    @property
    @pulumi.getter(name="accessSubnetId")
    def access_subnet_id(self) -> pulumi.Output[builtins.str]:
        """
        The access subnet ID of the VPN gateway.
        """
        return pulumi.get(self, "access_subnet_id")

    @property
    @pulumi.getter(name="accessVpcId")
    def access_vpc_id(self) -> pulumi.Output[builtins.str]:
        """
        The access VPC ID of the VPN gateway.
        """
        return pulumi.get(self, "access_vpc_id")

    @property
    @pulumi.getter
    def asn(self) -> pulumi.Output[Optional[builtins.int]]:
        """
        The ASN number of BGP
        """
        return pulumi.get(self, "asn")

    @property
    @pulumi.getter(name="attachmentType")
    def attachment_type(self) -> pulumi.Output[Optional[builtins.str]]:
        """
        The attachment type.
        """
        return pulumi.get(self, "attachment_type")

    @property
    @pulumi.getter(name="availabilityZones")
    def availability_zones(self) -> pulumi.Output[Sequence[builtins.str]]:
        """
        The availability zone IDs.
        """
        return pulumi.get(self, "availability_zones")

    @property
    @pulumi.getter
    def certificate(self) -> pulumi.Output['outputs.VpnGatewayCertificate']:
        return pulumi.get(self, "certificate")

    @property
    @pulumi.getter(name="connectSubnet")
    def connect_subnet(self) -> pulumi.Output[builtins.str]:
        """
        The Network ID of the VPC subnet used by the VPN gateway.
        """
        return pulumi.get(self, "connect_subnet")

    @property
    @pulumi.getter(name="createdAt")
    def created_at(self) -> pulumi.Output[builtins.str]:
        """
        The create time.
        """
        return pulumi.get(self, "created_at")

    @property
    @pulumi.getter(name="deleteEipOnTermination")
    def delete_eip_on_termination(self) -> pulumi.Output[Optional[builtins.bool]]:
        """
        Whether to delete the EIP when the VPN gateway is deleted.
        """
        return pulumi.get(self, "delete_eip_on_termination")

    @property
    @pulumi.getter
    def eip1(self) -> pulumi.Output['outputs.VpnGatewayEip1']:
        return pulumi.get(self, "eip1")

    @property
    @pulumi.getter
    def eip2(self) -> pulumi.Output['outputs.VpnGatewayEip2']:
        return pulumi.get(self, "eip2")

    @property
    @pulumi.getter(name="enterpriseProjectId")
    def enterprise_project_id(self) -> pulumi.Output[builtins.str]:
        """
        The enterprise project ID
        """
        return pulumi.get(self, "enterprise_project_id")

    @property
    @pulumi.getter(name="erAttachmentId")
    def er_attachment_id(self) -> pulumi.Output[builtins.str]:
        """
        The ER attachment ID.
        """
        return pulumi.get(self, "er_attachment_id")

    @property
    @pulumi.getter(name="erId")
    def er_id(self) -> pulumi.Output[builtins.str]:
        """
        The enterprise router ID to attach with to VPN gateway.
        """
        return pulumi.get(self, "er_id")

    @property
    @pulumi.getter
    def flavor(self) -> pulumi.Output[builtins.str]:
        """
        The flavor of the VPN gateway.
        """
        return pulumi.get(self, "flavor")

    @property
    @pulumi.getter(name="haMode")
    def ha_mode(self) -> pulumi.Output[builtins.str]:
        """
        The HA mode of the VPN gateway.
        """
        return pulumi.get(self, "ha_mode")

    @property
    @pulumi.getter(name="localSubnets")
    def local_subnets(self) -> pulumi.Output[Sequence[builtins.str]]:
        """
        The local subnets.
        """
        return pulumi.get(self, "local_subnets")

    @property
    @pulumi.getter(name="masterEip")
    def master_eip(self) -> pulumi.Output['outputs.VpnGatewayMasterEip']:
        return pulumi.get(self, "master_eip")

    @property
    @pulumi.getter
    def name(self) -> pulumi.Output[builtins.str]:
        """
        The name of the VPN gateway. Only letters, digits, underscores(_) and hypens(-) are supported.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="networkType")
    def network_type(self) -> pulumi.Output[builtins.str]:
        """
        The network type of the VPN gateway.
        """
        return pulumi.get(self, "network_type")

    @property
    @pulumi.getter
    def region(self) -> pulumi.Output[builtins.str]:
        return pulumi.get(self, "region")

    @property
    @pulumi.getter(name="slaveEip")
    def slave_eip(self) -> pulumi.Output['outputs.VpnGatewaySlaveEip']:
        return pulumi.get(self, "slave_eip")

    @property
    @pulumi.getter
    def status(self) -> pulumi.Output[builtins.str]:
        """
        The status of VPN gateway.
        """
        return pulumi.get(self, "status")

    @property
    @pulumi.getter
    def tags(self) -> pulumi.Output[Optional[Mapping[str, builtins.str]]]:
        return pulumi.get(self, "tags")

    @property
    @pulumi.getter(name="updatedAt")
    def updated_at(self) -> pulumi.Output[builtins.str]:
        """
        The update time.
        """
        return pulumi.get(self, "updated_at")

    @property
    @pulumi.getter(name="usedConnectionGroup")
    def used_connection_group(self) -> pulumi.Output[builtins.int]:
        """
        The number of used connection groups.
        """
        return pulumi.get(self, "used_connection_group")

    @property
    @pulumi.getter(name="usedConnectionNumber")
    def used_connection_number(self) -> pulumi.Output[builtins.int]:
        """
        The number of used connections.
        """
        return pulumi.get(self, "used_connection_number")

    @property
    @pulumi.getter(name="vpcId")
    def vpc_id(self) -> pulumi.Output[builtins.str]:
        """
        The ID of the VPC to which the VPN gateway is connected.
        """
        return pulumi.get(self, "vpc_id")

